2006-05-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.27 "fiddleheads" is released.

2006-05-10  Jerry James  <james@xemacs.org>

	* x-font-menu.el (x-font-menu-font-data): Always pass a device as
	the 4th argument to x-font-menu-font-data-xft.

2006-04-29  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/ethio-util.el (ethio-fidel-to-java-buffer):
	"\u" -> "\\u" as it should have been in the first place. 
	
2006-04-29  Aidan Kehoe  <kehoea@parhasard.net>

	* dumped-lisp.el (preloaded-file-list):
	Move loadhist earlier in the preloaded-file list. 
	* help.el:
	* help.el (help-mode-map): Add bindings to find the source code of
	a function, notably when that function's in C. 
	* help.el (describe-function-find-file, describe-symbol-find-file):
	Removed. Use symbol-file from loadhist.el instead. 
	* help.el (frob-help-extents):
	* help.el (describe-function-1):
	Allow built-in function file names to be hyperlinks. 
	* help.el (describe-variable):
	* help.el (help-find-source-or-scroll-up): New.
	* help.el (help-mouse-find-source-or-track): New.
	Make describe-function a bit more mouse-friendly, basically. 
	* loadhist.el (symbol-file):
	Support looking up builtin symbols using built-in-symbol-file. 
	
2006-04-23  Ville Skyttä  <scop@xemacs.org>

	* simple.el (goto-line): Add optional `buffer' argument, from
	GNU Emacs CVS.
	(next-line-add-newlines): Remove obsolete comments from the docs.

2006-04-25  Stephen J. Turnbull  <stephen@xemacs.org>

	Repair busted commit and gratuitous doc improvements.

	* startup.el (command-line-do-help): Document options for forcing
	initial from on a given window-system.

	* faces.el (Face-frob-property): Give informative error if device
	type has no mapper function.

	* x-font-menu.el (x-font-menu-font-data-xft):
	* x-faces.el (globally-declare-fboundp):
	Eliminate references to `fc-font-real-pattern'.

	* fontconfig.el (section header comments):
	* x-init.el (x-init-toolbar-from-resources):
	Improve comments.

2006-04-23  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el (push):
	* cl.el (pushnew):
	Take on board Stephen's criticism of my last changes to the CL
	docstrings.
	
2006-04-24  Stephen J. Turnbull  <stephen@xemacs.org>

	* dumped-lisp.el (fontconfig): Load only with Xft.

	* x-faces.el (fontconfig): Require only with Xft.

2006-04-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* font-mgr.el: New file.  Provides Lisp emulation of fontconfig.

	* fontconfig.el: Require 'font-mgr.

2006-04-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* fontconfig.el:
	Add some comments on proposed generic APIs.
	Remove some unused and probably broken code.
	Use `fc-define-property' to define new X11 XLFD standard
	properties: x11-swidth, x11-adstyle, x11-resx, x11-resy,
	x11-registry, and x11-encoding.
	Delete fc-font-name-property-PROPERTY constants.
	(fc-define-property):
	Add `fc-pattern-del-PROPERTY'.

	* x-faces.el (x-make-font-bold-xft):
	(x-make-font-unbold-xft):
	(x-make-font-italic-xft):
	(x-make-font-unitalic-xft):
	(x-find-xft-font-of-size): 
	* x-font-menu.el (x-font-menu-load-font-xft):
	Use property-specific APIs instead of defconsts for property names.

2006-04-16  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el (incf):
	* cl.el (decf):
	* cl.el (pop):
	* cl.el (push):
	* cl.el (pushnew):
	Docstring clarifications; drop non-standard formatting for incf,
	decf, pop, move to GNU's parameter names for push, pushnew since
	they make it much easier to remember the right order.  
	
2006-04-15  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (read-quoted-char): Use unicode-to-char instead of
	int-to-char for converting code points to characters; document
	this usage. This is compatible with previously documented
	behaviour, since the mapping from number to character was only
	stable and well-defined for ISO-8859-1. Thank you Pete Forman!

	Document some help subsystem incompatibility with GNU that seems
	to have been ignored during the last sync.

2006-03-31  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.26 "endive" is released.

2006-03-31  Marcus Crestani  <marcus.crestani@ub.uni-tuebingen.de>

	* diagnose.el (show-mc-alloc-memory-usage): Rename buffer to
	"mc-alloc memory usage" to avoid name clash with
	show-memory-usage.

2006-03-26  Marcus Crestani  <crestani@xemacs.org>

	* diagnose.el (show-gc-stats): Adjust format string, remove
	explicitly-freed statistics (the need to explicitly free went away
	with the asynchronous finalization patch).

2006-03-20  Malcolm Purvis  <malcolmp@xemacs.org>

	* next-error.el: Rename functions that clash with the next-error
	family in compile.el
	* occur.el (occur-next-error): Use new names
	* occur.el (multi-occur): Fix compiler warnings.

2006-03-15  Jerry James  <james@xemacs.org>

	* newcomment.el (uncomment-region): Remove old code that breaks
	uncomment-region on C files.  Thanks to Christian Podlasly for the
	report.

2006-03-15  Jerry James  <james@xemacs.org>

	* register.el (describe-register-1): Use set-text-properties
	instead of the nonexistent remove-list-of-text-properties.

2006-03-14  Jerry James  <james@xemacs.org>

	* wid-edit.el (widget-move-and-invoke): New function, used by Gnus.

2006-02-26  Vin Shelton  <acs@xemacs.org>

	* setup-paths.el (paths-emacs-data-root-p): Add search for package
	root.
	(paths-find-invocation-roots): Add root-p parameter to test
	plausibility of the roots.

2006-03-12  Marcus Crestani  <crestani@xemacs.org>

	* diagnose.el (show-memory-usage): Fix regexp.

2006-02-26  Mike Sperber  <mike@xemacs.org>

	* lisp-mode.el (lisp-send-defun): Remove this function; the
	definition here didn't do anything---once upon a time, it may have
	gotten overwritten by some code that has evaporated since then.

2006-02-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.25 "eggplant" is released.

2006-02-05  Aidan Kehoe  <kehoea@parhasard.net>

	* easymenu.el: Update copyright. 
	* easymenu.el (easy-menu-all-popups):
	Add a docstring. 
	* easymenu.el (easy-menu-add):
	Document a bug, rework the function to preserve any existing
	non-default mode-popup-menu instead of overwriting it, and not to
	bother normalising the menu title (nothing else does).
	* easymenu.el (easy-menu-remove):
	Restore the default mode-popup-menu instead of leaving an empty
	one when we remove the last easy-menu popup. 

2004-01-19  Martin Buchholz  <martin@xemacs.org>

	* font-lock.el: Add support for not-so recent changes in Java to
	java-mode.

2006-01-08  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (read-quoted-char):
	Eliminate some char/event confusion introduced by a GNU Emacs
	sync.
	
2006-01-06  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-download-sites): Add pt.xemacs.org,
	as suggested by Rodrigo Ventura.
	* package-get.el (package-get-pre-release-download-sites): Ditto,
	with replacement of xemacs-21.5 by beta, which is the logical path
	to our beta core and package pre-releases.

2005-12-30  Mike Sperber  <mike@xemacs.org>

	* packages.el (packages-find-all-package-hierarchies): Interpret
	EMACSPACKAGEPATH as listing package direcories, not hierarchies.
	This fixes a regression introduced in the change on 2005-01-08.

2005-11-25  Mike Sperber  <mike@xemacs.org>

	* packages.el (packages-find-package-hierarchies-named): Use
	`file-name-as-directory' to normalize something which may not
	have a trailing path separator.

	* package-get.el (package-get-package-index-file-location): Fix
	essentially bogus definition.

	* package-admin.el (package-admin-find-top-directory): Use the
	existing variables rather than groking the paths from scratch, and
	greatly simplify.

	* packages.el (packages-find-all-package-hierarchies): 
	Take into account `configure-early-package-hierarchies',
	`configure-late-package-hierarchies',
	`configure-last-package-hierarchies', as set by configure.

2005-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/chinese.el:
	* mule/chinese.el ('euc-china): Removed. Shouldn't have been
	uncommented in the first place. 

2005-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-cmds.el (set-language-environment-coding-systems):
	* mule/mule-cmds.el (init-locale-at-early-startup):
	Call set-current-locale (the wrapper for setlocale(3)) before
	checking the current locale, because the C code doesn't. 
	
2005-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/chinese.el:
	Make euc-cn available as a coding system alias for cn-gb-2312, for
	the sake of consistency with euc-jp, euc-ko and the FSF. 
	
2005-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* x-win-sun.el (x-win-init-sun):
	* x-win-xfree86.el (x-win-init-xfree86):
	Initialise the hardware-specific mapping from raw keycodes to the 
	US key layout. 

2005-12-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* buff-menu.el (Buffer-menu-rename): New command.
	(Buffer-menu-mode-map): Bind it to ?r.

2005-12-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.24 "dandelion" is released.

2005-12-17  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-cmds.el (set-language-environment-coding-systems):
	Initialise keyboard-coding-system, terminal-coding-system when
	applying a language environment, together with the input and
	output coding systems for any active TTY console. 
	* mule/mule-cmds.el (init-locale-at-early-startup):
	If set-current-locale returns a `more-specified version' of the
	current locale when passed a zero length argument, the magic used
	to work out the current language environment from the C locale
	will fail. Call current-locale instead. 

2005-12-17  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-download-sites): Add Hong Kong
	download site.
	* package-get.el (package-get-pre-release-download-sites): Ditto.

2005-12-10  Malcolm Purvis  <malcolmp@xemacs.org>

	* about.el (about-personal-info, about-hacker-contribution):
	Update `malcolmp'.

2005-12-03  Ville Skyttä  <scop@xemacs.org>

	* x-faces.el (x-library-search-path): Add /usr(/local)/share/X11.
	* font.el (font-lookup-rgb-components): Ditto, remove stale comment.

2005-10-28  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-download-sites): Update reflecting
	latest http://www.xemacs.org/Releases/ information generated by
	xemacs-builds/adrian/website/package-get-2-download-sites.el.
	* package-get.el (package-get-pre-release-download-sites): Ditto.

2005-11-29  Malcolm Purvis  <malcolmp@xemacs.org>

	* occur.el: Add autoload cookie for list-matching-lines.

2005-11-29  Stephen J. Turnbull  <stephen@xemacs.org>

	* objects.el (make-font-specifier): Document font name syntaxes.

2005-11-29  Stephen J. Turnbull  <stephen@xemacs.org>

	* about.el (about-personal-info, about-url-alist): Update `jerry'.

2005-11-26  Stephen J. Turnbull  <stephen@xemacs.org>

	Merge Xft.

    2005-09-07  Clemens Fruhwirth  <clemens@endorphin.org>

	* font.el (font-default-font-for-device): Remove vestigial code
	from incomplete removal of conditional.

    2005-08-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* fontconfig.el (fc-try-font): Improve docstring, add todo comment.
	(make-fc-pattern): Use defalias, not defun.

    2005-08-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* fontconfig.el (make-fc-pattern): Don't add finalizer, now
	finalizer is in lrecord implementation.

    2005-08-02  Stephen J. Turnbull  <stephen@xemacs.org>

	`fc-list-fonts-pattern-objects' now returns a LISP list.

	* fontconfig.el (fc-try-font):
	(fc-find-available-font-families):
	(fc-find-available-weights-for-family):
	Adapt to it.

	(fc-try-font): Return list of pattern objects.

	(fc-fontset-list): Remove.

    2005-03-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* font.el (font-running-xemacs): Remove definition.
	(font-x-font-regexp):
	(font-x-registry-and-encoding-regexp):
	(font-default-font-for-device):
	(x-font-create-name-core):
	(mswindows-font-create-name):
	(font-set-face-font):
	(font-blink-callback):
	Remove references.

	(define-font-keywords): Remove definition and top-level references.

	(set-font-style-by-keywords):
	(font-properties-from-style):
	Comment out.

    2005-03-01  Aidan Kehoe  <kehoea@parhasard.net>

	General cleanup of references to functions Eric has deleted 
	and renamed in the C core. 
	* font.el (x-font-create-object): 
	  xft-xlfd-font-name-p -> xlfd-font-name-p
	* font.el (x-font-create-object-xft):
	xft-pattern-* -> fc-pattern-*, return the created font. 
	* font.el (x-font-create-name-xft):
	xft* -> fc*
	* fontconfig.el (fc-font-name-weight-regular): New.
	* fontconfig.el (fc-font-name-weight-mapping):
	* fontconfig.el (fc-font-name-weight-mapping-string):
	* fontconfig.el (fc-font-name-weight-mapping-string-reverse):
	* fontconfig.el (fc-font-name-weight-mapping-reverse):
	* fontconfig.el (fc-font-weight-translate-from-symbol):
	Add information on the "regular" font weight, taken from
	fontconfig.h, which is the weight my local system returns by
	default.
	
    2005-02-03  Eric Knauel  <eric@xemacs.org>

	* fontconfig.el (fc-try-font): 
	(fc-find-available-font-families): 
	(fc-find-available-weights-for-family): adapt to new representation of
	FcObjectSets

    2004-11-20  Stephen J. Turnbull  <stephen@xemacs.org>

	Xft branch based on "Xft reloaded #3" patch by Eric Knauel and
	Mathias Neuebaur, and other contributors.

	* fontconfig.el: New file implementing fontconfig interfaces.

	* font.el:
	* face.el:
	Use fontconfig to access Xft fonts.

2005-11-21  Marcus Crestani  <crestani@xemacs.org>

	Incremental Garbage Collector

	* cus-start.el (all): Add allow-incremental-gc,
	gc-cons-incremental-threshold, and
	gc-incremental-traversal-threshold to alloc customization group.
	* diagnose.el (show-memory-usage): Additionally allocated memory
	no longer in use, remove.
	* diagnose.el (show-lrecord-stats): Additionally allocated memory
	no longer in use, remove.
	* diagnose.el (show-gc-stats): New.

2005-11-08  Malcolm Purvis  <malcolmp@xemacs.org>

	* help.el:
	* menubar-items.el (default-menubar):
	 Add 'Known Problems' to the Help menu.

2005-11-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* select.el (get-selection):
	Quiet bytecompiler (unused condition-case variable).

2005-11-13  Ben Wing  <ben@xemacs.org>

	* syntax.el:
	* syntax.el (describe-syntax-table): Removed.
	* syntax.el (describe-char-table): New.
	Convert describe-syntax-table to more general describe-char-table.
	(Will also be used by display tables.) Create new describe-syntax-table,
	compatible with old function, that uses describe-char-table.

2005-11-13  Ben Wing  <ben@xemacs.org>

	* diagnose.el (show-memory-usage):
	Conditionalize `sort-numeric-fields' on when-fboundp.

2005-11-13  Ben Wing  <ben@xemacs.org>

	* help.el (function-arglist):
	Don't bomb out when fun has no documentation.

2005-11-13  Ben Wing  <ben@xemacs.org>

	* simple.el (log-warning-minimum-level):
	* simple.el (display-warning-minimum-level):
	`foo.' -> `foo'.
	* simple.el (debug-print-1):
	princ() a formatted debug string, not prin1(), or it just looks stupid.

2005-11-13  Ben Wing  <ben@xemacs.org>

	* derived.el:
	* frame.el (get-frame-for-buffer):
	* toolbar.el (press-toolbar-button):
	* toolbar.el (release-and-activate-toolbar-button):
	* glyphs.el:
	* glyphs.el (set-glyph-property):
	* glyphs.el (set-glyph-image):
	* glyphs.el (set-glyph-contrib-p):
	* glyphs.el (set-glyph-baseline):
	* hyper-apropos.el (hyper-apropos-map):
	* mouse.el (mouse-track-down-hook):
	* files.el (file-name-extension):
	* specifier.el:
	* specifier.el (map-specifier):
	* specifier.el (set-specifier):
	Fix uses of `foo'; change 'foo -> `foo', and put punctuation outside
	of quotes.

	Add comments in specifier.el about needing better and new convenience
	functions.

2005-11-02  Marcus Crestani  <crestani@xemacs.org>

	* diagnose.el: Rename `show-lrecord-stats' to
	`show-object-memory-usage-stats', to keep in sync with the C
	sources.

2005-10-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.23 "daikon" is released.

2005-10-25  Ben Wing  <ben@xemacs.org>

	* cus-face.el:
	* cus-face.el (custom-face-attributes):
	* cus-face.el (custom-face-background-pixmap):
	* cus-face.el (custom-set-face-inherit): New.
	* cus-face.el (custom-face-inherit): New.
	* faces.el:
	* faces.el (face-property):
	* faces.el (convert-face-property-into-specifier):
	* faces.el (face-property-instance):
	* faces.el (set-face-property):
	* faces.el (reset-face):
	* faces.el (set-face-parent):
	* faces.el (face-font-name):
	* faces.el (face-font):
	* faces.el (face-font-instance):
	* faces.el (set-face-font):
	* faces.el (face-foreground):
	* faces.el (face-foreground-instance):
	* faces.el (set-face-foreground):
	* faces.el (face-background):
	* faces.el (face-background-instance):
	* faces.el (set-face-background):
	* faces.el (face-background-pixmap):
	* faces.el (face-background-pixmap-instance):
	* faces.el (set-face-background-pixmap):
	* faces.el (face-display-table):
	* faces.el (face-display-table-instance):
	* faces.el (face-equal):
	* faces.el (init-face-from-resources):
	Provide a basic implementation of the `inherit' property for
	faces and the :inherit property in custom.  Use the new
	`specifier-instantiator' function.

	Update the documentation for various places in faces.el.

	'foo -> `foo'.

2005-10-25  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-download-sites): Fixes after
	checklink and linklint testing.
	* package-get.el (package-get-pre-release-download-sites): Ditto.

2005-10-24  Ben Wing  <ben@xemacs.org>

	* next-error.el (compilation-current-error):
	* next-error.el (compilation-current-error)): New.
	* next-error.el (compilation-context-lines)): New.
	* occur.el (occur-accumulate-lines):
	* occur.el (multi-occur):
	Fix some byte-compile warnings.

2005-10-23  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-download-sites): Sync packages
	mirrors list with website, based on Ville's work.
	* package-get.el (package-get-pre-release-download-sites): Sync
	with `package-get-download-sites'.

2005-10-18  Ville Skyttä  <scop@xemacs.org>

	* package-get.el (package-get-download-sites): Sync mirrors list
	with the XEmacs website.
	(package-get-pre-release-download-sites): Ditto.

2005-10-21  Stephen J. Turnbull  <stephen@xemacs.org>

	UNDO:
	* mule/canna-leim.el: Rename canna_api to canna-api.

2005-10-21  Stephen J. Turnbull  <stephen@xemacs.org>

	* build-report.el: Note synch to XEmacs build package version 1.49.

2005-10-04  Stephen J. Turnbull  <stephen@xemacs.org> 

	* build-report.el (build-report): Refactor into interactive
	portion and `build-report-create-report'.
	(build-report-create-report): New function.
	(batch-build-report): Non-interactive version of `build-report'
	using `build-report-create-report'.

2005-10-10  Malcolm Purvis  <malcolmp@xemacs.org>

	* minibuf.el:
	* minibuf.el (read-buffer): Follow GNU Emacs behaviour: Can return
	empty string if require-match is t and default is nil.
	* replace.el: Moved occur code to occur.el
	* simple.el:
	* simple.el (line-number-at-pos): New.
	* subr.el:
	* subr.el (delete-dups): New.
	* occur.el: New.  Sync with 22.0.50.1 (CVS)
	* next-error.el: New.  Sync with 22.0.50.1 (CVS)

2005-10-10  Steve Youngs  <steve@sxemacs.org>

	* help.el (view-emacs-news): Use `expand-file-name' instead of
	`locate-data-file' as the latter will find any "NEWS" files that
	might exist in packages _before_ the one in core.

2005-10-09  Adrian Aichner  <adrian@xemacs.org>

	* finder.el (finder-find-library): Return filename actually
	searched for.

2005-10-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* simple.el (xemacs-default-composefunc): Don't warn when batch.

2005-10-04  Stephen J. Turnbull  <stephen@xemacs.org> 

	* build-report.el: Synch to Adrian's packaged version.

2005-10-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/canna-leim.el: Rename canna_api to canna-api.

2005-09-30  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/canna-leim.el (canna-activate): Fix typo in error symbol.
	Improve docstring.

2005-09-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/canna-leim.el: Add comment on autoloading strategy.
	(canna-activate): Handle CANNA in ELL.

	* dumped-lisp.el (preloaded-file-list): Remove dependency of
	canna-leim on CANNA.  Canna may be an ELL.

2005-09-21  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/mule-cmds.el (input-method-alist, register-input-method):
	Improve docstrings and formal parameter names.

2005-09-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.22 "cucumber" is released.

2005-08-06  Mike Sperber  <mike@xemacs.org>

	* window-xemacs.el (really-set-window-configuration): Only set
	the frame top and left if they've changed.

2005-08-04  Mike Sperber  <mike@xemacs.org>

	* window-xemacs.el (window-configuration-equal): Compare frame top
	and left via `equal' rather than '=', as it can be nil.

2005-07-24  Fabrice Popineau <Fabrice.Popineau@supelec.fr>

	* window-xemacs.el (really-set-window-configuration): 
	* window-xemacs.el (current-window-configuration): 
	* window-xemacs.el (window-configuration-equal): 
	* window-xemacs.el (window-configuration): Add `frame-top' and
	`frame-left' field to windows configurations, and save and restore
	them.

2005-06-26  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (read-quoted-char):
	* isearch-mode.el (isearch-char-to-string):
	Remove the fourth argument from event-to-character. 
	
	* dumped-lisp.el (preloaded-file-list):
	No longer dump x-iso8859-1.el--we don't need it any more. 

	* x-init.el (x-initialize-keyboard):
	* keymap.el (events-to-keys):	
	* events.el:
	Rename the ascii-character keysym property to character-of-keysym. 

	* gtk-compose.el:
	Don't depend on gtk-iso8859-1.el

	* x-compose.el:
	Move to using character literals rather than X11 keysyms as macro
	expansions. Loses the ability to use another character encoding
	for the Latin-1 characters in X11 composition with a bit of
	programming, which no-one uses; also happily reduces dependence on
	x-iso8859-1.el, which is no longer of use.

2005-06-06  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-init-package):
	package-get-init-package buglet (21.4.17) by Jeff Mincy
	<mincy@rcn.com> fixing false temporary load-path shadows reported
	after package installation and simplifying code.

2005-05-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.21 "corn" is released.

2005-05-15  Marcus Crestani  <crestani@xemacs.org>

	* diagnose.el: Lrecord and string data statistics.
	* diagnose.el (show-memory-usage): Add output for additional
	lrecord statistics (currently only string data).
	* diagnose.el (show-lrecord-stats): New. Print detailed lrecord
	statistics.

2005-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* menubar-items.el (default-menubar):
	* simple.el:
	* simple.el (mail-user-agent):
	* simple.el (vm-user-agent):
	* simple.el ('vm-user-agent): New.
	* simple.el (xemacs-default-composefunc): New.
	* simple.el (xemacs-default-sendfunc): New.
	* simple.el ('xemacs-default-mail-user-agent): New.
        Update the docstring for mail-user-agent to mention VM; default to 
        sendmail-user-agent, but on first use, give a huge warning that it 
        is underfeatured and not likely to get better in the medium term, 
        and the user should choose another mail client. 
	
2005-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* x-init.el (x-initialize-keyboard): Give info about any unbound
	Unicode keysyms. 

2005-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/european.el:
	* mule/latin.el:
	Add full syntax table and case mapping information for
	iso-8859-14, iso-8859-15, iso-8859-16. 
	
2005-05-05  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-ccl.el (define-ccl-program): Spelling and grammar fix
	in docstring. 

2005-05-05  Aidan Kehoe  <kehoea@parhasard.net>

	* map-ynp.el: Grammar fix in comment. 

2005-05-05  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (command-line): Call font-lock-set-defaults to make
	the user's choice of fontification take effect in *scratch*. 

2005-04-12  Mike Sperber  <mike@xemacs.org>

	* minibuf.el (get-user-response): Move here from dialog.el so it
	works even when dialogs are not available.
	* dialog.el: See above.

2005-04-01  Marcus Crestani  <crestani@xemacs.org>

	The new allocator.

	MEMORY_USAGE_STATS

	* diagnose.el: Add new lisp function to pretty print statistics
	about the new allocator.
	* diagnose.el (show-mc-alloc-memory-usage): New.

2005-04-08  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (find-file): Honour the coding system argument even in
	the case where we're creating a new file. 

2005-04-04  Steve Youngs  <steve@sxemacs.org>

	* files.el (backup-buffer): Write "%backup%~" in
	`auto-save-directory' and fall back to $HOME if for some reason
	that isn't possible.
	Suggested By: Jamie Zawinski <jwz@jwz.org>

2005-03-31  Aidan Kehoe  <kehoea@parhasard.net>

	* faces.el (face-complain-about-font):
	* x-faces.el:
	The warnings when there wasn't a bold or italic version of a given
	font available still specified "Emacs" as the X11 resource
	class. Change this to "XEmacs."
	
2005-03-29  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (command-line): Move Mule initialisation before
	window-system initialisation, because the latter depends on
	Unicode support with X11 and Unicode keysyms. 

2005-03-28  Aidan Kehoe  <kehoea@parhasard.net>

	* register.el (insert-register): Revert part of Ben's incomplete
	sync of 2005-01-26--we don't have insert-for-yank. 

2005-03-25  Ralf Angeli  <angeli@iwi.uni-sb.de> 

	* easymenu.el (easy-menu-remove): As described in 
	E1D4Nn5-0001lq-EU@neutrino.iwi.uni-sb.de; don't strip everything
	except the "Command" menu from mode-popup-menu. 

2005-03-25  Ralf Angeli  <angeli@iwi.uni-sb.de> 
 
        * font.el (font-spatial-to-canonical): Correct calculation of 
        return value for pixel-based input value. 
 
2005-03-17  Mike Sperber  <mike@xemacs.org>

	* files.el: Merge the following changes from GNU Emacs:

	2005-01-04  Andreas Schwab  <schwab@suse.de>
	
		* files.el (insert-directory): Only look for error lines in
		inserted text.  Don't move too far after processing --dired markers.
	
	2004-12-27  Richard M. Stallman  <rms@gnu.org>
	
		* files.el (insert-directory-ls-version): New variable.
		(insert-directory): When ls returns an error, test the version
		number to decide what the return code means.
		With --dired output format, detect and distinguish lines
		that are really error messages.
		(insert-directory-adj-pos): New function.
	
	2004-09-25  Stefan Monnier  <monnier@iro.umontreal.ca>
	
		* files.el (insert-directory): Obey --dired even with symlinks.
	
	2004-05-25  Luc Teirlinck  <teirllm@auburn.edu>
	
		(insert-directory): Check that lines were really inserted by
		the --dired switch, before erasing them.
	
	2004-04-17  Richard M. Stallman  <rms@gnu.org>
	
		* files.el (insert-directory): Delete any error msg output by the
		`insert-directory-program'.
	
2005-03-12  Fabrice Popineau <Fabrice.Popineau@supelec.fr> 

	* select.el (get-selection): As described in
	u0nj9nvq.fsf@esemetz.metz.supelec.fr , get-selection-internal
	returns nil instead of signalling a selection-conversion
	error on win32. Also, Aidan had a logic error while traversing a
	list. 

2005-03-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.20 "cilantro" is released.

2005-03-04  Aidan Kehoe  <kehoea@parhasard.net>

	* unicode.el (decode-char): New. This is what the FSF Mule API
	calls unicode-to-char. The API of the function is more general,
	but support for anything beyond Unicode isn't implemented, and I
	can't see why it would be, given that make-char does a fine job
	already.
	* unicode.el (encode-char): New. This is what the FSF Mule calls
	char-to-unicode.

2005-02-28  Simon Josefsson  <jas@extundo.com>

	* about.el (xemacs-hackers): Add jas.
	(about-other-current-hackers): Likewise.
	(about-url-alist): Add URL for jas.
	(about-personal-info): Document jas.
	(about-hacker-contribution): Describe jas contributions.

2005-02-28  Aidan Kehoe  <kehoea@parhasard.net>

	* select.el (selected-text-type): Removed.
	* select.el (selection-preferred-types): New.
	* select.el ('selected-text-type): New.
	Rename selected-text-type to selection-preferred-types, now that
	it's full of image types as fallbacks. Define an alias to the old
	name. 
	* select.el (kill-primary-selection): deleted -> delete

	* select.el (get-selection-no-error):
	* select.el (get-selection):
	* select.el (get-selection-foreign):
	Reference selection-preferred-types instead of giving details of
	which types these functions default to wanting. 
	
	* select.el (select-make-extent-for-selection): Comment that we
	need to hook something similar into the rectangle functions. 

	* select.el (select-convert-in):
	If we don't have a handler for an X11 selection, pass the value
	itself as a string. Fixes X11 atoms.
	
	* select.el (select-convert-to-timestamp): New.
	Uses get-xemacs-selection-timestamp. 

	* select.el (select-convert-to-utf-8-text): New.
	* select.el (select-convert-from-text): Removed.
	The change in select-convert-in makes this irrelevant.
	
	* select.el (select-convert-from-length): Removed.
	We have a more generic integer conversion routine here. 

	* select.el (select-convert-from-filename): Removed.
	The generic string conversion handles this. 

	* select.el (select-convert-from-ip-address): New.
	Whee. 
	
	* select.el (select-convert-from-utf-8-text): New.
	* select.el (select-convert-from-utf-16-le-text): New.
	The various Mozilla-specific types need the utf-16 conversion;
	utf-8 conversion is _in_ this season, didn't you know?

	* select.el (select-convert-from-image-data): New.
	Generic convert-an-image-to-a-space-with-end-glyph function. Used
	by the next six functions. 

	* select.el (select-convert-from-image/gif): New.
	* select.el (select-convert-from-image/jpeg): New.
	* select.el (select-convert-from-image/png): New.
	* select.el (select-convert-from-image/tiff): New.
	* select.el (select-convert-from-image/xpm): New.
	* select.el (select-convert-from-image/xbm): New.
	Check if we have support for a given image format; if so, pass
	back a space with the corresponding selection's image attached as
	glyph data. 

	* select.el (select-convert-from-cf-unicodetext):
	* select.el (select-convert-to-cf-text):
	* select.el (select-convert-to-cf-unicodetext):
	Check that the corresponding Windows coding systems are available
	before trying to convert. 
	
	* select.el (selection-converter-out-alist):
	* select.el (selection-converter-in-alist):
	Update both lists to reflect the other changes in the file. 
	
	* x-select.el (x-selected-text-type):
	Update the define-obsolete-variable-alias now selected-text-type
	is called something else. 
	
2005-02-25  Adrian Aichner  <adrian@xemacs.org>

	* diagnose.el: Fix typo.
	* diagnose.el (show-memory-usage): Sort sections by total usage.

2005-02-23  Adrian Aichner  <adrian@xemacs.org>

	* cmdloop.el (keyboard-quit): Remove workaround for
	`region-active-p' not making sure active region is in current
	buffer now that it does.
	* minibuf.el (minibuffer-keyboard-quit): Ditto.
	* simple.el (region-active-p): `region-active-p' to only return t
	when active region is in current buffer.

2005-02-20  Adrian Aichner  <adrian@xemacs.org>

	* replace.el (operate-on-non-matching-lines): Append matching
	lines to temp buffer to avoid prohibitive GC as a result of
	enormous string consing.
	* replace.el (operate-on-matching-lines): Ditto.

2005-02-21  Ben Wing  <ben@xemacs.org>

	* glyphs.el:
	* glyphs.el (make-image-specifier):
	* glyphs.el (glyph-property):
	* glyphs.el (convert-glyph-property-into-specifier):
	* glyphs.el (set-glyph-property):
	* glyphs.el (glyph-image):
	* glyphs.el (set-glyph-image):
	* glyphs.el (glyph-contrib-p):
	* glyphs.el (glyph-contrib-p-instance):
	* glyphs.el (set-glyph-contrib-p):
	* glyphs.el (glyph-baseline):
	* glyphs.el (set-glyph-baseline):
	* glyphs.el (make-glyph):
	Update documentation of `make-glyph' and `make-image-specifier'
	to more clearly document image instantiators and describe how
	errors are handled in make-glyph.  Also fix symbol references in
	doc strings to use `symbol' format, not 'symbol.

2005-02-21  Stephen J. Turnbull  <stephen@xemacs.org>

	* about.el (about-xemacs):
	Compute release date from xemacs-release-date.

2005-02-19  Norbert Koch  <viteno@xemacs.org>

	* package-ui.el (pui-list-packages): The longest package name now
	has 20 characters.  Adapt the display.

2005-02-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.19 "chives" is released.

2005-02-16  Aidan Kehoe  <kehoea@parhasard.net>

	* buffer.el (pop-to-buffer):
	* window-xemacs.el (display-buffer):
	Document use of `same-window-buffer-names,' `same-window-regexps'
	by pop-to-buffer and display-buffer. 
	
2005-02-09  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list):
	Move paragraphs later so that decode-coding-string is defined.

2005-02-09  Ben Wing  <ben@xemacs.org>

	* paragraphs.el (sentence-end):
	Don't have literal chars in the string and don't put the extended
	chars in the string unless (featurep 'mule).

2005-02-09  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/european.el: Fix a comment typo pointed out by Jerry James
	in psu0olr8z7.fsf@diannao.ittc.ku.edu.

2005-02-09  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/european.el: Create the 8859-16 character set and coding system.
	* mule/european.el (latin-iso8859-16): Make the character set available.

2005-02-09  Aidan Kehoe  <kehoea@parhasard.net>

	* unicode.el (load-unicode-tables):
	  Initialise mapping tables for ISO
	8859-16--cf. s3tk6pieyuk.fsf@magellan.suse.de , DOUBLE LOW-9
	QUOTATION MARK is very much used for German and in Central Europe.

2005-02-09  Aidan Kehoe  <kehoea@parhasard.net>

	* unicode.el: 
	Add coding system aliases for utf-16-be and utf-16-le, for 
	improved compatibility with Mule-UCS and the FSF.  

2005-02-07  Ben Wing  <ben@xemacs.org>

	* menubar.el (find-menu-item-1):
	Forgot to rename this when find-menu-item-1 was extracted.

2005-02-03  Ben Wing  <ben@xemacs.org>

	* autoload.el (batch-update-autoloads):
	Use correct parameters when invoking older interface.

2005-02-03  Ben Wing  <ben@xemacs.org>

	* shadow.el (find-emacs-lisp-shadows):
	Ignore custom-defines.

2005-02-03  Ben Wing  <ben@xemacs.org>

	* about.el:
	* about.el (xemacs-hackers):
	* about.el (about-personal-info):
	* about.el (about-hacker-contribution):
	* about.el (about-hackers):
	Add Aidan, alexm.  Update my info.  Sort list of ancillary
	contributors, delete a couple of duplicates.

2005-02-03  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list):
	Document that paragraphs needs easy-mmode.
	
2005-02-03  Ben Wing  <ben@xemacs.org>

	* packages.el (package-suppress): New.
	Add actual command to suppress packages.

2005-02-03  Jerry James  <james@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Add easy-mmode.
	* paragraphs.el (paragraphs): Undo the require as it is now
	unnecessary.

2005-02-03  Jerry James  <james@xemacs.org>

	* paragraphs.el: Require easy-mmode, due to its move in core.
	* paragraphs.el (sentence-end): Fix a typo.

2005-02-03  Ben Wing  <ben@xemacs.org>

	* regexp-opt.el:
	* regexp-opt.el (regexp-opt):
	* regexp-opt.el (regexp-opt-not-groupie*-re): New.
	* regexp-opt.el (regexp-opt-group):
	Update to latest version in package tree.

2005-02-03  Ben Wing  <ben@xemacs.org>

	* paragraphs.el:
	* paragraphs.el (paragraphs): New.
	* paragraphs.el (use-hard-newlines): Removed.
	* paragraphs.el (paragraph-start):
	* paragraphs.el (paragraph-separate):
	* paragraphs.el (sentence-end-double-space): New.
	* paragraphs.el (sentence-end-without-period): New.
	* paragraphs.el (sentence-end):
	* paragraphs.el (forward-paragraph):
	* paragraphs.el (backward-paragraph):
	* paragraphs.el (mark-paragraph):
	* paragraphs.el (forward-sentence):
	* paragraphs.el (mark-end-of-sentence):
	* paragraphs.el (transpose-sentences):
	Sync to 21.3.  Depends on easy-mmode in core.

2005-02-02  Ben Wing  <ben@xemacs.org>

	* easy-mmode.el, regexp-opt.el:
	Move these files into core.
	Uncomment stuff depending on new custom.el.
	
	* autoload.el:
	* autoload.el (generate-autoload-function): New.
	* autoload.el (autoload-feature-suffix): New.
	* autoload.el (generate-autoload-section-continuation): New.
	* autoload.el (make-autoload):
	* autoload.el (generate-file-autoloads):
	* autoload.el (generate-autoload-type-section):
	* autoload.el (process-one-lisp-autoload): New.
	* autoload.el (generate-lisp-file-autoloads-1):
	* autoload.el (generate-c-file-autoloads-1):
	* autoload.el (generate-custom-defines): New.
	* autoload.el (print-autoload): Removed.
	* autoload.el (autoload-print-form): New.
	* autoload.el (defcustom):
	* autoload.el (autoload-read-section-header): New.
	* autoload.el (update-file-autoloads):
	* autoload.el (update-autoloads-here): Removed.
	* autoload.el (batch-update-directory-custom-defines): New.
	* autoload.el (update-autoload-files):
	* autoload.el (autoload-update-directory-autoloads): Removed.
	* autoload.el (batch-update-directory-autoloads): New.
	* autoload.el (autoload-featurep-protect-autoloads):
	* autoload.el (update-autoloads-from-directory): Removed.
	* autoload.el (update-custom-define-files): New.
	* autoload.el (autoload-make-feature-name):
	* autoload.el (batch-update-autoloads):
	* autoload.el (batch-update-directory): Removed.
	* autoload.el (batch-update-one-directory): Removed.
	* autoload.el (batch-force-update-one-directory): Removed.
	Major update.  Sync with FSF 21.2.
	Create the ability to make custom-defines files.

	* update-elc-2.el (batch-update-elc-2):
	* update-elc.el (do-autoload-commands):
	Rewrite to use new autoload API.
	
	* update-elc.el (lisp-files-needing-early-byte-compilation):
	Add easy-mmode.

2005-02-02  Ben Wing  <ben@xemacs.org>

	* behavior.el:
	* behavior.el (behavior-group-hash-table): New.
	* behavior.el (behavior-override-hash-table): New.
	* behavior.el (define-behavior): Removed.
	* behavior.el (behavior-group-p): New.
	* behavior.el (check-behavior-group): New.
	* behavior.el (override-behavior):
	* behavior.el (define-behavior-group):
	* behavior.el (read-behavior):
	* behavior.el (compute-behavior-group-children): New.
	* behavior.el (behavior-menu-filter-1): New.
	* behavior.el (behavior-menu-filter): New.
	Major update.  Add documentation of how it works.

	* behavior-defs.el:
	* behavior-defs.el (tty):
	* behavior-defs.el ('scroll-in-place): Removed.
	* behavior-defs.el ('mouse-avoidance): Removed.
	* behavior-defs.el ('jka-compr): Removed.
	* behavior-defs.el ('efs): Removed.
	* behavior-defs.el ('resize-minibuffer): Removed.
	* behavior-defs.el ('func-menu): Removed.
	* behavior-defs.el ('mwheel): Removed.
	* behavior-defs.el ('recent-files): Removed.
	* behavior-defs.el ('filladapt): Removed.
	* behavior-defs.el ('tty)): New.
	* behavior-defs.el ('toolbars)): New.
	* behavior-defs.el ('menus)): New.
	* behavior-defs.el ('mouse)): New.
	* behavior-defs.el ('editing)): New.
	* behavior-defs.el ('keyboard)): New.
	* behavior-defs.el ('files)): New.
	* behavior-defs.el ('games)): New.
	* behavior-defs.el ('processes)): New.
	* behavior-defs.el ('display)): New.
	* behavior-defs.el ('programming)): New.
	* behavior-defs.el ('international)): New.
	* behavior-defs.el ('buffers-and-windows)): New.
	* behavior-defs.el ('internet)): New.
	* behavior-defs.el ('compose-mail): New.
	Only define the basic behavior groups here.
	Move the definitions for particular packages to the
	appropriate package files.

	* mwheel.el:
	* mwheel.el ('mwheel): New.
	Add define-behavior for mwheel.

2005-02-02  Ben Wing  <ben@xemacs.org>

	* easymenu.el (easy-menu-add):
	* easymenu.el (easy-menu-remove):
	* map-ynp.el (map-y-or-n-p):
	Use normalize-menu-text not normalize-menu-item-name.

	* menubar-items.el (submenu-generate-accelerator-spec): Removed.
	* menubar.el (submenu-generate-accelerator-spec): New.
	Move to menubar.el and rewrite for cleanliness.
	
	* menubar-items.el (coding-system-menu-filter):
	Use menu-split-long-menu-and-sort.
	
	* menubar-items.el (menu-item-strip-accelerator-spec): Removed.
	* menubar-items.el (menu-item-generate-accelerator-spec): Removed.
	* menubar-items.el (menu-max-items): Removed.
	* menubar-items.el (menu-submenu-max-items): Removed.
	* menubar-items.el (menu-submenu-name-format): Removed.
	* menubar-items.el (menu-split-long-menu): Removed.
	* menubar-items.el (menu-sort-menu): Removed.
	* menubar.el (menu-item-strip-accelerator-spec): New.
	* menubar.el (menu-item-generate-accelerator-spec): New.
	* menubar.el (menu-max-items): New.
	* menubar.el (menu-submenu-max-items): New.
	* menubar.el (menu-submenu-name-format): New.
	* menubar.el (menu-split-long-menu): New.
	* menubar.el (menu-sort-menu): New.
	Move to menubar.el.
	
	* menubar.el (menu-item-text): New.
	* menubar.el (menu-split-long-menu-and-sort): New.
	New funs.
	
	* menubar.el (find-menu-item):
	* menubar.el (find-menu-item-1): New.
	Split up find-menu-item w/find-menu-item-1, since PARENT is not
	an external item.
	Rewrite to use compare-menu-text.
	
	* menubar.el (add-menu-item-1):
	Don't normalize items as find-menu-item does not need it.

	* menubar-items.el (default-menubar):
	Delete old Behavior menu defn, replaced by behavior-menu-filter.
	Planning to [[Delete many menus from Tools menu -- they have been
	integrated as part of the behavior system.]] Currently the new
	Tools menu (very short, just a call to the behavior-menu-filter)
	is commented out, and the old Toold menu defn remains.  Once the
	new packages are in place (c. 1 or 2 weeks), I'll make the
	switchover.
	
	Use menu-split-long-menu-and-sort.

2005-02-02  Ben Wing  <ben@xemacs.org>

	* cus-dep.el (Custom-make-dependencies-1):
	If a directory has no custom dependencies, write a blank
	custom-load file rather than deleting the file, so that
	time-based rebuild checking will work.
	
	* cus-edit.el:
	* cus-edit.el (custom-load-symbol):
	* cus-edit.el (custom-load-symbol-1): New.
	* cus-edit.el (custom-already-loaded-custom-defines): New.
	* cus-edit.el (custom-define-current-source-file): New.
	* cus-edit.el (custom-warn-when-reloading-necessary): New.
	* cus-edit.el (custom-load-custom-defines): New.
	* cus-edit.el (custom-load-custom-defines-1): New.
	Split out code in custom-load-symbol.  Support loading of
	the new custom-defines file.
	
	* cus-edit.el (custom-menu-create):
	Split long menus.
	
	* custom.el:
	* custom.el (load):
	* custom.el (custom-dont-initialize): New.
	* custom.el (custom-current-group-alist): New.
	* custom.el (custom-declare-variable):
	* custom.el (defcustom):
	* custom.el (custom-current-group): New.
	* custom.el (custom-declare-group):
	* custom.el (defgroup):
	* custom.el (custom-add-to-group):
	* custom.el (custom-group-of-mode): New.
	* custom.el (custom-handle-all-keywords):
	* custom.el (custom-autoload): New.
	* custom.el (custom-variable-p): New.
	* custom.el (custom-load-recursion): New.
	* custom.el (custom-load-symbol): New.
	* custom.el (custom-known-themes):
	* custom.el (custom-declare-theme): New.
	* custom.el (deftheme):
	* custom.el (custom-make-theme-feature):
	* custom.el (custom-check-theme):
	* custom.el (custom-push-theme):
	* custom.el (custom-set-variables):
	* custom.el (custom-theme-set-variables):
	* custom.el (custom-set-default): New.
	* custom.el (custom-quote): New.
	* custom.el (customize-mark-to-save): New.
	* custom.el (provide-theme):
	* custom.el (require-theme):
	* custom.el (customize-mark-as-set): New.
	* custom.el (custom-remove-theme): New.
	* custom.el (custom-do-theme-reset):
	* custom.el (custom-theme-load-themes):
	* custom.el (custom-load-themes):
	* custom.el (custom-theme-value):
	* custom.el (custom-theme-variable-value):
	* custom.el (custom-theme-reset-internal):
	* custom.el (copy-upto-last): Removed.
	* custom.el (custom-theme-reset-variables):
	* custom.el (custom-reset-variables):
	* custom.el:
	* custom.el (load):
	* custom.el (custom-dont-initialize): New.
	* custom.el (custom-current-group-alist): New.
	* custom.el (custom-declare-variable):
	* custom.el (defcustom):
	* custom.el (custom-current-group): New.
	* custom.el (custom-declare-group):
	* custom.el (defgroup):
	* custom.el (custom-add-to-group):
	* custom.el (custom-group-of-mode): New.
	* custom.el (custom-handle-all-keywords):
	* custom.el (custom-autoload): New.
	* custom.el (custom-variable-p): New.
	* custom.el (custom-load-recursion): New.
	* custom.el (custom-load-symbol): New.
	* custom.el (custom-known-themes):
	* custom.el (custom-declare-theme): New.
	* custom.el (deftheme):
	* custom.el (custom-make-theme-feature):
	* custom.el (custom-check-theme):
	* custom.el (custom-push-theme):
	* custom.el (custom-set-variables):
	* custom.el (custom-theme-set-variables):
	* custom.el (custom-set-default): New.
	* custom.el (custom-quote): New.
	* custom.el (customize-mark-to-save): New.
	* custom.el (provide-theme):
	* custom.el (require-theme):
	* custom.el (customize-mark-as-set): New.
	* custom.el (custom-remove-theme): New.
	* custom.el (custom-do-theme-reset):
	* custom.el (custom-theme-load-themes):
	* custom.el (custom-load-themes):
	* custom.el (custom-theme-value):
	* custom.el (custom-theme-variable-value):
	* custom.el (custom-theme-reset-internal):
	* custom.el (copy-upto-last): Removed.
	* custom.el (custom-theme-reset-variables):
	* custom.el (custom-reset-variables):
	Sync with FSF 21.3.

2005-01-31  Ben Wing  <ben@xemacs.org>

	* help.el:
	* help.el (describe-distribution): Go to appropriate FAQ entry.
	* help.el (describe-beta): Go to info file.
	* help.el (describe-project): Removed.

2005-01-27  Ben Wing  <ben@xemacs.org>

	* font-menu.el:
	* font.el:
	* font.el (internal-facep):
	* font.el (x-font-build-cache):
	* font.el (font-lookup-rgb-components):
	* frame.el (set-frame-font):
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* minibuf.el (read-color-completion-table):
	* minibuf.el (x-library-search-path): Removed.
	* minibuf.el (x-read-color-completion-table)): Removed.
	* msw-faces.el (mswindows-available-font-sizes):
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	* obsolete.el:
	* x-faces.el:
	* x-faces.el (x-available-font-sizes):
	* x-faces.el (x-library-search-path): New.
	* x-faces.el (x-color-list-internal-cache)): New.
	* x-faces.el (x-color-list-internal): New.
	* x-font-menu.el (x-reset-device-font-menus):
	list-fonts->font-list.  Create color-list.  Abstract out
	x/msw-specific versions and obsolete the x/msw-specific Lisp
	functions.

2005-01-27  Ben Wing  <ben@xemacs.org>

	* subr.el:
	* subr.el (macro-declaration-function): New.
	Some synching with FSF 21.2.

2005-01-27  Ben Wing  <ben@xemacs.org>

	* gtk-marshal.el (find-file):
	Propagate hash changes to gtk-marshal.el.
	
2005-01-26  Ben Wing  <ben@xemacs.org>

	* newcomment.el:
	* newcomment.el (comment):
	* newcomment.el (comment-fill-column): New.
	* newcomment.el (comment-style):
	* newcomment.el (comment-padding):
	* newcomment.el (comment-multi-line):
	* newcomment.el (comment-normalize-vars):
	* newcomment.el (comment-indent):
	* newcomment.el (uncomment-region):
	* newcomment.el (comment-make-extra-lines):
	* newcomment.el (comment-with-narrowing):
	* newcomment.el (comment-region-internal):
	* newcomment.el (comment-region):
	* newcomment.el (comment-box):
	* newcomment.el (comment-or-uncomment-region): New.
	* newcomment.el (comment-dwim):
	* newcomment.el (comment-auto-fill-only-comments):
	* newcomment.el (comment-valid-prefix): New.
	* newcomment.el (comment-indent-new-line):
	Sync to FSF 21.3.

2005-01-26  Ben Wing  <ben@xemacs.org>

	* fill.el:
	* fill.el (canonically-space-region):
	* fill.el (fill-region-as-paragraph):
	* fill.el (justify-current-line):
	* fill.el (fill-individual-paragraphs):
	Sync for real to FSF 19.34.

	* page.el:
	* page.el (narrow-to-page):
	* register.el:
	* register.el (set-register):
	* register.el (point-to-register):
	* register.el (register-swap-out):
	* register.el (number-to-register):
	* register.el (view-register):
	* register.el (list-registers): New.
	* register.el (describe-register-1): New.
	* register.el (insert-register):
	Sync to FSF 21.3.

2005-01-26  Ben Wing  <ben@xemacs.org>

	* frame.el (display-mouse-p):
	Fix warning.

	* cl.el (cl-random-time):
	Conditionalize on coerce-number as Jerry says it's OK.

2005-01-26  Ben Wing  <ben@xemacs.org>

	* code-init.el (set-eol-detection):
	* code-init.el (coding-system-default-variable-list):
	* code-init.el (get-coding-system-variable):
	* code-init.el (set-coding-system-variable):
	Undo Stephen's change of 2004-05-11.
	Implement no-conversion-coding-system-mapping as a coding
	system variable.

2005-01-25  Ben Wing  <ben@xemacs.org>

	* startup.el:
	* startup.el (splash-frame-timeout): Removed.
	* startup.el (command-line-1):
	* startup.el (startup-presentation-hack-keymap): Removed.
	* startup.el (startup-presentation-hack-help):
	* startup.el (startup-presentation-hack): Removed.
	* startup.el (splash-frame-present): Removed.
	* startup.el (splash-screen-present): New.
	* startup.el (splash-frame-present-hack): Removed.
	* startup.el (startup-presentation-activate): New.
	* startup.el (splash-screen-present-hack): New.
	* startup.el (startup-center-spaces):
	* startup.el (splash-frame-body): Removed.
	* startup.el (splash-screen-window-body): New.
	* startup.el (splash-screen-tty-body): New.
	* startup.el (splash-frame-static-body): Removed.
	* startup.el (circulate-splash-frame-elements): Removed.
	* startup.el (display-splash-frame): Removed.
	* startup.el (splash-screen-static-body): New.
	* startup.el ('splash-frame-static-body): New.
	* startup.el (display-splash-screen): New.
	* startup.el (xemacs-splash-buffer): New.
	Rename "splash-frame" -> "splash-screen" (its change
	long ago from screen to frame happened during the general
	screen->frame sub and was a mistake).	Compress all info
	onto one screen rather than cycling through 3 of them.
	Update copyright years and some other random stuff.

	* menubar-items.el:
	* menubar-items.el (default-menubar):
	* menubar-items.el (xemacs-splash-buffer): Removed.
	frame->screen and rewrite to fix bugginess.
	Add menu items for beta and distribution info.

2005-01-25  Ben Wing  <ben@xemacs.org>

	* mouse.el:
	* mouse.el (mouse-track-activate-strokes):
	* mouse.el (mouse-track-conservative-activate-strokes): New.
	* mouse.el (Mouse-track-gensym):
	* mouse.el (mouse-track-do-activate): Removed.
	* mouse.el (default-mouse-track-check-for-activation): New.
	* mouse.el (default-mouse-track-click-hook): New.
	* mouse.el (mouse-track-down-hook):
	Redo mouse-track activation to separate out a "conservative"
	activation that is only triggered by button2 or button1 double-click
	and a regular activation also triggered by button1.

2005-01-25  Ben Wing  <ben@xemacs.org>

	* font-lock.el (c-font-lock-keywords-2): Removed.
	* font-lock.el (xemacs-c-font-lock-keywords-2): New.
	* font-lock.el (c-font-lock-keywords-3): Removed.
	* font-lock.el (xemacs-c-font-lock-keywords-3): New.
	Proper defvars.

2005-01-17  Adrian Aichner  <adrian@xemacs.org>

	* simple.el (shifted-motion-keys-select-region): Fix statement
	about unshifted-motion-keys-deselect-region.

2005-01-08  Mike Sperber  <mike@xemacs.org>

	* packages.el (packages-find-installation-package-directories): Add.

	* find-paths.el (paths-for-each-emacs-directory): Abstract FUNC
	parameter out of `paths-find-emacs-directory'.
	(paths-find-emacs-directories): Add.
	(paths-find-emacs-directory): Redefine in terms of
	`paths-for-each-emacs-directory'.
	(paths-for-each-site-directory): Add.
	(paths-find-site-directory): Redefine in terms of
	`paths-for-each-site-directory'.
	(paths-find-site-directories): Add.
	(paths-for-each-version-directory): Add.
	(paths-find-version-directory): Redefine in terms of
	`paths-for-each-version-directory'.
	(paths-find-version-directories): Add.

2005-01-09  Adrian Aichner  <adrian@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Fix typo in
	"mule-win32-init" path in preloaded-file-list, as suggected by
	Alejandro L~pez-Valencia.

2005-01-09  Adrian Aichner  <adrian@xemacs.org>

	* process.el (start-process-shell-command): Correct docstring.

2005-01-03  Mike Sperber  <mike@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Prefix Mule files with
	mule/, unbreaking the build.

2004-12-18  Mike Sperber  <mike@xemacs.org>

	* package-admin.el:
	* startup.el: Reflect the changes made in packages.el.

	* packages.el:
	* loadup.el:
	* make-docfile.el:
	* package-admin.el:
	* startup.el:
	* update-elc.el (early-package-hierarchies)
	(late-package-hierarchies)
	(last-package-hierarchies): Renamed these from `early-packages',
	`late-packages' and `last-packages'.

	* packages.el: Rewrote package-finding logic to separate the
	concepts of "package directories" and "package hierarchies".
	Added explanation of these concepts.
	
	* setup-paths.el: 
	* find-paths.el: Added parameter descriptions to some of the
	docstrings.

	* packages.el, setup-paths.el: Make terminology more explicit
	about "package hierarchies"

	* startup.el (emacs-roots, emacs-data-roots)
	(user-init-directory-base, user-init-directory)
	(user-init-file-base, user-init-file-base-list)
	(user-home-init-file-base-list)
	(load-home-init-file, load-user-init-file-p)
	(startup-find-load-path, startup-setup-paths)
	(startup-find-load-path-for-packages): Moved these back from
	setup-paths.el where they belong---setup-paths.el now again, as
	documented, contains no code that sets global variables.  (They
	were moved from startup.el to setup-paths.el on 2003-02-28.)
	Clarify that in the comment at the top.

	* setup-paths.el (paths-find-emacs-roots): Restored
	`invocation-directory' 'invocation-name' parameters removed on
	2003-02-28; they're useful for debugging.

2004-12-15  Ville Skyttä  <scop@xemacs.org>

	* bytecomp-runtime.el (make-obsolete): Add 3rd argument (no-op for
	now) for GNU Emacs compatibility.
	(make-obsolete-variable): Ditto.

2004-11-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* gnuserv.el (gnuserv-edit-files): Improve docstring.

2004-12-13  Stephen J. Turnbull  <stephen@xemacs.org>

	* simple.el (next-line):
	(previous-line):
	Document effect of `signal-error-on-buffer-boundary'.

2004-12-11  Ben Wing  <ben@xemacs.org>

	* files.el (find-coding-system-magic-cookie-in-file):
	File positions are 0 based not 1 based.

2004-12-05  Ben Wing  <ben@xemacs.org>

	* info.el (Info-additional-search-directory-list):
	Correct doc string giving example package path.
	
	* menubar-items.el (default-menubar):
	Move Prefix Rectangle command up one level.

2004-11-14  Adrian Aichner  <adrian@xemacs.org>

	* mule/devan-util.el (devanagari-composite-glyph-unit): doctring
	typo fix.

2004-09-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* menubar-items.el (save-options-file):
	(save-options-init-file):
	(options-save-faces):
	Remove obsolete and unused variables.

2004-09-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* menubar-items.el (init-menubar-at-startup):
	XEmacs loads "init files", not ".emacs".

2004-11-07  Malcolm Purvis  <malcolmp@xemacs.org>

	* about.el (about-personal-info): Added my personal details.
	Added missing entry for Norbert Koch.
	* about.el (about-hacker-contribution): Added missing entry for
	Norbert Koch.

2004-11-04  Ben Wing  <ben@xemacs.org>

	* mule/mule-ccl.el (define-ccl-program):
	* mule/mule-ccl.el (TRANSLATE): New.
	* mule/mule-ccl.el (MAP): New.
	* mule/mule-ccl.el (MAP-IDs): New.
	* mule/mule-ccl.el (MAP-SET): New.
	* mule/mule-ccl.el (MAP-ID): New.
	* mule/mule-ccl.el (INT-OR-CHAR): New.
	Update docs.
	
2004-10-26  Ben Wing  <ben@xemacs.org>

	* cl-extra.el (coerce):
	* cl.el (cl-random-time):
	* wid-edit.el (widget-url-link-action):
	* widgets-gtk.el (gtk-widget-instantiate-notebook-internal):
	* dialog-gtk.el:
	* frame.el (frame-notice-user-settings):
	* frame.el (display-mouse-p):
	* frame.el (display-visual-class):
	* package-ui.el (pui-display-maintainer):
	Fix compile warnings.
	
2004-10-14  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el:
	Put in comment about extended chars in dumped files.
	
	* font-lock.el:
	* font-lock.el (lisp-font-lock-keywords-2):
	* font-lock.el (c-font-lock-keywords-2): New.
	* font-lock.el (c-font-lock-keywords-3): New.
	Add versions of C keywords for editing XEmacs source code,
	recognizing many basic XEmacs types.

	* loadup.el (really-early-error-handler):
	* unicode.el:
	* unicode.el (load-unicode-tables-at-dump-time): New.
	* unicode.el (init-unicode-at-startup): Removed.
	* mule/mule-cmds.el (init-mule-at-startup):
	Define and implement load-unicode-tables-at-dump-time.  Set this
	to true on Windows systems.  This will increase the size of the
	dumped XEmacs but allow XEmacs to be run when in a non-ASCII
	directory or with non-ASCII command-line arguments.
	
	* update-elc.el:
	* update-elc.el (unbytecompiled-lisp-files):
	* update-elc.el (additional-dump-dependencies): New.
	* update-elc.el ((preloaded-file-list site-load-packages files-to-process)):
	Add loadup.el, loadup-el.el and update-elc.el as additional
	dependencies, forcing a redump if they are changed.
	
	* win32-native.el:
	Add stuff snipped from Microsoft docs concerning how quoting
	conventions are supposed to work.

2004-10-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* code-process.el (call-process-region): Fix region deletion bug.
	Report by Katsumi Yamaoka <b9yvfcyuscf.fsf@jpl.org>.

2004-10-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.18 "chestnut" is released.

2004-09-25  Jerry James  <james@xemacs.org>

	* itimer.el (start-itimer): Cannot use set-itimer-name now that
	that function does not uniquify names.

2004-09-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* startup.el (load-init-file):
	(load-user-init-file):
	Remove bogus comments.

2004-09-23  Stephen J. Turnbull  <stephen@xemacs.org>

	* about.el (xemacs-hackers): Fix Malcolm's address.

2004-09-22  Jerry James  <james@xemacs.org>

	* itimer.el (set-itimer-name): Do not uniquify names, as requested
	by Kyle Jones.

2004-09-19  Stephen J. Turnbull  <stephen@xemacs.org>

	* code-init.el: Add to header comment.
	* gtk-font-menu.el: Improve documentation.
	* unicode.el: Various comments added.
	* process.c (process-buffer):
	(set-process-buffer):
	(process-stderr-buffer):
	(set-process-stderr-buffer):
	Document interaction with filters.

2004-09-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* x-font-menu.el: (x-fonts-menu-junk-families): Improve docstring.
	(hack-font-truename): Improve docstring.

	* font-menu.el (font-menu-ignore-scaled-fonts): Improve docstring.
	(font-menu-this-frame-only-p): Improve docstring.
	(font-menu-preferred-resolution): Improve docstring.
	(font-menu-size-scaling): Improve docstring.
	(device-fonts-cache): Move comment into docstring and improve it.
	(reset-device-font-menus): Improve docstring.
	(reset-device-font-menus): Move message into if; only announce
	we're getting font list if we're actually going to do it.

2003-12-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* cl-macs.el (loop): Fixed typo in docstring.

2003-11-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* itimer.el (check-itimer-coerce-string): Fix sense of docstring;
	markup signal name as code.
	(check-nonnegative-number): Markup signal name as code.

2004-07-12  Stephen J. Turnbull  <stephen@xemacs.org>

	* specifier.el (set-specifier): Sentences in docstrings should be
	separated with two spaces, not one.

	* find-paths.el (paths-lisp-filename-regexp): Improve docstring.

2004-07-12  Stephen J. Turnbull  <stephen@xemacs.org>

	* about.el (xemacs-hackers): Update turnbull, add viteno.
	(about-current-release-maintainers): Add martin, vin, and viteno.
	(about-other-current-hackers):
	(about-once-and-future-hackers):
	Move inactive hackers from other-current to once-and-future.
	(about-url-alist):  Add turnbull, xemacs-cvs, and xemacs-lists.
	* about.el (about-xemacs):
	Add information about package maintainers.
	Mention Vin, Stephen, and Andy w.r.t. 21.4.
	Mention Ben and Martin w.r.t. 21.2.
	(about-advantages): Mention GNU Emacs 21.
	(about-personal-info): Update turnbull.

2004-05-15  Stephen J. Turnbull  <stephen@xemacs.org>

	* specifier.el (set-specifier): Fix typo in comment.

2004-07-12  Stephen J. Turnbull  <stephen@xemacs.org>

	* about.el (about-xemacs):
	Give more precise version info.
	Compute version numbers.

2004-09-21  Jerry James  <james@xemacs.org>

	* itimer.el (start-itimer): Fix my bungling of Martin's intentions.

2004-09-20  Martin Buchholz <martin@xemacs.org>

	* itimer.el (set-itimer-name): New function.
	(start-itimer): Use it.

2003-12-12  Katsumi Yamaoka  <yamaoka@jpl.org>

	* itimer.el (activate-itimer): Modify the itimer timeout value as
	if it were begun at the last time when the itimer driver was woken
	up.

2004-09-15  Stephen J. Turnbull  <stephen@xemacs.org>

	Fix bug: apropos errors if a defalias refers to an undefined
	function.  <87pt4pmdcs.fsf@tleepslib.sk.tsukuba.ac.jp>

	* apropos.el (apropos):
	(apropos-command):
	* help.el (frob-help-extents):
	* help-macro.el (make-help-screen):
	* hyper-apropos.el (hyper-apropos-grok-functions):
	(hyper-apropos-get-doc):
	Catch void-function error thrown by `documentation'.

2004-09-07  Steve Youngs  <steve@youngs.au.com>

	* packages.el (package-require): Fix incorrect arg to format.
	This fixes a `format specifier' error.

2004-08-15  Jan Rychter <jwr@xemacs.org>

	* window-xemacs.el (really-set-window-configuration): deal
	gracefully with the case when the buffer previously saved in the
	configuration (and that we want to switch to) has been
	killed. Switch to the next buffer on the buffer-list in that case.

2004-08-13  Jerry James  <james@xemacs.org>

	* bytecomp.el (forward-word): Tell the byte compiler the correct
	number of arguments to forward-word.

2004-07-02  Malcolm Purvis  <malcolmp@xemacs.org>

	* widgets-gtk.el (gtk-widget-instantiate-notebook-internal):
	Loading items into the notebook is now done by C code.
	* widgets-gtk.el (gtk-widget-instantiate-internal):
	Style no longer changed.

2004-06-24  Jerry James  <james@xemacs.org>

	* cl-compat.el: Synch with Emacs 21.3.
	* cl-extra.el: Ditto.
	* cl-extra.el (cl-push): Removed because superfluous.
	* cl-extra.el (cl-pop): Removed because superfluous.
	* cl-extra.el (cl-emacs-type)): Removed because unused.
	* cl-extra.el (cl-map-keymap): Just alias map-keymap.
	* cl-extra.el (cl-map-keymap-recursively): Drop Emacs 18 support.
	* cl-extra.el (cl-copy-tree): Removed because superfluous.
	* cl-extra.el (cl-remprop): New alias.
	* cl-extra.el (cl-make-hash-table): New alias.
	* cl-extra.el (cl-hash-table-p): New alias.
	* cl-extra.el (cl-hash-table-count): New alias.
	* cl-macs.el: Synch with Emacs 21.3.
	* cl-macs.el (cl-push): Removed because superfluous.
	* cl-macs.el (cl-pop): Removed because superfluous.
	* cl-macs.el (cl-emacs-type): Removed because unused.
	* cl-macs.el (cl-compile-time-init): Drop Emacs 18 and 19 support.
	* cl-macs.el (return): Change arg name to match Emacs and docstring.
	* cl-macs.el (return-from): Ditto.
	* cl-macs.el (loop): Check for 'collecting as well as 'collect.
	* cl-macs.el (define-setf-expander): New alias.
	* cl-macs.el (caar): New setf method.
	* cl-macs.el (cadr): New setf method.
	* cl-macs.el (cdar): New setf method.
	* cl-macs.el (cddr): New setf method.
	* cl-macs.el (deftype): Change arg name to match Emacs and docstring.
	* cl-macs.el (ignore-errors): Change docstring to match arg name.
	* cl-seq.el: Synch with Emacs 21.3.
	* cl-seq.el (cl-push): Removed because superfluous.
	* cl-seq.el (cl-pop): Removed because superfluous.
	* cl-seq.el (mismatch): Typo fix.
	* cl.el: Synch with Emacs 21.3.
	* cl.el (cl-map-extents): Alias map-extents.
	* cl.el (values): Change from defalias to defsubst to add docstring.
	* cl.el (values-list): Ditto.
	* cl.el (multiple-value-list): Ditto.
	* cl.el (multiple-value-apply): Ditto.
	* cl.el (nth-value): Ditto.
	* cl.el (cl-abs): Alias the `abs' builtin instead.
	* cl.el (svref): New alias.
	* cl.el (cl-add-hook): Removed due to obsolescence.
	* cl.el (cl-hack-byte-compiler): Set cl-hacked-flag first for safety.

2004-06-26  Steve Youngs  <steve@youngs.au.com>

	* package-get.el (package-get-info-name-array): New.
	(package-get-info-info-array): New.
	(package-get-info): Use them, adding completion.
	(package-get-list-packages-where): Add completion.

2004-06-21  Adrian Aichner  <adrian@xemacs.org>

	* package-ui.el (pui-help-echo): Fix false cvs conflict by
	avoiding line solely composed of equal signs.

2004-06-18  Jerry James  <james@xemacs.org>

	* derived.el (define-derived-mode): Put the arguments to
	derived-mode-merge-syntax-tables in the correct order.

2004-06-17  Jerry James  <james@xemacs.org>

	* derived.el (define-derived-mode): XEmacs does not have
	char-table-parent.  Use derived-mode-merge-syntax-tables instead.

2004-06-09  Stephen J. Turnbull  <stephen@xemacs.org>

	* subr.el (split-string): Clean up docstring.

2004-06-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* help.el (with-syntax-table): Removed.  (Prefer version in subr.el.)

2004-06-16  Jerry James  <james@xemacs.org>

	* cl.el (cl-set-substring): Increment start by the length of the
	string, not the string itself.

2004-06-07  Jerry James  <james@xemacs.org>

	* derived.el: Synch with Emacs 21.3.
	* subr.el (with-local-quit): New, from Emacs 21.3.
	* subr.el (delayed-mode-hooks): New variable, from Emacs 21.3.
	* subr.el (run-mode-hooks): New function, from Emacs 21.3.
	* subr.el (delay-mode-hooks): New macro, from Emacs 21.3.

2004-06-10  Adrian Aichner  <adrian@xemacs.org>

	* cus-edit.el (custom-save-variables): Fix bug introduced by
	nconc/make-list removal.
	* cus-edit.el (custom-save-faces): Ditto.

2004-06-07  Adrian Aichner  <adrian@xemacs.org>

	* cus-edit.el (custom-browse-visibility): Typo fix.
	* cus-edit.el (custom-variable-value-create): Ditto.
	* cus-edit.el (custom-save-variables): Simply use push instead of
	make-list and nconc, as suggested by Hrvoje and already used in
	21.4.
	* cus-edit.el (custom-save-faces): Ditto.

2004-06-07  Adrian Aichner  <adrian@xemacs.org>

	* mule/ethio-util.el (ethio-sera-to-fidel-region): Phrase
	duplication typo fixes for typos found by
	xemacs-builds/adrian/typology/phrase-duplication-typo.pl.
	* mule/mule-charset.el (make-translation-table): Ditto.

2004-06-07  Adrian Aichner  <adrian@xemacs.org>

	* files.el (basic-save-buffer): Ditto.
	* lisp-mode.el (eval-interactive-verbose): Ditto.
	* newcomment.el (uncomment-region): Ditto.

2003-12-03  Adrian Aichner  <adrian@xemacs.org>

	* files.el (delete-old-versions): Avoid going interactive during
	make install when environment variable VERSION_CONTROL is set.

2004-04-21  Sven Grundmann  <sven@hellerhof.de>

	* list-mode.el (display-completion-list): Fixed completion list was
	taking the width of the frame and not of the window for displaying
	the selection methods.

2004-05-21  Jerry James  <james@xemacs.org>

	* cl.el (cl-random-time): Chop a bignum down to a fixnum if
	(featurep 'bignum), not if (featurep 'number-types).

2004-05-15  Malcolm Purvis  <malcolmp@xemacs.org>

	* gtk-widgets.el: New import: gtk-accel-group-new.
	* dialog-gtk.el:
	* dialog-gtk.el (gtk-popup-convert-underscores): New.
	* dialog-gtk.el (popup-builtin-question-dialog):

	Added support for dialog button mnemonics.

2004-04-30  Stephen J. Turnbull  <stephen@xemacs.org>

	* cl.el (gensym, gentemp): Improve docstrings.

2004-05-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* code-init.el (set-eol-detection): Special-case 'no-conversion.

2004-05-10  Stephen J. Turnbull  <stephen@xemacs.org>

	* isearch-mode.el (isearch-forward, isearch-abort): Document that our
	behavior of `isearch-abort' differs from that of GNU Emacs.

2004-05-08  Sven Grundmann  <sven@xemacs.org>

	* etags.el:
	* etags.el (tags-exuberant-ctags-optimization-p): Enable optimization
	only for use with exuberant ctags. This will also enable building of 
	completion tables with exuberant ctags. This will not work with
	xemacs ctags. New.
	* etags.el (get-tag-table-buffer): New function for creating of
	completion table is used if tags-exuberant-ctags-optimization-p ist t
	* etags.el (add-to-tag-completion-table-exuberant-ctags): Defun for
	building tag completion table with exuberant ctags. New.
	* etags.el (find-tag-internal): Improve exact tag matching for tags
	with name fields. Before the patch return types of functions or
	function parameters (with exuberant ctags) were found as matches.

2004-04-20  Malcolm Purvis  <malcolmpurvis@optushome.com.au>

 	* gtk-marshal.el: Return type for INT is gint, not guint.

2004-02-23  Stephen J. Turnbull  <stephen@xemacs.org>

	* isearch-mode.el (isearch-abort): Preserve successful search target.

2004-04-19  Stephen J. Turnbull  <turnbull@sk.tsukuba.ac.jp>

	* startup.el (site-start-file):
	(load-init-file):
	Improve documentation.

2004-04-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* menubar-items.el (default-menubar): Options are saved to custom.el.

2004-04-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* help.el (help-register-and-maybe-prune-excess): Trim docstring.
	Sanity check argument.
	(with-displaying-temp-buffer): Improve docstring.

2004-04-09  Stephen J. Turnbull  <turnbull@sk.tsukuba.ac.jp>

	* files.el (revert-buffer): Synch to 21.4.  Suggested by
	Rodney Sparapani <rsparapa@post.its.mcw.edu>.

2004-04-09  Mike Sperber  <mike@xemacs.org>

	* minibuf.el (reset-buffer): Zap the mark of the minibuffer as
	well, to prevent it from hijacking other buffers' marks when
	typing in the minibuffer later.

2004-04-05  Jerry James  <james@xemacs.org>

	* cl-extra.el (coerce): Add support for general numeric conversions.
	* cl.el (eql): Update for more number types.
	* cl.el (cl-random-time): Ensure the result is a fixnum.
	* cl.el (most-positive-fixnum): Do not define in Lisp if enhanced
	number types are available.
	* cl.el (most-negative-fixnum): Ditto.

2004-03-23  Adrian Aichner  <adrian@xemacs.org>

	* code-process.el (call-process-region): Correct start and end
	marker construction, delete regions before and after insertion
	point.

2004-03-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.17 "chayote" is released.

2004-02-26  Jerry James  <james@xemacs.org>

	* device.el (device-num-screens): New.
	* device.el (device-backing-store): New.
	* device.el (device-save-under): New.
	* frame.el: Synch with Emacs 21.3.

2004-02-23  Steve Youngs  <sryoungs@bigpond.net.au>
 
	* package-get.el (package-get-update-base-from-buffer): Force
 	binary coding system for verifying GnuPG signature in the
 	package-index file.
 
2004-02-06  Jerry James  <james@xemacs.org>

	* term/linux.el: Change iso-latin-1 to iso-8859-1.

2004-01-28  Jerry James  <james@xemacs.org>

	* subr.el (add-to-invisibility-spec): New, from Emacs 21.3.
	* subr.el (remove-from-invisibility-spec): Ditto.

2004-01-29  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/japanese.el (paragraph-start, paragraph-separate):
	Remove anchor to BOL.

2004-01-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* specifier.el (canonicalize-spec): Fix typo in docstring.
	(make-specifier-and-init):
	(map-specifier):
	(canonicalize-spec-list):
	(set-specifier):
	Improve docstring.
	
2004-01-21  Jerry James  <james@xemacs.org>

	* wid-edit.el: Remove duplicate sexp widget definitions.

2004-01-08  Nickolay Pakoulin  <npak@ispras.ru>

	* info.el (Info-insert-file-contents): Use `shell-command-switch'
	instead of hard-coded "-c".

2003-12-15  Steve Youngs  <sryoungs@bigpond.net.au>

	* wid-edit.el (lazy): New.
	(widget-child-value-get): New.
	(widget-child-value-inline): New.
	(widget-child-validate): New.
	(widget-type-value-create): New.
	(widget-type-default-get): New.
	(widget-type-match): New.

	This adds a "lazy" widget to allow the definition of recursive
	datatypes for customize.  The composite widgets expand their
	subtypes immediately, which cause obvious problems for recursive
	datatypes.  The "lazy" will only expand them when needed, hense
	the name.
	From Per Abrahamsen <abraham@dina.kvl.dk>

2003-12-15  Steve Youngs  <sryoungs@bigpond.net.au>

	* package-get.el (package-get-list-packages-where): New.  A
	function that allows searching for groups of packages.  For
	example, find all packages that require the fsf-compat package.

2003-11-05  Vin Shelton  <acs@xemacs.org>

	* help.el (Help-prin1-face):
	(Help-princ-face):
	princ and prin1 are functions and need to be called as such.  The
	idea for this patch was submitted by Eric Eide <eeide@cs.utah.edu>.

2003-11-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* about.el (about-personal-info): Fix typo in Tony Rossini's entry.

2003-10-29  Ville Skyttä  <scop@xemacs.org>

	* mule/lao-util.el (lao-transcription-pattern):
	Comment out duplicate which uses regexp-opt.

2003-10-15  Stephen J. Turnbull  <stephen@xemacs.org>

	* autoload.el (Copyright): Update.

2003-10-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* files.el (find-file): Improve docstring.

2003-10-11  Steve Youngs  <sryoungs@bigpond.net.au>

	* package-ui.el (pui-display-keymap): Map `m' to
	`pui-display-maintainer'. 
	(pui-help-echo): Display both the installed upstream version
	number and the available upstream version number.
	(pui-display-maintainer): New.

2003-10-10  Stephen J. Turnbull  <stephen@xemacs.org>

	* wid-edit.el (widget-url-link-action): Fix typo.

2003-10-05	Kevin Haddock	<kevinhaddock@yahoo.com>

	* lisp/wid-edit.el (widget-default-create): Implemented suggested
	char-table dispatch wrench up (No. 4).

2003-10-07  Jerry James  <james@xemacs.org>

	* autoload.el (generate-c-file-autoloads-1): Use module-extensions
	instead of listing the extensions.  Use locate-file instead of
	explicitly trying each extension.
	* code-files.el (load): Use module-extensions instead of an
	explicit list of extensions.

2003-10-02  Steve Youngs  <youngs@xemacs.org>

	* about.el (xemacs-hackers): Remove me.
	(about-current-release-maintainers): Ditto.
	(about-url-alist): Ditto.
	(about-personal-info): Ditto.
	(about-hacker-contribution): Ditto.

2003-10-01  Steve Youngs  <youngs@xemacs.org>

	* cl-extra.el (cl-do-prettyprint): Work around a "formatting" bug
	in `report-xemacs-bug'.

2003-09-26  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.16 "celeriac" is released.

2003-09-20  Ilya N. Golubev  <gin@mo.msk.ru>

	* simple.el (raw-append-message): Allow user to specify
	alternative function for displaying message.
	(redisplay-echo-area-function): New.
	(clear-message): Allow user to specify function for finishing
	message display.
	(undisplay-echo-area-function): New.

2003-09-20  James LewisMoss  <dres@lewismoss.org>

	* font-menu.el (font-menu-max-number): New variable to specify
	the maximum recieved fonts.

	* x-font-menu.el (x-reset-device-font-menus): Use new variable
	(font-menu-max-number) to list-fonts.

2002-09-20  James LewisMoss  <dres@lewismoss.org>

	* gnuserv.el (gnuserv-edit-files): fallback to gtk if x device
	fails.  Fixes problem where gnuclient fails for gtk instances when
	gnuclient was built with X configure.

2003-09-20  Mike Alexander  <mta@arbortext.com>

	* code-init.el (eol-detection-enabled-p): eval the initialization
	value.

	* code-files.el (insert-file-contents): Make sure that
	setbuffer-file-coding-system sets the eol style.

2003-09-19  Stephen J. Turnbull  <stephen@xemacs.org>

	* win32-native.el (grep-null-device): Defined in
	xemacs-base/compile.el.

	* files.el (null-device): Defined in C, remove defvar.

2003-09-06  Mike Sperber  <mike@xemacs.org>

	* bytecomp.el (byte-compile-defvar-or-defconst): Actually
	implement the specified semantics for `defvar.'

2003-09-07  Adrian Aichner  <adrian@xemacs.org>

	* window-xemacs.el (display-buffer): Fix for `shrink-to-fit' by
	Klaus Berndl, calling `shrink-window-if-larger-than-buffer' when
	displaying buffer in question.

2003-09-03  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.15 "celery" is released.

2003-08-30  Adrian Aichner  <adrian@xemacs.org>

	* cus-edit.el (apropos-customize): New autoloaded alias making it
	easier to find customize-apropos.

2003-08-28  Steve Youngs  <youngs@xemacs.org>

	* package-ui.el (pui-set-local-package-get-directory): Remove
	arg. 

2003-07-31  René Kyllingstad  <listmailxemacs@kyllingstad.com>

	* mwheel.el (mwheel-scroll-amount):
	* mwheel.el (mwheel-scroll):
	* mwheel.el (mwheel-install):
	bind C-mouse-{4,5} to scroll page by page.

2003-08-03  Mike Sperber  <mike@xemacs.org>

	* files.el (insert-directory): Massage somewhat to be slightly
	closer to FSF version.  Support "--dired" as argument for GNU ls,
	and, if given, create extents with 'dired-file-name property set
	to t, similar to what the FSF version does.

2003-07-31  Mike Sperber  <mike@xemacs.org>

	* isearch-mode.el (isearch-mode-help): 
	(isearch-update):
	(isearch-done):
	(isearch-edit-string): Change the way window configurations are
	handled: Formerly, the code would do `set-window-configuration'
	off `pre-command-hook' which isn't really allowed.  (The old
	window-configuration code would quietly ignore this restriction.)
	Instead, save the window configuration only when someone asks for
	help, and restore afterwards, and otherwise leave it alone.

2003-07-24  Mike Sperber  <mike@xemacs.org>

	* post-gc.el (simple-finalizer-ephemerons): 
	(add-finalizer):
	(cleanup-simple-finalizers): Implement simple object finalization.

2003-07-19  Stephen Turnbull  <stephen@xemacs.org>

	* etags.el: Change `\\s ' in comments to `\\s-'.
	(tags-explicit-name-pattern, tags-DEFUN-pattern, tags-def-pattern):
	Comment the use of groups.

	* etags.el: Fix bad parsing for completion of good TAGS files.
	(tags-explicit-name-pattern): New constant.
	(tags-DEFUN-pattern, tags-def-pattern): Use it.
	(tags-schemish-pattern): New constant.
	(add-to-tag-completion-table): Intern explicit names when found.

2003-06-18  Nickolay Pakoulin  <npak@ispras.ru>

	* cl-macs.el (cl-transform-lambda): Place doc on Common Lisp
	lambda list after the original doc.  Care about
	#'(lambda () "SingleString")
	(cl-upcase-arg):
	(cl-function-arglist):
	Care about &cl-defs and &cl-quote in lambda list, dotted lists and
	circular data structures in lambda list specification

2003-07-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* derived.el (derived-mode-merge-syntax-tables): Reverse map
	logic.  Fixes "do-nothing" bug.

2003-07-16  Jerry James  <james@xemacs.org>

	* window-xemacs.el (restore-saved-window): Follow first-hchild and
	first-vchild links even when next-child is nil.

2003-07-06  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-package-index-file-location): Handle
	missing "EMACSPACKAGEPATH" environment variable.

2003-07-05  Adrian Aichner  <adrian@xemacs.org>

	* package-admin.el (package-admin-find-top-directory): Simplify
	directory comparisions and fix substring errors on short path
	components.
	* package-get.el (package-get-package-index-file-location):
	Default to first component of "EMACSPACKAGEPATH", if set.

2003-06-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* bytecomp.el (byte-compile-lambda): Discard docstring only if it
	is not also the value of the lambda.

2003-06-13  Adrian Aichner  <adrian@xemacs.org>

	* setup-paths.el (paths-emacs-root-p): Don't insist in lib-src
	directory on 'windows-nt, which currently does not have it.

2003-06-11  Adrian Aichner  <adrian@xemacs.org>

	* font-lock.el (lisp-font-lock-keywords-1): Only NAME, not NAME(
	to appear in font-lock-function-name-face.

2003-06-01  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.14 "cassava" is released.

2003-05-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* autoload.el (autoload-featurep-protect-autoloads):
	Make the error message say which sym was checked.

2003-05-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* subr.el (split-string): Update dox, tweak logic, to synch to GNU.

2003-05-15  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-package-index-file-location): New,
	so it is possible to specify a location for the index file.
	(package-get-locate-index-file): Use it.
	(package-get-maybe-save-index): Ditto.
	(package-get-user-index-filename): Remove.

2003-05-14  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-require-signed-base-updates): Turn
	the PGP verification code back on.

2003-05-11  Simon Josefsson  <jas@extundo.com>

	* replace.el (delete-non-matching-lines, kill-non-matching-lines)
	(copy-non-matching-lines, delete-matching-lines)
	(kill-matching-lines, copy-matching-lines): Don't message.

2003-05-10  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.13 "cauliflower" is released.

2003-05-08  Jerry James  <james@xemacs.org>

	* code-init.el (coding-system-variable-default-value-table): Use
	undecided-unix for keyboards to avoid EOL autodetection on TTYs.
	* code-init.el (coding-system-variable-default-value): Update the
	comment to reflect the changed table.

2003-05-03  Steve Youngs  <youngs@xemacs.org>

	* package-admin.el (package-admin-find-top-directory): You can't
	concat a string & a char, so convert 'directory-sep-char' to a string.

2003-05-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* cmdloop.el (command-error): Ensure exit msg is on separate line.

2003-05-01  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-require-signed-base-updates): Force
	default to nil while I sort out some PGP problems.

2003-04-16  Jerry James  <james@xemacs.org>

	* keydefs.el: Remove mappings for keys mapped to the nowhere
	defined function function-key-error.

2003-04-24  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.12 "carrot" is released.

2003-04-24  Steve Youngs  <youngs@xemacs.org>

	* font-lock.el (font-lock-match-java-declarations): Move
	save-restriction, narrow-to-region to beginning of function to
	avoid going beyond the limit and causing an infloop.
	From Jin Choi <jsc@orangeimagineering.com>.

2003-04-24  Vasily Korytov  <deskpot@myrealbox.com>

	* lisp-mode.el (emacs-lisp-mode-hook, lisp-mode-hook,
	lisp-interaction-mode-hook): Add the docstrings.

2003-04-23  Stephen J. Turnbull  <stephen@xemacs.org>

	* subr.el (split-string): Revert to regular behavior, except when
	both separators and omit-nulls are nil.
	(split-string-default-separators): New constant.

2003-04-15  Reiner Steib  <Reiner.Steib@gmx.de>

	* info.el (info): Support `(filename)nodename' as argument.

2003-04-14  Steve Youngs  <youngs@xemacs.org>

	* package-admin.el (package-admin-find-top-directory): Use
	'directory-sep-char'. 
	(package-admin-get-install-dir): Ditto.
	This is so PUI won't break on platforms that don't use '/' as the
	directory separator. 
	
	* package-get.el (package-get-pgp-available-p): New.
	(package-get-require-signed-base-updates): Use it.
	(package-get-update-base-from-buffer): Move the code that finds
	the gpg stuff into `package-get-pgp-available-p'.
	Now if you have Mailcrypt and a PGP binary installed and set up on
	your system, PUI will automatically default to doing PGP
	verification, otherwise it'll default to off.
	(package-get-require-base): Use the DATUM arg to `error'.
	(package-get-locate-index-file): Ditto.
	(package-get-update-base): Ditto.
	(package-get-update-base-entries): Ditto.
	(package-get-all): Ditto.
	(package-get-dependencies): Ditto.
	(package-get-info): Ditto.
	(package-get): Ditto.

	* package-info.el (batch-update-package-info): Use the DATUM arg
	to `error'.

	* package-net.el (package-net-batch-generate-bin-ini): Use the
	DATUM arg to `error'.

	* package-ui.el (pui-toggle-package-key): Use the DATUM arg to
	`error'. 
	(pui-toggle-package-delete-key): Ditto.
	(pui-install-selected-packages): Ditto.
	(pui-add-required-packages): Ditto.
	(pui-display-info): Ditto.
	(list-packages-mode): Ditto.

	* packages.el (package-require): Use the DATUM arg to `error'.

2003-03-27  Stephen J. Turnbull  <stephen@xemacs.org>

	* menubar-items.el (default-menubar):
	* startup.el (in comment): 
	Global substitution: .Xresources for .Xdefaults.

2003-03-24  Jerry James  <james@xemacs.org>

	* window-xemacs.el (saved-window-equal): Use equal instead of = to
	compare saved-window-modeline-hscroll values.

2003-03-25  Steve Youngs  <youngs@xemacs.org>

	* package-admin.el: (package-admin-delete-binary-package): Only
	delete the lisp directory if it exists.
	(package-admin-find-top-directory): New.
	(package-admin-get-install-dir): Use it.

	* package-get.el (package-get-install-to-user-init-directory):
	New.  If non-nil install packages under `user-init-directory'.
	(package-get): `package-admin-get-install-dir' only takes 2 args.

	* package-ui.el (pui-install-selected-packages): The 2nd arg to
	`package-admin-get-install-dir' is optional, no need to specify nil.

2003-03-24  Stephen J. Turnbull  <stephen@xemacs.org>

	* wid-edit.el (widget-url-link-action): Typo fix.  Thx, Adrian!

2003-03-23  Adrian Aichner  <adrian@xemacs.org>

	* menubar-items.el (default-menubar): Reword "Add Download Site"
	to the more appropriate "Set Download Site".  Categorize download
	sites under separate menu entries for "Offical", "Pre-", and
	"Site" Releases so that users only need to customize
	`package-get-site-release-download-sites'.
	* package-get.el (package-get-download-sites): Fix typo.
	* package-get.el (package-get-site-release-download-sites): New.
	Add support for "Site Releases".
	* package-ui.el (package-ui-site-release-download-menu): New.
	Ditto.

2003-03-21  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el: Globally remove trailing whitespace.
	* package-get.el (package-get-download-sites): Add more sites.
	* package-get.el (package-get-pre-release-download-sites): Add
	more sites.

2003-03-20  Steve Youngs  <youngs@xemacs.org>

	* menubar-items.el (default-menubar): Add a "Pre-Release Download
	Sites" submenu to "Tools -> Packages" menu.

	Filter the package download sites menus through
	`menu-split-long-menu'.
	
	* obsolete.el (pui-add-install-directory): New.
	(package-get-download-menu): New.

	* package-admin.el: (package-admin-add-single-file-package):
	Removed.
	(package-admin-get-install-dir): Don't rely on an installed
	xemacs-base package to guess where a package needs to be installed
	to.
	(package-admin-get-manifest-file): Whitespace clean up.
	(package-admin-check-manifest): Use `directory-sep-char' to
	compute regexp.  

	Only search 'lisp' and 'man' directories to determine package
	name.

	Don't error is xemacs-base package isn't installed, just don't
	sort the MANIFEST file and issue a warning.
	(package-admin-add-binary-package): Whitespace clean up.
	(package-admin-get-lispdir): Ditto.
	(package-admin-delete-binary-package): Use `with-temp-buffer'
	instead of creating a temporary buffer manually.

	* package-get.el: (package-get-remote): Change custom type so that
	only either a single directory or remote host:directory can be
	selected. 
	(package-get-download-sites): Put the sites into alphabetical
	order of country.  

	Make the description element be "Country (site)" instead of the
	other way around. 
	(package-get-pre-release-download-sites): New.
	(package-get-require-signed-base-updates): Default to t.
	(package-get-download-menu): Removed.
	(package-get-locate-file): Change to reflect new format of
	'package-get-remote'. 
	(package-get-update-base-from-buffer): Whitespace clean up and
	remove an unneccessary 'when'.
	(package-get-interactive-package-query): Whitespace clean up.
	(package-get-update-all): Ditto.
	(package-get-all): Ditto.
	(package-get-init-package): Ditto.
	(package-get-info): New.
	(package-get): Bring into line with new format of
	'package-get-remote'.  

	Error if non-Mule XEmacsen try to install Mule packages.  

	Don't rely on a Mule package having 'mule-base' in its
	"REQUIRES" to determine if it is a Mule package or not,
	instead we test "CATEGORY".  

	Better handling of the situation where a partial package tarball
	exists on the local hard drive from a previous interupted
	download.

	Clean up after a failed package install.
	(package-get-set-version-prop): Removed.
	(package-get-installedp): Whitespace clean up.

	* package-ui.el: Whitespace clean up.
	(pui-info-buffer): Make it a defcustom.
	(pui-directory-exists): Removed.
	(pui-package-dir-list): Removed.
	(pui-add-install-directory): Removed.
	(package-ui-download-menu): New.
	(package-ui-pre-release-download-menu): New.
	(pui-set-local-package-get-directory): New.
	(pui-package-symbol-char): Whitespace clean up.
	(pui-update-package-display): Ditto.
	(pui-toggle-package): Ditto.
	(pui-toggle-package-key): Ditto.
	(pui-toggle-package-delete): Ditto.
	(pui-toggle-package-delete-key): Ditto.
	(pui-toggle-package-event): Ditto.
	(pui-toggle-verbosity-redisplay): Ditto.
	(pui-install-selected-packages): Ditto.
	(pui-help-echo): Ditto.
	(pui-display-info): Ditto.
	(pui-list-packages): Ditto.

	* packages.el: Whitespace clean up.

2003-03-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* gutter-items.el (buffers-tab-filter-functions): Improve docstring.
	Suggested by a Chris Palmer <chris@nodewarrior.org> patch.

2003-03-02  Stephen Turnbull  <stephen@xemacs.org>

	* wid-edit.el: Many XEmacs-specific comments added.
	(missing-package): New error type.
	(link widget): Use it.
	(widget-sublist):
	Move to section with other generic utilities.
	(sexp widget):
	(widget-sexp-value-to-internal):
	(widget-sexp-validate):
	(widget-sexp-prompt-value-history):
	(widget-sexp-prompt-value):
	Move to top of sexp section.
	(finder-commentary):
	Redundant autoload removed.
	(widget-princ-to-string):
	Use `prin1-to-string'.  Add docstring.
	(widget-prettyprint-to-string):
	Use `with-temp-buffer'.  Add docstring.
	(widget-convert):
	Use `keywordp'.  Improve comments.
	(symbol widget):
	Change default value to `t' to distinguish from lists.
	(widget-edit-functions):
	Add docstring.
	(widget-field-new):
	(widget-field-list):
	Convert comments to docstrings.
	(widget-default-prompt-value):
	Fix docstring, improve comments.
	(widget-field-add-space):
	(widget-create):
	(widget-create-child-and-convert):
	(widget-create-child):
	(widget-create-child-value):
	(push-button widget):
	(checklist widget):
	(option widget):
	(radio-button-choice widget):
	(radio widget):
	(list widget):
	(vector widget):
	Improve docstrings.

2003-03-06  Ben Wing  <ben@xemacs.org>

	* behavior.el (define-behavior):
	Allow other keywords for forward compatibility.
	
	* cl-macs.el (loop):
	Rewrite to eliminate byte-compiler warning when `return' is used
	without `finally'.
	
	* cmdloop.el (file-error):
	Avoid truncated error messages for `end-of-file' and the like.
	
	* cmdloop.el (read-quoted-char):
	Avoid char-int error after syncing.
	
	* files.el (find-file-noselect):
	* files.el (recover-file):
	* files.el (recover-session-finish):
	Eliminate byte-compile warnings.
	
	* printer.el (generate-header-line):
	Fix line-width calculations.
	#### This used to work.  Someone's changes (perhaps by
	Michael	Sperber?) seem to have messed something up.
	
	* simple.el (clear-message):
	* simple.el (append-message):
	* simple.el (raw-append-message):
	Use new clear-left-side functions to avoid messages ending up on
	the same line as other output.

2003-03-03  Stephen J. Turnbull  <stephen@xemacs.org>

	* files.el (save-abbrevs): Fixup whitespace.

2003-02-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* subr.el (custom-declare-variable-early): Reference
	dumped-lisp.el in comment.

	* custom.el (at end): Remark about `custom-declare-variable-list'.

2003-03-01  Ben Wing  <ben@xemacs.org>

	* cmdloop.el:
	* cmdloop.el (read-quoted-char-radix): New.
	* cmdloop.el (read-quoted-char):
	* cmdloop.el (momentary-string-display):
	* custom.el:
	* custom.el (custom-initialize-set):
	* custom.el (custom-initialize-reset):
	* custom.el (custom-initialize-changed):
	* custom.el (custom-declare-variable):
	* custom.el (defcustom):
	* dumped-lisp.el (preloaded-file-list):
	* files.el:
	* files.el (delete-auto-save-files): New.
	* files.el (directory-abbrev-alist):
	* files.el (make-backup-files):
	* files.el (backup-by-copying-when-privileged-mismatch): New.
	* files.el (normal-backup-enable-predicate): New.
	* files.el (buffer-offer-save):
	* files.el (small-temporary-file-directory): New.
	* files.el (null-device): New.
	* files.el (version-control):
	* files.el (auto-save-file-name-transforms): New.
	* files.el (save-abbrevs):
	* files.el (find-directory-functions): New.
	* files.el (find-file-not-found-hooks):
	* files.el (write-file-hooks):
	* files.el (write-contents-hooks):
	* files.el (write-file-data-hooks):
	* files.el (enable-local-variables):
	* files.el ((fboundp 'file-locked-p)):
	* files.el (view-read-only): New.
	* files.el (cd-absolute):
	* files.el (load-file):
	* files.el (file-local-copy):
	* files.el (file-chase-links):
	* files.el (switch-to-buffer-other-window):
	* files.el (switch-to-buffer-other-frame):
	* files.el (find-file):
	* files.el (find-file-other-window):
	* files.el (find-file-other-frame):
	* files.el (find-file-read-only):
	* files.el (find-file-read-only-other-window):
	* files.el (find-file-read-only-other-frame):
	* files.el (abbreviate-file-name):
	* files.el (find-buffer-visiting):
	* files.el (find-file-wildcards): New.
	* files.el (find-file-suppress-same-file-warnings): New.
	* files.el (find-file-noselect): New.
	* files.el (find-file-noselect-1): New.
	* files.el (insert-file-contents-literally):
	* files.el (insert-file-literally): New.
	* files.el (after-find-file-from-revert-buffer):
	* files.el (after-find-file):
	* files.el (normal-mode):
	* files.el (find-file-literally): New.
	* files.el (dabbrev-case-fold-search):
	* files.el (hack-one-local-variable-quotep): New.
	* files.el (hack-one-local-variable):
	* files.el (set-visited-file-name):
	* files.el (write-file):
	* files.el (backup-buffer):
	* files.el (make-backup-file-name-function): New.
	* files.el (backup-directory-alist): New.
	* files.el (make-backup-file-name):
	* files.el (make-backup-file-name-1): New.
	* files.el (backup-extract-version-start):
	* files.el (backup-extract-version-start)): New.
	* files.el (file-relative-name):
	* files.el (save-buffer):
	* files.el (delete-auto-save-file-if-necessary):
	* files.el (save-buffer-coding-system): New.
	* files.el (basic-save-buffer):
	* files.el (basic-save-buffer-1):
	* files.el (basic-save-buffer-2): New.
	* files.el (save-some-buffers):
	* files.el (save-some-buffers-1):
	* files.el (toggle-read-only):
	* files.el (file-newest-backup):
	* files.el (rename-uniquely):
	* files.el (revert-buffer-insert-file-contents-function):
	* files.el (recover-file):
	* files.el (recover-session):
	* files.el (recover-session-finish):
	* files.el (kill-some-buffers):
	* files.el (wildcard-to-regexp):
	* files.el (file-expand-wildcards): New.
	* files.el (list-directory):
	* files.el (shell-quote-wildcard-pattern): New.
	* files.el (insert-directory-safely): New.
	* files.el (confirm-kill-emacs): New.
	* files.el (save-buffers-kill-emacs):
	* files.el (file-name-non-special): New.
	* keydefs.el (global-map): New.
	* keymap.el:
	* keymap.el (kbd): Removed.
	* keymap.el (substitute-key-definition):
	* lisp-mode.el (construct-lisp-mode-menu):
	* make-docfile.el (custom-declare-variable-list): New.
	* replace.el:
	* replace.el (match-string): Removed.
	* replace.el (save-match-data): Removed.
	* simple.el:
	* simple.el (comment-column): Removed.
	* simple.el (comment-start): Removed.
	* simple.el (comment-start-skip): Removed.
	* simple.el (comment-end): Removed.
	* simple.el (comment-indent-hook): Removed.
	* simple.el (comment-indent-function): Removed.
	* simple.el (block-comment-start): Removed.
	* simple.el (block-comment-end): Removed.
	* simple.el (indent-for-comment): Removed.
	* simple.el (set-comment-column): Removed.
	* simple.el (kill-comment): Removed.
	* simple.el (comment-padding): Removed.
	* simple.el (comment-region): Removed.
	* simple.el (comment-multi-line): Removed.
	* simple.el (set-selective-display):
	* simple.el (indent-new-comment-line): Removed.
	* simple.el (overwrite-mode-textual):
	* simple.el (overwrite-mode):
	* simple.el (binary-overwrite-mode):
	* simple.el (mail-user-agent):
	* simple.el (rfc822-goto-eoh): New.
	* simple.el (sendmail-user-agent-compose):
	* simple.el (mh-e-user-agent):
	* simple.el (set-variable-value-history): New.
	* simple.el (set-variable):
	* simple.el (clone-buffer-hook): New.
	* simple.el (clone-process): New.
	* simple.el (clone-buffer): New.
	* simple.el (clone-indirect-buffer): New.
	* simple.el (clone-indirect-buffer-other-window): New.
	* subr.el:
	* subr.el (custom-declare-variable-list): New.
	* subr.el (custom-declare-variable-early): New.
	* subr.el (assoc-default): New.
	* subr.el (assoc-ignore-case): New.
	* subr.el (assoc-ignore-representation): New.
	* subr.el (member-ignore-case): New.
	* subr.el ('move-marker): New.
	* subr.el ('beep): New.
	* subr.el ('indent-to-column): New.
	* subr.el ('backward-delete-char): New.
	* subr.el ('search-forward-regexp): New.
	* subr.el ('search-backward-regexp): New.
	* subr.el ('remove-directory): New.
	* subr.el ('set-match-data): New.
	* subr.el ('send-string-to-terminal): New.
	* subr.el (make-local-hook):
	* subr.el (add-hook):
	* subr.el (remove-hook):
	* subr.el (add-local-hook):
	* subr.el (remove-local-hook):
	* subr.el (add-one-shot-hook):
	* subr.el (add-local-one-shot-hook):
	* subr.el (string-equal-ignore-case): Removed.
	* subr.el (with-current-buffer):
	* subr.el (with-output-to-string): Removed.
	* subr.el (replace-in-string): Removed.
	* subr.el (split-string): Removed.
	* subr.el (with-temp-message):
	* subr.el (with-syntax-table): New.
	* subr.el (save-match-data): New.
	* subr.el (match-string): New.
	* subr.el (match-string-no-properties): New.
	* subr.el (subst-char-in-string): New.
	* subr.el (replace-regexp-in-string): New.
	* subr.el (truncate-string-to-width):
	* subr.el (eval-after-load):
	* view-less.el:
	* wid-edit.el:
	* wid-edit.el (widget-url-link-action):
	Lots of syncing with FSF 21.2.
	Use if-fboundp in wid-edit.el.
	New file newcomment.el from FSF.

2003-02-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Add markers for use of
	defcustom v. custom-declare-variable-early.

	* make-docfile.el (custom-declare-variable-list): Defvar to prevent
	custom (required from raw-process) from barfing a void-variable error.

2003-02-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* view-less.el (view-minor-mode): Add autoload cookie.

2003-02-28  Ben Wing  <ben@xemacs.org>

	* dump-paths.el:
	* dump-paths.el (startup-setup-paths): Removed.
	* dumped-lisp.el (preloaded-file-list):
	Delete.  Combine stuff into setup-paths.el.
	
	* find-paths.el:
	* find-paths.el (paths-chase-symlink):
	* find-paths.el (paths-emacs-root-p): Removed.
	* find-paths.el (paths-construct-path):
	* find-paths.el (paths-find-emacs-root): Removed.
	* find-paths.el (paths-emacs-data-root-p): Removed.
	* find-paths.el (paths-find-emacs-roots): Removed.
	Make this file contain generic routines only.  Move stuff to
	compute Emacs roots to setup-paths.el.
	
	* startup.el:
	* startup.el (emacs-roots): Removed.
	* startup.el (emacs-data-roots): Removed.
	* startup.el (user-init-directory-base): Removed.
	* startup.el (user-init-directory): Removed.
	* startup.el (user-init-file-base): Removed.
	* startup.el (user-init-file-base-list): Removed.
	* startup.el (user-home-init-file-base-list): Removed.
	* startup.el (load-home-init-file): Removed.
	* startup.el (load-user-init-file-p): Removed.
	Move these variables into setup-paths.el.

	* setup-paths.el:
	* setup-paths.el (emacs-roots): New.
	* setup-paths.el (emacs-data-roots): New.
	* setup-paths.el (user-init-directory-base): New.
	* setup-paths.el (user-init-directory): New.
	* setup-paths.el (user-init-file-base): New.
	* setup-paths.el (user-init-file-base-list): New.
	* setup-paths.el (user-home-init-file-base-list): New.
	* setup-paths.el (load-home-init-file): New.
	* setup-paths.el (load-user-init-file-p): New.
	* setup-paths.el (paths-emacs-root-p): New.
	* setup-paths.el (paths-emacs-data-root-p): New.
	* setup-paths.el (paths-find-emacs-root): New.
	* setup-paths.el (paths-find-emacs-roots): New.
	* setup-paths.el (startup-find-load-path): New.
	* setup-paths.el (startup-setup-paths): New.
	* setup-paths.el (configure-package-path): New.
	* setup-paths.el (startup-find-load-path-for-packages): New.
	* startup.el (normal-top-level):
	* startup.el (startup-find-roots-warning): Removed.
	Combine all high-level code for computing the paths into
	setup-paths.el.  Create new function startup-find-load-path to
	encapsulate all logic for computing `load-path'.  Eliminate
	invocation-directory and invocation-name parameters since
	there is no point (false generality) -- the code references
	other globals, which cannot be specified.  Eliminate some code
	duplicated between setup-paths.el and startup.el.  Clean up
	the debug-paths code and output load-path in addition.
	Add logic to paths-emacs-root-p to support separated source
	and build trees.

	* loadup.el:
	* loadup.el (build-root): New.
	* loadup.el (source-lisp): New.
	* loadup.el (source-root): New.
	* loadup.el (really-early-error-handler):
	* make-docfile.el:
	* make-docfile.el (build-root): New.
	* make-docfile.el (build-lib-src): New.
	* make-docfile.el (source-lisp): New.
	* make-docfile.el (source-src): New.
	* make-docfile.el (process-args):
	* make-docfile.el (load-path):
	* make-docfile.el ("raw-process.el"):
	* make-docfile.el ((preloaded-file-list)):
	* make-docfile.el (docfile-out-of-date):
	* update-elc-2.el (batch-update-elc-2):
	* update-elc.el:
	* update-elc.el (undumped-exe): Removed.
	* update-elc.el (dumped-exe-out-of-date-wrt-dump-files): Removed.
	* update-elc.el (exe-target): New.
	* update-elc.el (dump-target): New.
	* update-elc.el (dump-target-out-of-date-wrt-dump-files): New.
	* update-elc.el (build-root): New.
	* update-elc.el (source-lisp): New.
	* update-elc.el (source-lisp-mule): New.
	* update-elc.el (source-root): New.
	* update-elc.el (aa-lisp): New.
	* update-elc.el (aac-lisp): New.
	* update-elc.el (aa-lisp-mule): New.
	* update-elc.el (aac-lisp-mule): New.
	* update-elc.el ((preloaded-file-list site-load-packages files-to-process)):
	Rewrite to allow for separated source and build trees, as may occur
	in MS Windows.
	
	NOTE TO BUILD HACKERS:
	
	loadup.el, make-docfile.el, update-elc.el and update-elc-2.el made two
	assumptions that are no longer correct:
	
	(1) The source and build trees are in the same place.
	(2) They can make assumptions about where `.' is.
	
	These files now compute the locations of the source and build
	roots at the top of the file.  *ALL* constant file names or path
	snippets must now be made absolute using expand-file-name and one
	of these roots.

	* dumped-lisp.el:
	* dumped-lisp.el (packages-hardcoded-lisp): New.
	* packages.el:
	* packages.el (packages-hardcoded-lisp): Removed.
	* packages.el (packages-useful-lisp): Removed.
	* packages.el (packages-unbytecompiled-lisp): Removed.
	Remove some unused lists of Lisp files.  packages-hardcoded-lisp
	(empty, in any case) moved to dumped-lisp.el.
	
	* startup.el (find-init-file-1): New.
	* startup.el (find-user-home-directory-init-file):
	When a compiled init file is out-of-date wrt the uncompiled
	version, load the uncompiled version and issue a nasty warning.
	
	* update-elc-2.el (batch-update-elc-2):
	Force touching of auto-autoloads files when REBUILD_AUTOLOADS
	was set.

	* update-elc.el ((preloaded-file-list site-load-packages files-to-process)):
	Fix code that checks whether dumping is necessary to check against
	xemacs.dmp, not xemacs.exe, when Unix and pdump.
	
2003-02-20  Ben Wing  <ben@xemacs.org>

	* mule/mule-cmds.el:
	* mule/mule-cmds.el (get-native-coding-system-from-language-environment):
	* mule/mule-cmds.el (set-language-environment-coding-systems):
	* mule/mule-cmds.el (init-locale-at-early-startup):
	Alias file-name to native not vice-versa.
	Do set EOL of native but not of process output to fix various
	problems and be consistent with code-init.el.

2003-02-20  Ben Wing  <ben@xemacs.org>

	* code-cmds.el (coding-system-change-eol-conversion):
	Return a name not a coding system.
	
	* code-init.el:
	* code-init.el (coding-system-default-variable-list):
	* code-init.el (get-coding-system-variable):
	* code-init.el (set-coding-system-variable):
	* code-init.el (coding-system-variable-default-value):
	Reindent.  Remove `file-name' since it should always be the same
	as native.
	
	* unicode.el (load-unicode-tables):
	Rename to load-unicode-mapping-table as suggested by the anonymous
	(but rather Turnbullian) comment in unicode.c.

2003-02-19  Ben Wing  <ben@xemacs.org>

	* mule/mule-msw-init.el:
	* mule/mule-msw-init.el ('mswindows-multibyte-system-default): Removed.
	Delete this file.

	* mule/mule-win32-init.el:
	New file, with stuff from mule-msw-init.el -- not just for MS Windows
	native,	boys and girls!

	* bytecomp.el (byte-compile-insert-header):
	Change code inserted to catch trying to load a Mule-only .elc
	file in a non-Mule XEmacs.  Formerly you got the rather cryptic
	"The required feature `mule' cannot be provided".  Now you get
	"Loading this file requires Mule support".
	
	* finder.el (finder-compile-keywords):
	Remove dependency on which directory this function is invoked
	from.

	* update-elc.el:
	Don't mess around with ../src/BYTECOMPILE_CHANGE.  Now that
	Makefile.in.in and xemacs.mak are in sync, both of them use
	NEEDTODUMP and the other one isn't used.

	* dumped-lisp.el:
	* dumped-lisp.el (preloaded-file-list):
	Rewrite in terms of `list' and `nconc' instead of assemble-list, so
	we can have arbitrary forms, not just `when-feature'.

	* very-early-lisp.el: Nuke this file.

	* finder-inf.el:
	* packages.el:
	* update-elc.el:
	* update-elc-2.el:
	* loadup.el:
	* make-docfile.el:
	Eliminate references to very-early-lisp.

	* msw-glyphs.el:
	Comment clarification.

2003-02-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/mule-charset.el (charsets-in-region): Remove broken
	optimization to get slight speed-up.
	(charsets-in-string): Use mapc to iterate in C.

2003-02-16  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.11 "cabbage" is released.

2003-02-15  Ben Wing  <ben@xemacs.org>

	* make-docfile.el:
	* make-docfile.el (message): New.
	* make-docfile.el (format-decode): New.
	* make-docfile.el (process-args): New.
	* make-docfile.el ((preloaded-file-list)):
	* make-docfile.el (docfile-out-of-date):
	Use `message' (defined in this file) in place of `princ'/`print',
	and put in a terpri, so that we get correct newline behavior.
	Rewrite if-progn -> when and a few similar stylistic niceties.
	And the big change: Allow MS Windows to specify the object files
	directly and frob them into C files here (formerly this was done
	in xemacs.mak, and very slooooooooooooooooooowly).  Due to
	line-length limitations in CMD, we need to use a "response file"
	to hold the arguments, so when we see a response file argument
	(preceded by an @), read in the args (a bit of trickiness to do
	this), and process recursively.  Also frob .obj -> .c as mentioned
	earlier and handle other junk dependencies that need to be removed
	(NEEDTODUMP, make-docfile.exe).
	
	* update-elc-2.el (do-update-elc-2):
	Use :test `equal' in call to set-difference.
	
	* update-elc.el:
	Put back commented out kill-emacs, update header comment.

2003-02-14  Ben Wing  <ben@xemacs.org>

	* autoload.el (generate-file-autoloads):
	Include FUNLIST argument to generate-c-file-autoloads-1.

2003-02-14  Ben Wing  <ben@xemacs.org>

	* byte-optimize.el:
	* byte-optimize.el (byte-compile-inline-expand):
	* byte-optimize.el (byte-compile-unfold-lambda):
	* byte-optimize.el (byte-optimize-form-code-walker):
	* byte-optimize.el (byte-optimize-form):
	* byte-optimize.el (byte-decompile-bytecode-1):
	* byte-optimize.el (byte-optimize-lapcode):
	Review carefully and sync up to 20.7 except for areas as noted.
	Fixes problem with JDE compilation.

2003-02-14  Ben Wing  <ben@xemacs.org>

	* autoload.el:
	* autoload.el (generate-file-autoloads):
	* autoload.el (generate-autoload-ish-1):
	* autoload.el (generate-file-autoloads-1):
	* autoload.el (generate-c-file-autoloads-1):
	Factor out common code in generate-{c-,}file-autoloads-1 into new
	function generate-autoload-ish-1.  \(I was originally going to use
	this for custom as well but ended up thinking better of it.)
	
	* cus-dep.el:
	* cus-dep.el (cusload-hash-table-marker): New.
	* cus-dep.el (Custom-make-dependencies-1):
	Cache the old computed values in custom-load.el and reuse them as
	necessary, to speed up running cus-dep (which would take 25-30
	seconds to do all files in lisp/*, lisp/*/* on my Pentium III
	700).  Use `message' not `princ' to get correct newline behavior.
	Output messages showing each file we do actually process.
	
	* update-elc-2.el:
	* update-elc-2.el (dirfiles-table): New.
	* update-elc-2.el (do-update-elc-2):
	* update-elc-2.el (batch-update-elc-2):
	Rewrite algorithm to be much faster -- cache calls to
	directory-files and don't make needless calls to file-exists-p,
	file-directory-p because they're way way slow.
	Autoload early and only when update-elc has told us to.

	* update-elc.el:
	* update-elc.el (dumped-exe): Removed.
	* update-elc.el (dumped-exe-out-of-date-wrt-undumped-exe): Removed.
	* update-elc.el (lisp-files-ignored-when-checking-for-autoload-updating): New.
	* update-elc.el ((preloaded-file-list site-load-packages files-to-process)):
	If no files need byte compilation, signal to update-elc-2 to do
	any necessary autoload updating (using the file REBUILD_AUTOLOADS)
	rather than doing it ourselves, which would be way slow.  Ignore
	updates to custom-load.el and auto-autoloads.el when checking to
	see whether autoloads need updating.  Optimize out many
	unnecessary calls to file-exists-p to speed it up somewhat. (####
	The remaining time is 50% or more in locate-file; this is
	presumably because, even though it has a cache, it's still
	statting each file to determine it's actually there.  By calling
	directory-files ourselves, building a tree, and then looking in
	that tree, we could drastically shorten the time needed to do the
	locate operation.)
	
2003-02-12  Jerry James  <james@xemacs.org>

	* about.el (about-url-alist): Add my home page.
	* about.el (about-personal-info): Flatter myself.

2002-11-01  Ilpo Nyyss~nen  <iny@iki.fi>

	* mule/mule-cmds.el (finish-set-language-environment): Fix for
	call to set-language-unicode-precedence-list.

2003-02-09  Ben Wing  <ben@xemacs.org>

	* window.el (walk-windows):
	walk-windows was broken when a frame was given to WHICH-FRAMES.
	it would loop forever.  The FSF version fixes this but i didn't
	sync to them because (a) it conses (bad for lazy-lock), (b) it
	calls select-window.

2003-02-07  Ben Wing  <ben@xemacs.org>

	* hyper-apropos.el:
	* hyper-apropos.el (hyper-apropos):
	* hyper-apropos.el (hyper-apropos-grok-functions):
	* hyper-apropos.el (hyper-apropos-grok-variables):
	Separate obsolete and non-obsolete stuff and make sure we note
	when obsolete funs are just aliases for others.  Also fix some
	problems with doc string hacking.
	
	* menubar-items.el:
	* menubar-items.el (default-menubar):
	Change the Help->Info submenu a bit.
	
	* text-props.el (text-property-any):
	* text-props.el (text-property-not-all):
	Fix bug when end > start.
	
	* update-elc.el (unbytecompiled-lisp-files):
	Add raw-process.el.

2002-12-27  Stephen J. Turnbull  <stephen@xemacs.org>

	Synch to GNU Emacs 21.3.50:

	* wid-edit.el: Update Copyright notice and Commentary.
	(other):
	(float):
	(plist):
	(widget-plist-value-type):
	(widget-plist-convert-widget):
	(widget-plist-convert-option):
	(alist):
	(widget-alist-value-type):
	(widget-alist-convert-widget):
	(widget-alist-convert-option):
	New widgets and ancillary objects.
	(coding-system):
	(widget-coding-system-prompt-value-history):
	(widget-coding-system-prompt-value):
	(widget-coding-system-prompt-action):
	Reenabled widget.
	(default): Use `ignore' instead of lambda form.
	(editable-field): New help-echo, better error.
	(text): Use conventional argument order.
	(character): Specify :size property.
	(widget-menu-max-shortcuts): New user variable.
	(widget-remove-if):
	(widgetp):
	(widget-copy):
	(widget-types-copy):
	(widget-field-at):
	New functions.
	(widget-convert): Use keywordp.
	(widget-insert): Auto-autoload.
	(widget-types-convert-widget): Make defsubst.
	(widget-convert):
	(widget-get-sibling):
	(widget-insert):
	(widget-default-complete):
	(widget-item-value-create):
	(widget-field-prompt-value):
	(widget-field-validate):
	(widget-choice-validate):
	(widget-radio-value-inline):
	(widget-editable-list-value-create):
	(widget-regexp-validate):
	(widget-file-complete):
	(widget-color-complete):
	Eliminate pointless let-bindings.
	(widget-field-find): Delete old version; comment XEmacs use of
	map-extents.
	(widget-default-create):
	(widget-checklist-add-item):
	(widget-radio-add-item):
	(widget-radio-chosen):
	(widget-editable-list-entry-create):
	(widget-documentation-string-value-create):
	Insert characters, not one-element strings.
	(widget-default-create): Use stream argument of princ.
	(widget-default-format-handler): Check functionp before funcalling.
	(widget-url-link-action): Fix if-fboundp typo and too-long line.
	(widget-sublist):
	(cons :value-to-external):
	Use Common Lisp functions.
	(widget-echo-help):
	(widget-default-value-set):
	Use `if' rather than `and' and `when'.
	(widget-princ-to-string):
	(widget-specify-sample):
	(widget-specify-doc):
	(widget-glyph-directory):
	(widget-glyph-enable):
	(widget-after-change):
	Docstrings from comments or improve docstrings.
	(widget-image-conversion): New GNU Emacs-compatible alias.
	(widget-field-face): Handle light-background TTYs.

2003-02-06  Stephen J. Turnbull  <stephen@xemacs.org>

	* update-elc.el (lisp-files-needing-early-byte-compilation):
	Comment referred to wrong variable.
	(do-autoload-commands ...): Remove duplicate comment.

2003-02-05  Ben Wing  <ben@xemacs.org>

	* mule/cyril-util.el:
	* mule/cyril-util.el (standard-display-table):
	* mule/cyril-util.el (standard-display-table)): New.
	Fix compile warning.

2003-02-05  Ben Wing  <ben@xemacs.org>

	* loadup.el:
	* loadup.el (really-early-error-handler):
	* loadup.el (load-warn-when-source-only):
	* loadup.el ((member "dump" command-line-args)):
	* make-docfile.el:
	* update-elc-2.el:
	* update-elc.el:
	Set stack-trace-on-error, load-always-display-messages so we
	get better debug results.

	* update-elc-2.el (batch-update-elc-2):
	Fix typo in name of lisp/mule, leading to compile failure.

	* simple.el:
	* simple.el (motion-keys-for-shifted-motion):
	Omit M-S-home/end from motion keys.
	
	* update-elc.el (undumped-exe): New.
	* update-elc.el (dumped-exe): New.
	* update-elc.el (dumped-exe-out-of-date-wrt-dump-files): New.
	* update-elc.el (dumped-exe-out-of-date-wrt-undumped-exe): New.
	* update-elc.el ("very-early-lisp.el"):
	* update-elc.el (lisp-files-needed-for-byte-compilation): New.
	* update-elc.el (lisp-files-needing-early-byte-compilation): New.
	* update-elc.el (unbytecompiled-lisp-files): New.
	* update-elc.el ((preloaded-file-list site-load-packages files-to-process)):
	Overhaul:

	-- allow list of "early-compile" files to be specified, not hardcoded
	-- fix autoload checking to include all .el files, not just dumped ones
	-- be smarter about regenerating autoloads, so we don't need to use
	   loadup-el if not necessary
	-- use standard methods for loading/not loading auto-autoloads.el
	   (maybe fixes "Already loaded" error?)
	-- rename misleading NOBYTECOMPILE flag file.
	
	* window-xemacs.el (window-list):
	Fix bug in default param.
	
	* window-xemacs.el (really-set-window-configuration):
	* window-xemacs.el (restore-saved-window-parameters):
	Fix compile warnings.

2003-02-02  Steve Youngs  <youngs@xemacs.org>

	* about.el (xemacs-hackers): Add Jerry, Ville, 
	(about-current-release-maintainers): Remove Martin, Jason.  Add
	Jerry, Ville.
	(about-other-current-hackers): Add Martin, Jason.
	(about-personal-info): Update me.  Add Jerry, Ville.
	(about-hacker-contribution): Update me, Martin, Steve T.  Add
	Jerry, Ville.

2003-01-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* autoload.el: Drastically reorganized.

	API improvement:

	(autoload-target-directory): 
	(batch-update-autoloads): 
	(batch-update-directory): 
	(batch-update-one-directory): 
	(batch-force-update-one-directory):
	Deprecated.
	(autoload-feature-prefix): New special.
	(autoload-package-name): Obsolete alias for autoload-feature-prefix.
	(autoload-batch-update-autoloads): New function.  Main
	command-line API.

	Documentation:

	Improve many docstrings.
	(Header summary): Update.
	(Commentary): Completely rewritten.
	(ChangeLog): Redundant, so removed.

	General sanitation:

	(generated-autoload-file): Default changed to lisp-directory.
	(generate-file-autoloads): Better argument checking.
	(generate-c-file-autoloads-1): Make the output code prettier,
	clean up long lines.
	(autoload-featurep-protect-autoloads):
	(autoload-make-feature-name):
	New functions for handling feature checking and provide'ing.
	(update-autoload-files): Use them.  Don't try tricky things to
	guess feature names.
	(update-autoloads-here): Remove extra arg to a call
	to format.  Warn of probable bitrot in the docstring.
	(batch-force-update-one-directory):
	(batch-update-one-directory):
	Fix typo in error message.

	Related changes:

	* update-elc.el: Use `autoload-update-directory-autoloads'.

	* update-elc-2.el (batch-update-elc-2): Use full API for
	`update-autoload-files'.

	* startup.el (startup-load-autoloads): Oops.  Ben generates Mule
	autoloads in lisp/mule, Mike doesn't load them in startup.el.
	Also, use `when' and `unless' for clarity.
	(command-line): Comment typo.
	(splash-frame-body): Grammatical nits.

2003-01-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* info.el (Info-insert-dir): Make default-directory end in
	separator.  Patch due to Martin Buchholz.

2003-01-10  Mike Sperber  <mike@xemacs.org>

	* window-xemacs.el: Revert his change
	
		2003-01-10  Mike Sperber  <mike@xemacs.org>

		* window-xemacs.el (window-reduce-to-one): Rewrite in terms of
		`delete-other-windows.'
		(window-find-buffer-subwindow): Add.

	It caused subtle breakage.  (And add a comment to that effect.)
	
2003-01-13  Mike Sperber <mike@xemacs.org>

	* packages.el: 
	* find-paths.el: Revert this change

		2000-04-01  Mike Sperber  <mike@xemacs.org>

		* packages.el (packages-find-package-directories): Added support
		for external package hierarchies with in-place installations.

		* find-paths.el (paths-root-in-place-p): Added.
		(paths-find-emacs-directory): Added support for external
		directories with in-place installations.
		(paths-find-site-directory): Ditto.

2003-01-19  Mike Sperber  <mike@xemacs.org>

	* startup.el (normal-top-level): Compute `emacs-data-roots.'  Call
	`startup-setup-paths' with data-roots argument.
	(emacs-data-roots): Add.

	* dump-paths.el: Call `startup-setup-paths' with
	data-roots argument.
	(startup-setup-paths): Use `data-roots' instead of `roots' to find
	packages.
	Call `paths-find-emacs-roots' with `root-p' argument.

	* make-docfile.el: Call `paths-find-emacs-roots' with `root-p' argument.

	* find-paths.el (paths-emacs-data-root-p): Add.
	(paths-find-emacs-roots): Parmeterize over `root-p.'

2003-01-13  Ilya Golubev  <golubev@xemacs.org>

	* about.el: Update golubev data.

2003-01-10  Mike Sperber  <mike@xemacs.org>

	* window-xemacs.el (window-reduce-to-one): Rewrite in terms of
	`delete-other-windows.'
	(window-find-buffer-subwindow): Add.

2003-01-09  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/japan-util.el (setup-japanese-environment-internal):
	usg-unix-v is not a suitable catchall.

	* mule/viet-util.el: 
	* mule/ethio-util.el:
	characater -> character.

	* mule/cyril-util.el (cyrillic-language-alist): There is no such
	language as Serbo-Croatian, according to Hrvoje, who oughtta know.

2003-01-04  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.10 "burdock" is released.

2002-12-27  Stephen J. Turnbull  <stephen@xemacs.org>

	* wid-edit.el: Synch trivia to GNU Emacs 21.3.50.  Make docstrings
	from comments, fix typos & whitespace, add some comments and fixmes.

2002-12-17  Daiki Ueno  <daiki@xemacs.org>

	* process.el (shell-command-to-string): Synch with GNU Emacs 21.

2002-12-15  Ben Wing  <ben@xemacs.org>

	* ChangeLog: Combine all ChangeLog files.
	* ChangeLog.1: Deleted.

2002-12-14  Ben Wing  <ben@xemacs.org>

	* window-xemacs.el (restore-saved-window-parameters):
	Don't override point motion when restoring window start, or
	`M-x goto-line' doesn't work.

2002-12-03  John Paul Wallington  <jpw@shootybangbang.com>

	* cus-start.el (garbage-collection-messages): Add.

2002-12-02  Mike Sperber <mike@xemacs.org>

	* The Great Window Configuration rewrite: Re-implement window
	configuration functionality in Emacs Lisp.

	* window-xemacs.el (current-window-configuration): 
	(set-window-configuration): (plus many functions they depend on)
	Re-implement window configurations in Emacs Lisp.

2002-12-03  Didier Verna  <didier@xemacs.org>

	* faces.el (set-face-background-pixmap-file): Ensure default value
	can be computed.

2002-12-03  Didier Verna  <didier@xemacs.org>

	* faces.el (background-pixmap-file-history): New.
	* faces.el (set-face-background-pixmap-file): New.

2002-11-28  Mike Sperber <mike@xemacs.org>

	* window.el (save-window-excursion): New macro to eventually
	replace the bytecode instruction of that name.

2002-11-16  Mike Sperber <mike@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Move window.el & neighbors
	further up because other some files further down import macro(s)
	from it.

2002-11-26  Mike Sperber <mike@xemacs.org>

	* window.el (shrink-window-if-larger-than-buffer): Elide braindead
	use of `save-window-excursion'.

2002-11-28  Mike Sperber <mike@xemacs.org>

	* dialog.el (make-dialog-box): `set-frame-pixel-size' ->
	`set-frame-displayable-pixel-size,' following the
	`frame-pixel-xxx' reorganization in src/frame.c.

2002-11-27  Ben Wing  <ben@xemacs.org>

	* cl-macs.el (loop): Document better.

	* cmdloop.el:
	* cmdloop.el (command-error):
	* cmdloop.el (breakpoint-on-error): Removed.
	Remove nonworking breakpoint-on-error now that debug-on-error
	works as documented.

	* help.el:
	* help.el (temp-buffer-mode): New.
	* help.el (Commands): New.
	* help.el (temp-buffer-mode-map): New.
	* help.el (mode-for-temp-buffer): New.
	* help.el (with-displaying-help-buffer): Removed.
	* help.el (with-displaying-temp-buffer): New.
	Extract out with-displaying-help-buffer into a more general
	mechanism.

	* lib-complete.el:
	* lib-complete.el (find-library-source-path):
	* lib-complete.el (find-library):
	Support thunks in find-library-source-path.

	* startup.el (normal-top-level):
	Don't catch errors when noninteractive, because that makes
	stack traces from stack-trace-on-error useless.

2002-11-17  Ben Wing  <ben@xemacs.org>

	* code-files.el (load):
	* loadhist.el (unload-feature):
	Fix warnings.

	* package-get.el (package-get-update-base-from-buffer):
	Fix warnings.

	NOTE: This was already fixed awhile ago, but reverted by Steve Y.
	Please be careful.

2002-10-14  Jerry James  <james@xemacs.org>

	* gtk-font-menu.el (gtk-reset-device-font-menus): Simplify code
	that previously could not depend on LISP_FLOAT_TYPE.
	* x-font-menu.el (x-reset-device-font-menus): Ditto.

2002-11-12  Stephen J. Turnbull  <stephen@xemacs.org>

	Synch to 21.4 (suggested by Edward M. Lee <edward@tailifer.com>):

	* font-menu.el (font-menu-set-font): Make sure values for family,
	size, and weight are defaulted non-nil.  Fix indentation.
	(font-menu-size-scaling):
	(font-menu-preferred-resolution):
	Provide specs for GTK+.

2002-11-03  Mike Sperber <mike@xemacs.org>

	* code-process.el (call-process-region): Preserve return value
	from `call-process.'

2002-10-25  Scott Evans  <gse@antisleep.com>

	* replace.el (operate-on-non-matching-lines)
	(operate-on-non-matching-lines): Generalized from
	delete-non-matching-lines and delete-matching-lines.  The
	"operate" versions work with regions, can copy to the kill ring,
	and return the number of lines copied/deleted.
	(delete-non-matching-lines): Use operate-on-non-matching-lines.
	(delete-matching-lines): Use operate-on-matching-lines.
	(kill-non-matching-lines): New.
	(copy-non-matching-lines): New.
	(kill-matching-lines): New.
	(copy-matching-lines): New.

2002-10-24  Andy Piper  <andy@xemacs.org>

	* dialog.el (make-dialog-box): for general dialogs only
	delete-frame-hook will be run.

2002-10-10  Jerry James  <james@xemacs.org>

	* autoload.el (generate-file-autoloads-1): Use new print-autoload
	margin parameter.
	* autoload.el (generate-c-file-autoloads-1): Ditto.  Fix typo in
	docstring.  Conditionalize module autoloads on the presence of the
	module in module-directory.
	* autoload.el (print-autoload): New margin parameter to prettify
	module auto-autoloads without affecting Lisp auto-autoloads.
	* dump-paths.el (startup-setup-paths): Always set
	module-directory, site-module-directory, and module-load-path,
	even when not called-early.

2002-09-22  Ville Skyttä  <ville.skytta@xemacs.org>

	* package-get.el (package-get-download-sites): Bring sites list
	up to date, prefer xx.xemacs.org addresses.

2002-09-12  John Paul Wallington  <jpw@shootybangbang.com>

	* hyper-apropos.el (hyper-apropos-popup-menu): Add "Find Variable"
	menu entry for `hyper-apropos-find-variable'.

2002-09-03  John Paul Wallington  <jpw@shootybangbang.com>

	* help.el (view-lossage): Change interactive spec to "P".

2002-09-03  John Paul Wallington  <jpw@shootybangbang.com>

	* subr.el (with-output-to-string): Synch with GNU Emacs 21;
	avoids leaking temp buffers by killing rather than erasing
	them, and doesn't execute BODY in temporary `standard-output'
	buffer.

2002-10-07  Katsumi Yamaoka  <yamaoka@jpl.org>

	* keydefs.el (global-map): Bind C-xrd to delete-rectangle per GNU.

2002-10-03  Stephen J. Turnbull  <stephen@xemacs.org>

	* font-lock.el (font-lock-compile-keywords): Improve docstring.

2002-09-22  Ville Skyttä  <ville.skytta@xemacs.org>

	* files.el (auto-mode-alist): Move entries for modes in packages
	to the corresponding modes.
	(interpreter-mode-alist): Ditto.

2002-09-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* obsolete.el (parse-sexp-lookup-properties): new compatible alias
	for `lookup-syntax-properties'.  RFE from Alan Mackenzie.

2002-08-08  Jerry James  <james@xemacs.org>

	* autoload.el (make-c-autoload): New function for reading autoload
	markers in C files.
	* autoload.el (generate-c-autoload-cookie): New variable.
	* autoload.el (generate-c-autoload-module): New variable.
	* autoload.el (generate-file-autoloads): Do C autoloads, too.
	* autoload.el (generate-file-autoloads-1): Use print-autoload.
	* autoload.el (generate-c-file-autoloads-1): New function.
	* autoload.el (print-autoload): New function to abstract the
	printing of autoload forms.
	* autoload.el (update-file-autoloads): Do C autoloads, too.
	* autoload.el (update-autoloads-from-directory): Ditto.
	* code-files.el (load): Pass the pathless filename to load-module.
	* loadhist.el (unload-feature): Set unloading-module when a
	module marker is seen in load-history.  Call unload-module if
	unloading-module is non-nil.
	* startup.el (startup-load-autoloads): Look for module autoloads.
	* update-elc-2.el (batch-update-elc-2): Generate module
	autoloads.

2002-09-02  Ville Skyttä  <ville.skytta@xemacs.org>

	* bytecomp-runtime.el (make-obsolete): Docstring argument nit.
	(make-obsolete-variable): Ditto.
	(make-compatible): Ditto.
	(make-compatible-variable): Ditto.

2002-07-12  Andy Piper  <andy@xemacs.org>

	* custom.el (custom-theme-set-variables): remove bogus
	arguments. Use custom-set-default to set defaults.
	(custom-set-variables): update doc.
	(custom-local-buffer): new, synced from FSF.
	(custom-set-default): ditto.
	(defcustom): update doc.

2002-07-23  Andy Piper  <andy@xemacs.org>

	* about.el (about-personal-info): update me.

2002-08-28  Andy Piper  <andy@xemacs.org>

	* files.el (revert-buffer): propagate revert-without-query-status.

2002-08-31  Seiichi Ikiuo  <ikiuo@polyphony.co.jp>

	* code-init.el (reset-coding-categories-to-default): Add new
	coding category 'utf-8-bom'.

	* coding.el (coding-system-category): Add check for 'utf-8-bom'.

	* unicode.el: Add new coding system 'utf-8-bom'.

2002-08-30  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.9 "brussels sprouts" is released.

2002-08-16  Steve Youngs  <youngs@xemacs.org>

	* build-report.el (build-report-installation-version-regexp):
	Update to cater for 'xemacs-extra-name'.
	(build-report-version-file-regexp): Ditto.
	(build-report): Ditto.
	(build-report-installation-data): Ditto.
	(build-report-version-file-data): Ditto.

	* version.el (emacs-version): Test for 'xemacs-extra-name'.

2002-08-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* autoload.el (make-autoload): Make comment more precise.  Support
	docstring for define-derived-mode.

2002-08-13  Stephen J. Turnbull  <stephen@xemacs.org>

	* startup.el (command-line-do-help): Fix typo in help string.

2002-08-11  John Paul Wallington  <jpw@shootybangbang.com>

	* simple.el (join-line): New alias for `delete-indentation'.

2002-08-03  Steve Youngs  <youngs@xemacs.org>

	* lib-complete.el (find-library): Remove check for mule because
	decompression DOES work on Mule.

2002-05-29  Katsumi Yamaoka  <yamaoka@jpl.org>

	* mule/japan-util.el (setup-japanese-environment-internal): Use
	proper coding-systems.

2002-05-28  Katsumi Yamaoka  <yamaoka@jpl.org>

	* mule/japan-util.el: Use `characterp' instead of `integerp' while
	defining char properties for katakana.

	* mule/mule-category.el: Clear the category table before defining
	categories for `predefined-category-list'.

	* mule/mule-cmds.el (finish-set-language-environment): Fit the
	charsets preferences in unicode conversions for the language
	environment.  Suggested by ARISAWA Akihiro <ari@mbf.sphere.ne.jp>.

2002-08-02  Ville Skyttä  <ville.skytta@xemacs.org>

	* font-lock.el: Some faces and doc typo fixes from GNU Emacs.
	(font-lock-doc-face): New alias to font-lock-doc-string-face.
	(font-lock-builtin-face): New.
	(font-lock-constant-face): New.
	(font-lock-face-list): Add builtin and constant faces.

2002-07-27  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.8 "broccoli" is released.

2002-06-04  John H Palmieri  <palmieri@math.washington.edu>

	* gutter-items.el (buffers-tab-omit-function): Default value is
	now `buffers-tab-omit-some-buffers'.
	* gutter-items.el (buffers-tab-omit-list): New customizable
	variable, specifying which buffers to omit from buffers tab.
	* gutter-items.el (buffers-tab-omit-some-buffers): New function
	which uses buffers-tab-omit-list.

2002-07-21  John Paul Wallington  <jpw@xemacs.org>

	* process.el (substitute-env-vars): New function; sync with
	GNU Emacs 21.1.50.
	(setenv): Add optional arg SUBSTITUTE-ENV-VARS; sync with
	GNU Emacs 21.1.50.

2002-07-17  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-update-base-from-buffer): Re-write
	so it doesn't rely on the APEL package.

2002-07-16  Didier Verna  <didier@xemacs.org>

	* subr.el (replace-in-string): fix case fold bug introduced by
	"2000-07-30  Ben Wing  <ben@xemacs.org>": honor the value of
	case-fold-search in temporary buffers.

2002-07-01  Mike Alexander  <mta@arbortext.com>

	* code-process.el (call-process-region): Don't delete the process
	output if start equals end

2002-07-14  Mike Alexander  <mta@arbortext.com>

	* process.el (shell-command-on-region): Don't delete the region
	before giving it to call-process-region

2002-07-14  Adrian Aichner  <adrian@xemacs.org>

	* ChangeLog: It's XEmacs, not Xemacs.

2001-07-10  Katsumi Yamaoka  <yamaoka@jpl.org>

	* mule/kinsoku.el (kinsoku-bol-p): Work with ascii and non-ascii
	mixed text.
	(kinsoku-eol-p): Ditto.

2001-07-09  Katsumi Yamaoka  <yamaoka@jpl.org>

	* mule/kinsoku.el (kinsoku-ascii-eol, kinsoku-gb-bol,
	kinsoku-gb-eol, kinsoku-big5-bol, kinsoku-big5-eol): Assign
	characters as the category `s' or `e' correctly.

2002-06-26  John Paul Wallington  <jpw@shootybangbang.com>

	* derived.el (define-derived-mode): Put `derived-mode-parent'
	property on child.
	(derived-mode-p): New function; sync with GNU Emacs 21.

2002-06-16  Andy Piper  <andy@xemacs.org>

	* menubar-items.el (default-menubar): enable windows printing on
	cygwin as well as native.

2002-06-12  Andy Piper  <andy@xemacs.org>

	* printer.el (generic-print-buffer): catch all errors so that the
	print device can be cleared in all scenarios.
	(Printer-clear-device): make sure clearing the printer allows it
	to be used again immediately.
	(generic-print-region): make sure the default printer face is
	black-on-white.

2002-04-23  Jerry James  <james@xemacs.org>

	* window-xemacs.el (display-buffer-function): Change doc to
	reflect new arg.
	* window-xemacs.el (pre-display-buffer-function): Ditto.
	* window-xemacs.el (display-buffer): New arg, shrink-to-fit.  If
	non-nil, make the new window just big enough for its contents.
	* frame.el (get-frame-for-buffer): Accept new arg, due to above.
	* frame.el (show-temp-buffer-in-current-frame): Remove broken
	temp-buffer-shrink-to-fit code.  Tell display-buffer instead.

2002-06-06  Andy Piper  <andy@xemacs.org>

	* gutter-items.el (buffers-tab-filter-functions): fix typo.

2002-06-06  Andy Piper  <andy@xemacs.org>

	* custom.el (custom-theme-set-variables): sync :set-after from FSF.
	(defcustom): ditto.
	(custom-handle-keyword): ditto.

2002-06-04  John H Palmieri  <palmieri@math.washington.edu>

	* gutter-items.el (buffers-tab-selection-function): fix
	documentation, make obsolete.
	* gutter-items.el (buffers-tab-filter-functions): change default
	value (but not default behavior), reword documentation.

2002-06-27  Olivier Galibert  <galibert@pobox.com>

	* behavior.el (enabled-behavior-list): Sort the lists for the
	assert comparison.

2002-07-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.7 "broccoflower" is released.

2002-06-27  Mike Sperber <mike@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Added post-gc.el.

	* post-gc.el: Create.

2002-06-24  John Paul Wallington  <jpw@shootybangbang.com>

	* obsolete.el (frame-parameter): New compatibility function.
	(makehash): Ditto.
	(buffer-local-value): Ditto.
	(line-beginning-position): New compatibility alias for `point-at-bol'.
	(line-end-position): New compatibility alias for `point-at-eol'.

	* subr.el (with-temp-message): New function; sync with GNU Emacs 21.
	(bound-and-true-p): Ditto.
	(propertize): New function.
	(delete-and-extract-region): Ditto.

2002-06-24  Jerry James  <james@xemacs.org>

	* code-files.el (load): Look for a binary module if no Lisp file
	with the correct name is found.

2002-06-22  Ville Skyttä  <ville.skytta@xemacs.org>

	* subr.el (add-to-list): Sync with GNU Emacs 21.2, adding the
	"&optional append" argument.

2002-06-23  Stephen J. Turnbull  <stephen@xemacs.org>

	* unicode.el (load-unicode-tables): Comment loading 8859-1.TXT.

2002-06-20  Ben Wing  <ben@xemacs.org>

	* mule/mule-msw-init-late.el:
	Specify charset->windows-registry conversion.

	* mule/mule-x-init.el:
	* mule/mule-x-init.el (x-use-halfwidth-roman-font):
	* mule/mule-x-init.el (init-mule-x-win):
	Delete extra mule font additions here.  Put them in faces.c.

2002-06-20  Ben Wing  <ben@xemacs.org>

	* cl-macs.el (defun*):
	* cl-macs.el (defmacro*):
	* cl-macs.el (destructuring-bind):
	Document better.

	* font-lock.el (lisp-font-lock-keywords-1):
	Move Lisp function regexp to lisp-mode.el.

	* lisp-mode.el:
	* lisp-mode.el (lisp-function-and-type-regexp): New.
	* lisp-mode.el (lisp-flet-regexp): New.
	* lisp-mode.el (lisp-indent-function):
	* lisp-mode.el (lisp-indent-quoteform): New.
	Various indentation fixes:

	Handle flet functions better.
	Handle argument lists in defuns and flets.
	Handle quoted lists, e.g. property lists -- don't indent like
	function calls.  Distinguish between lambdas and other lists.

	* lisp-mode.el (save-selected-device): Handle this form.

	* faces.el:
	* faces.el (face-property-instance):
	* faces.el (face-property-matching-instance):
	* faces.el (set-face-property):
	* faces.el (set-face-display-table):
	* faces.el (set-face-underline-p):
	* faces.el (set-face-strikethru-p):
	* faces.el (set-face-highlight-p):
	* faces.el (set-face-blinking-p):
	* faces.el (face-equal):
	* faces.el (try-font-name):
	* faces.el (face-frob-from-locale-first): New.
	* faces.el (frob-face-property): Removed.
	* faces.el (included): Removed.
	* faces.el (frob-face-property-1): Removed.
	* faces.el (frob-face-font-2): Removed.
	* faces.el (Face-frob-property-device-considered-current): New.
	* faces.el (Face-frob-property): New.
	* faces.el (make-face-family):
	* faces.el (make-face-bold):
	* faces.el (make-face-italic):
	* faces.el (NOTE): New.
	* faces.el (functions): New.
	* faces.el (make-face-bold-italic):
	* faces.el (make-face-unbold):
	* faces.el (make-face-unitalic):
	* faces.el (make-face-size):
	* faces.el (make-face-smaller):
	* faces.el (make-face-larger):
	* faces.el (get-frame-background-mode):
	* faces.el (init-global-faces):
	* font-menu.el:
	* font-menu.el (font-menu-set-font):
	* font-menu.el (font-menu-change-face):
	* font.el:
	* font.el (mswindows-font-weight-mappings):
	* font.el (font-mswindows-font-regexp): Removed.
	* font.el (mswindows-font-create-object):
	* font.el (mswindows-font-create-name):
	* gtk-faces.el (gtk-init-global-faces):
	* msw-faces.el:
	* msw-faces.el (mswindows-init-device-faces):
	* msw-faces.el (mswindows-font-regexp): Removed.
	* msw-faces.el (mswindows-font-canonicalize-name): Removed.
	* msw-faces.el (mswindows-canonicalize-font-name): New.
	* msw-faces.el (mswindows-parse-font-style): New.
	* msw-faces.el (mswindows-construct-font-style): New.
	* msw-faces.el (mswindows-frob-font-style): New.
	* msw-faces.el (mswindows-frob-font-style-and-sizify): New.
	* msw-faces.el (mswindows-nonbold-weight-regexp): New.
	* msw-faces.el (mswindows-make-font-unbold):
	* msw-faces.el (mswindows-bold-weight-regexp): New.
	* msw-faces.el (mswindows-make-font-italic):
	* msw-faces.el (mswindows-make-font-bold-mapper): New.
	* msw-faces.el (mswindows-make-font-unitalic):
	* msw-faces.el (mswindows-make-font-nonbold-mapper): New.
	* msw-faces.el (mswindows-make-font-italic-mapper): New.
	* msw-faces.el (mswindows-make-font-bold-italic):
	* msw-faces.el (mswindows-make-font-unitalic-mapper): New.
	* msw-faces.el (mswindows-make-font-bold-italic-mapper): New.
	* msw-faces.el (mswindows-find-smaller-font):
	* msw-faces.el (mswindows-find-larger-font):
	* msw-faces.el (mswindows-available-font-sizes): New.
	* msw-faces.el (mswindows-frob-font-size): New.
	* msw-font-menu.el:
	* msw-font-menu.el (mswindows-font-menu-junk-families):
	* msw-font-menu.el (mswindows-font-menu-registry-encoding): Removed.
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	* msw-font-menu.el (mswindows-font-menu-font-data):
	* msw-font-menu.el (mswindows-font-menu-load-font):
	* x-faces.el:
	* x-faces.el (x-init-global-faces):
	* x-faces.el (x-init-device-faces):
	* x-init.el (init-x-win):
	* x-init.el (init-post-x-win):

	Major overhaul of face-handling code:

	-- Fix lots of bogus code in msw-faces.el, msw-font-menu.el,
	font-menu.el that was "truenaming" font specs -- i.e. in the
	process of frobbing a particular field in a general user-specified
	font spec with wildcarded fields, sticking in particular values
	for all the remaining wildcarded fields.  This bug was rampant
	everywhere except in x-faces.el (the oldest and only correctly
	written code).  This also means that we need to work with font
	names at all times and not font instances, because a font instance
	is essentially a truenamed font.

	-- Total rewrite of extremely junky code in msw-faces.el.  Work
	with names as well as font instances, and return names; stop
	truenaming when canonicalizing and frobbing; fix handling of the
	combined style field, i.e. weight/slant (also fixed in font.el).

	-- Totally rewrite the frobbing functions in faces.el.  This time,
	we frob all the instantiators rather than just computing a single
	instance value and working backwards.  That way, e.g., `bold' will
	work for all charsets that have bold available, rather than only
	for whatever charset was part of the computed font instance
	(another example of the truename virus).  Also fix up code to look
	at the fallbacks (all of them) when no global value present, so we
	don't need to put something in the global value.  Intelligently
	handle a request to frob a buffer locale, rather than signalling
	an error.  When frobbing instantiators, try hard to figure out
	what device type is associated with them, and frob each according
	to its own proper device type.  Correctly handle inheritance
	vectors given as instantiators.  Preserve existing tags when
	putting back frobbed instantiators.  Extract out general
	specifier-frobbing code into specifier.el.  Document everything
	cleanly.  Do lots of other things better, etc.

	-- Don't duplicatively set a global specification for the default
	font -- it's already in the fallback and we no longer need a
	default global specification present.  Delete various code in
	x-faces.el and msw-faces.el that duplicated the lists of fonts in
	faces.c.

	-- init-global-faces was not being called at all under MS Windows!
	Major bogosity. That caused device-specific values to get stuck
	into all the fonts, making it very hard to change them -- setting
	global specs caused nothing to happen.

	-- Correct weight names in font.el.

	-- Lots more font fixups in objects*.c.

	* Printer.el (generic-print-region):
	Warning fix.

	* specifier.el:
	* specifier.el (map-specifier):
	* specifier.el (modify-specifier-instances):
	* specifier.el (instance-to-instantiator): New.
	* specifier.el (device-type-matches-spec): New.
	* specifier.el (add-tag-to-inst-list): New.
	* specifier.el (derive-domain-from-locale): New.
	* specifier.el (derive-device-type-from-tag-set): New.
	* specifier.el (Specifically): New.
	* specifier.el (derive-device-type-from-locale-and-tag-set): New.
	* specifier.el (derive-specifier-specs-from-locale): New.
	Add more args to map-specifier.

	Add various "heuristic" specifier functions to aid in creation of
	specifier-munging code such as in faces.el.

	* subr.el:
	* subr.el (args-out-of-range): New.
	* subr.el (argument-in-range-p): New.
	* subr.el (check-argument-range): New.
	New functions.


2002-06-04  Andy Piper  <andy@xemacs.org>

	* startup.el (normal-top-level): Fix bad merge.

2002-06-04  Jerry James <james@eecs.ku.edu>

	* find-paths.el (paths-find-architecture-directory): Search in
	`system-configuration'/`base', not `base'`system-configuration'.

2002-06-03  Andy Piper  <andy@xemacs.org>

	* dialog-items.el (make-search-dialog): align various subcontrols
	in visually pleasing ways, allow frame to autosize to the dialog
	size.
	* dialog.el (make-dialog-box): add a border inside the frame. Add
	:autosize property, if t then reset the frame size appropriately
	before the frame is mapped.
	* gutter-items.el (set-progress-feedback-instantiator): align
	various subcontrols.
	* gutter-items.el (set-progress-abort-instantiator): ditto.

2002-05-30  Andy Piper  <andy@xemacs.org>

	* files.el (revert-buffer-internal): don't visit
	revert-buffer. Kill buffer when not used. Suggested by Mike
	Alexander <mta@arbortext.com>

2002-05-08  Andy Piper  <andy@xemacs.org>

	* files.el (revert-buffer): observe noconfirm behavior.

2002-04-09  Andy Piper  <andy@xemacs.org>

	* files.el (revert-buffer): use revert-buffer-internal if it looks
	like doing so will not result in any user-visible changes.
	(revert-buffer-internal): new function. Do the actual process of
	reversion and then see whether the result is any different to what
	we have already. If it is not then do nothing.

2002-02-04  Andy Piper  <andy@xemacs.org>

	* files.el (convert-standard-filename): Fix for short filename
	Peter Arius <pas@methodpark.de>

2001-12-16  Andy Piper  <andy@xemacs.org>

	* package-get.el (package-get-update-all): Make sure installed.db
	gets updated after updating packages.

2001-12-11  Andy Piper  <andy@xemacs.org>

	* menubar.el (get-popup-menu-response): re-order so that it works
	on more sane/facist window systems.

2001-12-03  Andy Piper  <andy@xemacs.org>

	* faces.el (frob-face-property): don't infloop in face frobbing
	from Jan Vroonhof <jan@xemacs.org>.

2001-11-30  Andy Piper  <andy@xemacs.org>

	* printer.el (generic-print-region): fix for non-MS systems from
	Mike Fabian.

2001-11-30  Jan Vroonhof  <jan@xemacs.org>

	* font.el (font-window-system-mappings): Add mapping for Gtk
	(assume identical to X)

2001-11-30  Jan Vroonhof  <jan@xemacs.org>

	* faces.el (frob-face-property): Follow face fall-back hierarchy
	properly for face properties without an instance. Only do manual
	copy form 'default in last resort. This handles in particular
	the case where 'default itself has only a fall-back (which is
	the case by default on windows).

2001-11-24  Andy Piper  <andy@xemacs.org>

	* printer.el (generic-print-region): set default-frame-plist to
	nil while creating the printer frame so that sizes reflect the
	printed page.

	* faces.el (face-complain-about-font): Don't complain on printers.

2002-04-25  Steve Youngs  <youngs@xemacs.org>

	* mule/mule-charset.el (string-to-char-list): New.  This used to
	be in 'mule-misc.el' but that file has been removed.

2002-04-14  Steve Youngs  <youngs@xemacs.org>

	* obsolete.el (find-non-ascii-charset-region): A couple of
	packages use this.
	(find-non-ascii-charset-string): Ditto.

2002-04-14  Ben Wing  <ben@xemacs.org>

	* abbrev.el:
	* abbrev.el (abbrev-mode):
	* abbrev.el (only-global-abbrevs):
	* abbrev.el (defining-abbrev-turns-on-abbrev-mode): New.
	* abbrev.el (define-abbrev-table):
	* abbrev.el (global-abbrev-mode): New.
	* abbrev.el (add-mode-abbrev):
	* abbrev.el (add-global-abbrev):
	* abbrev.el (inverse-add-mode-abbrev):
	* abbrev.el (inverse-add-global-abbrev):
	Add `global-abbrev-mode', which turns on or off abbrev-mode in all
	buffers.  Added `defining-abbrev-turns-on-abbrev-mode' -- if
	non-nil, defining an abbrev through an interactive function will
	automatically turn on abbrev-mode, either globally or locally
	depending on the command.  This is the "what you'd expect"
	behavior.
	* indent.el:
	* indent.el (indent-balanced-expression-function): New.
	* indent.el (indent-balanced-expression): New.
	* indent.el (indent-region-or-balanced-expression): New.
	general function for indenting a balanced expression in a
	mode-correct way.  Works similar to indent-region in that a mode
	can specify a specific command to do the whole operation; if not,
	figure out the region using forward-sexp and indent each line
	using indent-according-to-mode.
	* keydefs.el:
	* keydefs.el (global-map): Removed.
	Modify M-C-backslash to do indent-region-or-balanced-expression.
	Make S-Tab just insert a TAB char, like it's meant to do.
	* make-docfile.el:
	* make-docfile.el (docfile-out-of-date):
	Now that we're using the call-process-in-lisp, we need to load
	an extra file win32-native.el because we're running a bare temacs.
	* menubar-items.el:
	* menubar-items.el (default-menubar):
	Totally redo the Cmds menu so that most used commands appear
	directly on the menu and less used commands appear in submenus.
	The old way may have been very pretty, but rather impractical.
	* process.el (call-process-internal):
	Under Windows, don't ever use old-call-process-internal, even
	in batch mode.  We can do processes in batch mode.
	* subr.el:
	* subr.el (truncate-string-to-width):
	* subr.el (truncate-string-with-continuation-dots): New.
	* subr.el (plist-to-alist):
	Someone recoded truncate-string-to-width, saying "the FSF version
	is too complicated and does lots of hard-to-understand stuff" but
	the resulting recoded version was *totally* wrong!  it
	misunderstood the basic point of this function, which is work in
	*columns* not chars.  i dumped ours and copied the version from
	FSF 21.1.  Also added truncate-string-with-continuation-dots,
	since this idiom is used often.

2002-04-07  William M. Perry  <wmperry@gnu.org>

	* startup.el (command-line): Don't call init-menubar-at-startup
	unless we were built with menubar support.

2002-03-19  Daiki Ueno  <daiki@xemacs.org>

	* mule/japanese.el: Don't quote function expressions listed as
	`native-coding-system'.
	* mule/chinese.el: Likewise.

2002-06-03  Ben Wing  <ben@xemacs.org> and
            Michael Sperber [Mr. Preprocessor]  <sperber@informatik.uni-tuebingen.de>

	* process.el:
	* process.el (process-synchronize-point): New.
	* process.el (call-process-internal):
	Create new process-synchronize-point to avoid dynamic binding
	problems.  Fix editing bogosity in setting process sentinels.

2002-05-28  Katsumi Yamaoka  <yamaoka@jpl.org>

	* obsolete.el (find-non-ascii-charset-region): Revert the function
	definition.
	(find-non-ascii-charset-string): Ditto.

2002-06-01  Ben Wing  <ben@xemacs.org>

	* process.el (call-process-internal):
	Insert before, not after, point.

2002-05-30  Michael Sperber [Mr. Preprocessor]  <sperber@informatik.uni-tuebingen.de>

	* code-process.el (call-process): Ensure that the argument to
	`symbol-value-in-buffer' is a buffer even if `buffer' is a string.

2002-05-28  Ben Wing  <ben@xemacs.org>

	* code-init.el:
	* code-init.el (coding-system-variable-default-value-table):
	* code-init.el (coding-system-variable-default-value):
	Don't use CRLF conversion by default on process output.  CMD.EXE and
	friends work both ways but Cygwin programs don't like the CRs.

	* code-process.el:
	* code-process.el (process-coding-system-alist):
	* code-process.el (call-process):
	* code-process.el (call-process-region):
	* code-process.el (start-process):
	* code-process.el (open-network-stream):
	* code-process.el (set-buffer-process-coding-system):
	* multicast.el:
	* multicast.el (open-multicast-group):
	* process.el:
	* process.el (start-process-shell-command):
	* process.el (call-process-internal):
	* process.el (call-process): Removed.
	* process.el (call-process-region): Removed.
	* process.el (start-process): Removed.
	* process.el (open-network-stream): Removed.

	Improvements to call-process-internal:

	-- allows a buffer to be specified for input and stderr output
	-- use it on all systems
	-- implement C-g as documented
	-- clean up and comment

	call-process-region uses new call-process facilities; no temp file.

	remove duplicate funs in process.el.

	comment exactly how coding systems work and fix various problems.

	open-multicast-group now does similar coding-system frobbing to
	open-network-stream.

	* dumped-lisp.el (preloaded-file-list):
	* faces.el (init-global-faces):
	* msw-faces.el (mswindows-init-global-faces): New.
	Fix some hidden errors due to code not being defined at the right time.

2002-05-25  Steve Youngs  <youngs@xemacs.org>

	* package-ui.el (pui-help-echo): Display both installed and author
	version.  Use a balloon-help window to display extra info like
	package requires.

2002-05-23  Ben Wing  <ben@xemacs.org>

	* files.el:
	* files.el (recover-session):
	* files.el (recover-session-finish): Removed.
	* files.el (Recover-session-files-from-auto-save-list-file): New.
	Recover-session improvements: Only show session files where some
	files can actually be recovered, and show in chronological order.

	* subr.el:
	* subr.el (truncate-string-to-width):
	* subr.el (BUG): New.
	* subr.el (truncate-string-with-continuation-dots): Removed.
	* subr.el (plist-to-alist):
	* menubar-items.el (default-menubar):
	As promised to rms, the functionality in
	truncate-string-with-continuation-dots has been merged into
	truncate-string-to-width.  Change callers in menubar-items.el.

	* select.el:
	* select.el (copy-primary-selection):
	* select.el (kill-primary-selection):
	* select.el (own-selection):
	* select.el (cut-copy-clear-internal):
	Document some of these funs better.  Fix problem where we were
	doing own-clipboard twice.

2002-05-20  Stephen J. Turnbull  <stephen@xemacs.org>

	* files.el (revert-buffer):
	(revert-buffer-internal):
	Update docstrings from 21.4.

2002-04-17  Nickolay Pakoulin  <npak@ispras.ru>

	* cus-edit.el (custom-save-delete-any): New function
	(make-custom-save-resets-mapper): New macro
	(custom-save-resets-mapper-alist): New constant
	(custom-save-resets): Modified
	Save customized values MUCH faster by keeping often used lambdas
	in cache `custom-save-resets-mapper-alist' instead of building them
	on the fly in `custom-save-resets'.

	* cus-edit.el (custom-save-pretty-print): New variable
	(custom-save-variable-p): New function
	(custom-save-variable-internal): New function
	(custom-save-variables): Modified
        (custom-save-face-p): New function
        (custom-save-face-internal): Modified
        (custom-save-faces): Modified
	Save customized variables and faces in the alphabetic order.
	`custom-save-pretty-print' turns on/off pretty-printing values.

2002-05-16  Ben Wing  <ben@xemacs.org>

	* dialog.el:
	* dialog.el (get-user-response): New.  Function to ask a
	multiple-choice question, automatically choosing a dialog box or
	minibuffer representation as necessary.  Generalized version of
	yes-or-no-p, y-or-n-p.

	* files.el:
	* files.el (recover-file-diff-program): New.
	* files.el (recover-file-diff-arguments): New.
	* files.el (recover-file):
	Use get-user-response to ask "yes/no/diff" question when recovering.
	"diff" means that a diff is displayed between the current file and the
	autosave. (Converts/deconverts escape-quoted as necessary.  No more
	complaints from you, Mr. Turnbull!) One known problem: when a dialog
	is used, it's modal, so you can't scroll the diff.  Will fix soon.

	* lisp-mode.el (lisp-fill-paragraph):
	If we're filling a string, don't treat semicolon as a comment,
	which would give very unfriendly results.
	Uses `buffer-syntactic-context'.

	* simple.el:
	* simple.el (undo-all-changes): New.
	all changes back to the beginning. (Useful if you've saved the file
	in the middle of the changes.)

	* simple.el (kill-word-into-kill-ring): New.
	* simple.el (backward-kill-word):
	Add option kill-word-into-kill-ring, which controls whether words
	deleted with kill-word, backward-kill-word, etc. are "cut" into the
	kill ring, or "cleared" into nothingness. (My preference is the
	latter, by far.  I'd almost go so far as suggesting we make it the
	default, as you can always select a word and then cut it if you want
	it cut.)

	* menubar-items.el (default-menubar):
	Add option corresponding to kill-word-into-kill-ring.

2002-05-09  Stephen J. Turnbull  <stephen@xemacs.org>

	This patch is based on Jerry James's patch and analysis.

	* select.el (get-clipboard):
	(get-selection):
	Update docstrings.
	(get-clipboard-foreign):
	(get-selection-foreign):
	New function for use as `interprogram-paste-function's.

	* simple.el (interprogram-paste-function): Change default to
	`get-clipboard-foreign'; improve docstring.
	(interprogram-cut-function): Improve dosctring.

2002-05-13  Ben Wing  <ben@xemacs.org>

	* files.el (revert-buffer):
	Andy's patch from 21.4.  Fix evil nasty problems with revert-buffer.

	* menubar-items.el (default-menubar):
	Add Append to Register to Rectangles/Register menu.

2002-05-13  Adrian Aichner  <adrian@xemacs.org>

	* code-process.el (call-process): Process-related docstring
	improvements spurred by Norbert Koch.
	* code-process.el (call-process-region): Ditto.
	* code-process.el (start-process): Ditto.

2002-05-09  Ben Wing  <ben@xemacs.org>

	* keydefs.el (global-map): New.
	* msw-init.el (init-post-mswindows-win):
	ctrl-delete is like M-d, in keeping with PC standards.  it still
	will function at its original (delete-selection), when there's a
	selection, with the new associated pending-del patch.

2002-04-14  Golubev I. N.  <gin@mo.msk.ru>

	* info.el (Info-find-index-alternatives): fix missing \ in \t.
	Port of `Info-index' change from 21.4.

2002-04-23  Jerry James  <james@xemacs.org>

	* select.el (get-clipboard): Document connection with
        interprogram-paste-function.
	* select.el (get-selection): Document that nil should be
        returned if XEmacs owns the selection.
        Remove unnecessary variable.
	* simple.el (kill-ring-max): Synch with FSF Emacs 21.2.
	* simple.el (kill-new): Synch with FSF Emacs 21.2

2002-05-05  Ben Wing  <ben@xemacs.org>

	* bytecomp-runtime.el (with-obsolete-variable):
	* bytecomp-runtime.el (with-obsolete-function):
	Doc string changes.

	* compat.el:
	* compat.el (compat-current-package):
	* compat.el (compat-current-package)): New.
	* compat.el (compat-define-compat-functions): New.
	* compat.el (compat-define-group):
	* compat.el (compat-define-functions): Removed.
	* compat.el (compat-defun): New.
	* compat.el (compat-define-function): New.
	* compat.el (compat-wrap-runtime): New.
	* compat.el (compat-wrap): New.
	* compat.el (compat): Removed.
	* compat.el (overlays):
	* compat.el (overlayp): New.
	* compat.el (make-overlay): New.
	* compat.el (move-overlay): New.
	* compat.el (delete-overlay): New.
	* compat.el (overlay-start): New.
	* compat.el (overlay-end): New.
	* compat.el (overlay-buffer): New.
	* compat.el (overlay-properties): New.
	* compat.el (overlays-at): New.
	* compat.el (overlays-in): New.
	* compat.el (next-overlay-change): New.
	* compat.el (previous-overlay-change): New.
	* compat.el (overlay-lists): New.
	* compat.el (overlay-recenter): New.
	* compat.el (overlay-get): New.
	* compat.el (overlay-put): New.
	* compat.el ('delete-extent): New.
	* compat.el ('extent-end-position): New.
	* compat.el ('extent-start-position): New.
	* compat.el ('set-extent-endpoints): New.
	* compat.el ('set-extent-property): New.
	* compat.el ('make-extent): New.
	* compat.el (extent-property): New.
	* compat.el (extent-at): New.
	* compat.el (map-extents): New.  Some attempts to redo this to
	make it truly useful and fix the "multiple versions interacting
	with each other" problem.  Not yet done.  Currently doesn't work.

	* files.el (revert-buffer-internal):
	Use with-obsolete-variable to avoid warnings in new revert-buffer code.

2002-05-02  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get): Use 'warn' instead of 'lwarn'.

2002-05-01  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-update-base-entry): Remove code to
	add package entries into custom.
	(package-get-custom-groups): Remove.
	(package-get-custom): Ditto.
	(package-get-custom-add-entry): Ditto.

2002-04-29  Steve Youngs  <youngs@xemacs.org>

	* menubar-items.el (default-menubar): Remove entry for managing
	packages via custom.

2002-04-24  Mats Lidell  <matsl@contactor.se>

	* mule/european.el (language-info-alist): Add TUTORIAL & greeting for Swedish.

2002-04-28  Steve Youngs  <youngs@xemacs.org>

	* mule/mule-charset.el: Revert my last patch. 'string-to-char-list'.

	* XEmacs 21.5.6 "bok choi" is released.

2002-03-31  Ben Wing  <ben@xemacs.org>

	* mule/mule-cmds.el:
	* mule/mule-cmds.el (langenv-to-locale-hash): New.
	* mule/mule-cmds.el (mswindows-get-language-environment-from-locale):
	Hash the result of mswindows-get-language-environment-from-locale,
	since it's very expensive (and causes huge ballooning of memory
	under X Windows, since it's called from x-get-resource).

2002-03-31  Ben Wing  <ben@xemacs.org>

	* cl-extra.el:
	* cl-extra.el (equalp):
	* code-files.el (load):
	* files.el (hack-local-variables-last-page):
	* files.el (hack-local-variables-prop-line):
	* simple.el (assoc-ignore-case):
	* subr.el:
	* subr.el (string-equal-ignore-case): New.
	* x-faces.el (x-frob-font-size):
	* x-faces.el (x-init-device-faces):
	Create new string-equal-ignore-case, based on built-in
	compare-strings -- compare strings ignoring case without the need
	to generate garbage by calling downcase.  Use it in equalp and
	elsewhere.

2002-03-31  Ben Wing  <ben@xemacs.org>

	* behavior.el:
	* behavior.el (within-behavior-enabling-disabling): New.
	* behavior.el (behaviors): New.
	* behavior.el (enabled-behavior-list): New.
	* behavior.el (define-behavior):
	* behavior.el (behavior-enabled-p):
	* behavior.el (enable-behavior):
	* behavior.el (disable-behavior):
	* dumped-lisp.el (preloaded-file-list):
	* menubar-items.el (default-menubar):
	Add support for saving using custom.  Load into a dumped XEmacs.
	Correct :title to :short-doc in accordance with behavior-defs.el.
	Add a submenu under Options for turning on/off behaviors.

	* cl-macs.el:
	* cl-macs.el (loop):
	* cl-macs.el (cl-parse-loop-clause):
	Properly document `loop'.  Fix a minor bug in keymap iteration and
	add support for bit-vector iteration.

	* lisp-mode.el (construct-lisp-mode-menu):
	Rearrange and add items for macro expanding.

	* menubar-items.el (menu-split-long-menu):
	* menubar-items.el (menu-sort-menu):
	Document connection between these two functions.

	* window.el:
	* window.el (get-window-with-predicate): New.
	* window.el (ALL-FRAMES): New.
	* window.el ('some-window): New.
	* window.el (count-windows):
	* window.el (window-safely-shrinkable-p): New.
	* window.el (count-screen-lines): New.
	* window.el (shrink-window-if-larger-than-buffer):
	Port stuff from GNU 21.1.

2002-03-24  Ben Wing  <ben@xemacs.org>

	* mule/english.el (ascii-right-to-left):
	Define this charset now, since a bug was fixed that formerly
	prevented it.

	* mule/ethio-util.el (ethio-fidel-to-java-buffer):
	* mule/ethio-util.el (ethio-java-to-fidel-buffer):
	Fix compile errors involving Unicode `characters', which should be
	integers.

2002-03-24  Ben Wing  <ben@xemacs.org>

	* sound.el:
	* sound.el (sound-default-alist):
	Correct docs.

	* msw-glyphs.el:

	Set glyph-contrib-p to nil on hscroll, continuation, truncation so
	that we don't get line jumpiness from them being larger than the
	line height.

	* mouse.el:
	* mouse.el ((meta button1)):
	* mouse.el (mouse-consolidated-yank):
	* mouse.el (mouse-yank):
	* mouse.el (mouse-track):
	* mouse.el (variables): Removed.
	* mouse.el (default-mouse-track-normalize-point):
	* mouse.el (default-mouse-track-return-dragged-selection):
	* mouse.el (mouse-track-by-lines): New.
	* mouse.el (mouse-track-insert): Removed.
	* mouse.el (mouse-track-adjust-by-lines): New.
	* mouse.el (mouse-track-insert-1): New.
	* mouse.el (mouse-track-insert-by-lines): New.
	* mouse.el (mouse-track-delete-and-insert-by-lines): New.

	New functions for line-oriented mouse selection, with meta held
	down.  Extend mouse-track{,adjust,insert,delete-and-insert} this
	way.  Move mouse-track-do-rectangle to meta-button2; not nearly so
	useful (and doesn't really work correctly currently).

	* auto-save.el:
	* auto-save.el (make-auto-save-file-name):
	* auto-save.el (recover-all-files):
	* check-features.el:
	* check-features.el ((featurep 'tooltalk)):
	* check-features.el ((featurep 'sparcworks)):
	* code-files.el:
	* code-files.el (insert-file-contents):
	* etags.el (find-tag-default):
	* files.el (normal-mode):
	* files.el (backup-buffer):
	* files.el (recover-session-finish):
	* finder.el (finder-compile-keywords):
	* font-lock.el (font-lock-pre-idle-hook):
	* info.el (Info-suffixed-file):
	* package-get.el:
	* package-get.el (package-get-load-package-file):
	* package-get.el (package-get):
	* packages.el:
	* packages.el (packages-load-package-lisps):
	* simple.el:
	* simple.el (show-message-log):
	* simple.el (log-message):
	* simple.el (remove-message):
	* simple.el (log-warning-minimum-level):
	* simple.el (display-warning-minimum-level):
	* simple.el (warning-level-alist):
	* simple.el (warning-level-<): New.
	* simple.el (display-warning):
	* simple.el (NOTE): New.
	* simple.el (warn):
	* simple.el (lwarn):
	* subr.el:
	* subr.el (backtrace-in-condition-handler-eliminating-handler): New.
	* subr.el (with-trapping-errors): New.

	New form with-trapping-errors; a consistent way to execute code,
	catching all errors and displaying a warning, including a
	backtrace showing where the error occurred.  Modify various files
	to use this.

	Show all warnings in the echo area (in a format convenient for
	this) as well as the Warnings buffer.  Change the interpretation
	of display-warning-minimum-level so that warnings below this level
	(now set at `warning') do not force the Warnings buffer to be
	displayed, but still appear in the echo area.  The motivation for
	this was `Unable to instantiate font' warnings, which should be
	visible but are very annoying when the Warnings buffer pops up.

	Change the meaning of warning level `alert' and define clearly
	what the purpose of the various warning levels are.  Modify
	various files consistent with the new definitions.

	Mark all warnings with extents.

	* startup.el (load-init-file):
	Modify so that a backtrace is seen when an error occurs.

	* help.el (view-warnings): New.
	New function for viewing warnings buffer.

	* help.el:
	* help.el (print-recent-messages):
	* simple.el:
	* simple.el (show-message-log):
	Integrate show-message-log with view-lossage.  Add option to
	view-lossage to view only the messages.  Clear message first so
	latest message is seen.

	* menubar-items.el:
	* menubar-items.el (default-menubar):
	* menubar-items.el (bookmark-menu-filter): Removed.
	Various rearrangements and fixes.

	* msw-faces.el:
	* msw-faces.el (gui-element):
	* msw-faces.el (mswindows-init-device-faces):
	Set gui-element font globally instead of on each device.

	* msw-font-menu.el (mswindows-font-menu-font-data): Fix bug.

	* simple.el (debug-print-1): New.
	* simple.el (debug-print):
	* simple.el (debug-backtrace): New.
	New debugging functions.

2002-03-20  John Paul Wallington  <jpw@shootybangbang.com>

	* menubar-items.el (list-all-buffers): New function.
	(list-all-buffers-function): New customizable variable.
	(default-menubar): Replace list-buffers with list-all-buffers.

2002-03-04  Simon Josefsson  <jas@extundo.com>

	* files.el (auto-mode-alist): Move Sieve to a place where the
	comment is more appropriate for it.

2002-03-20  Ben Wing  <ben@xemacs.org>

	* mule\mule-category.el:
	* mule\mule-category.el (with-category-table): New.
	Start implementing a category API compatible with FSF.  Not there yet.
	We need improvements to char-tables.

	* mule\mule-charset.el:
	* mule\mule-charset.el ((translation-table): New.
	* mule\mule-charset.el (make-translation-table): New.
	* mule\mule-charset.el (named-translation-table-hash-table): New.
	* mule\mule-charset.el (define-translation-table): New.
	* mule\mule-charset.el (find-translation-table): New.
	* mule\mule-charset.el (get-translation-table): New.
	Copy translation table code from FSF 21.1 and fix up.  Eventually
	we'll have them in XEmacs. (used in ccl) Not here quite yet, and
	we need some improvements to char-tables.

	* mule\cyril-util.el:
	* mule\cyril-util.el (cyrillic-encode-koi8-r-char):
	* mule\cyril-util.el (cyrillic-encode-alternativnyj-char):
	* mule\cyrillic.el:
	* mule\cyrillic.el (cyrillic-koi8-r-to-external-code-table): New.
	* mule\cyrillic.el (cyrillic-alternativnyj-to-external-code-table): New.
	* mule\devan-util.el (devanagari-compose-string):
	* mule\ethio-util.el:
	* mule\korea-util.el:
	* mule\mule-tty-init.el (init-mule-tty-win):
	* mule\tibet-util.el (tibetan-add-components):
	* mule\tibet-util.el (tibetan-compose-region):
	* mule\viet-util.el:
	* mule\viet-util.el (viet-encode-viscii-char):
	* mule\vietnamese.el:
	* mule\vietnamese.el (viet-viscii-to-external-code-table): New.
	Fix numerous compilation warnings.  Fix up code related to
	translation tables and other types of char-tables.

2002-03-20  Ben Wing  <ben@xemacs.org>

	* menubar-items.el (default-menubar): Move the frame commands from
	the View menu to the File menu, to be consistent with how most other
	programs do things.  Move less-used revert/recover items to a submenu.
	Make "recover" not prompt for a file, but recover the current buffer.

2002-03-20  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): debug.el -> diagnose.el.
	* diagnose.el: Renamed from debug.el because of existing debug.el
	in xemacs-base.

2002-03-18  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Add debug.el.

2002-03-18  Ben Wing  <ben@xemacs.org>

	* subr.el:
	* subr.el (map-plist): New.

	* debug.el: New.  New function show-memory-usage.

2002-03-18  Adrian Aichner  <adrian@xemacs.org>

	* cus-edit.el (customize-save-variable): Fix typo in prompt.

2002-03-18  Ben Wing  <ben@xemacs.org>

	* mule\lao.el (?):
	* mule\lao.el (lao):
	Convert stuff to XEmacs-style.

	* mule\thai-xtis.el:
	* mule\thai-xtis.el (thai-xtis):
	* mule\thai-xtis.el (?x): New.
	Move thai-xtis-chars.el stuff to here, since we can now handle
	encountering characters of a charset before the charset is defined.

	* mule\thai-xtis-chars.el: Removed, moved into thai-xtis.el.

	* mule\mule-msw-init.el: Move some stuff into mule-msw-init-late.el,
	which references charsets and thus needs to be delayed until after
	all charsets have been created.

	* mule\mule-msw-init-late.el: New file, some stuff from
	mule-msw-init.el.

2002-03-18  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list):
	Load the remaining languages -- lao, indian, devanagari, tibetan.
	Load new file mule-msw-init-late.

	* unicode.el (load-unicode-tables):
	* unicode.el (init-unicode-at-startup):
	Load the new tables for Ethiopic, Vietnamese, and other languages
	extracted from mule-ucs.

2002-03-16  Ben Wing  <ben@xemacs.org>

	* mule\arabic.el:
	* mule\arabic.el (arabic-1-column):
	* mule\arabic.el (arabic-2-column):
	* mule\canna-leim.el:
	* mule\canna-leim.el (canna:*japanese-mode*):
	* mule\canna-leim.el (canna-inactivate):
	* mule\china-util.el:
	* mule\chinese.el:
	* mule\chinese.el (chinese-sisheng):
	* mule\cyril-util.el:
	* mule\cyril-util.el (cyrillic-encode-koi8-r-char):
	* mule\cyril-util.el (cyrillic-encode-alternativnyj-char):
	* mule\cyrillic.el:
	* mule\devan-util.el:
	* mule\devanagari.el:
	* mule\english.el:
	* mule\ethio-util.el:
	* mule\ethio-util.el (ethio-modify-vowel):
	* mule\ethiopic.el:
	* mule\european.el:
	* mule\greek.el:
	* mule\hebrew.el:
	* mule\indian.el:
	* mule\japan-util.el:
	* mule\japan-util.el (japanese-symbol-table):
	* mule\japan-util.el (japanese-hankaku):
	* mule\japan-util.el (japanese-hankaku-region):
	* mule\japanese.el:
	* mule\korea-util.el:
	* mule\korean.el:
	* mule\lao-util.el:
	* mule\lao.el:
	* mule\lao.el (lao):
	* mule\misc-lang.el:
	* mule\mule-charset.el:
	* mule\mule-cmds.el (set-locale-for-language-environment):
	* mule\mule-cmds.el (set-language-environment-coding-systems):
	* mule\mule-cmds.el (init-locale-at-early-startup):
	* mule\thai-util.el:
	* mule\thai.el:
	* mule\tibet-util.el:
	* mule\tibetan.el:
	* mule\tibetan.el (tibetan-1-column):
	* mule\tibetan.el (tibetan):
	* mule\viet-util.el:
	* mule\viet-util.el (viet-encode-viscii-char):
	* mule\vietnamese.el:
	* mule\vietnamese.el (?v): New.
	* mule\vietnamese.el (viet-viscii-decode-table):
	* unicode.el:
	Fix lots of warnings.  Sync up some files to FSF 21.1.  Copy over
	all charset definitions from FSF 21.1, convert them to our format,
	and stick them in the relevant files.  Eventually we will actually
	be able to dump these files (though they may not quite work).

2002-03-16  Ben Wing  <ben@xemacs.org>

	* autoload.el:
	* autoload.el (make-autoload):
	* autoload.el (generate-autoload-cookie):
	* autoload.el (defun*):
	Support defun*, defmacro*.

	* mule/mule-composite.el: New file, from FSF.
	* mule/mule-composite-stub.el: New file, stubs for nonexistent
	composition funs/vars.
	* mule/viet-chars.el: Deleted, moved into vietnamese.el.
	* dumped-lisp.el (preloaded-file-list):
	Account for these changes.

	* font.el (mswindows-font-create-object):
	* mouse.el (mouse-begin-drag-n-drop):
	* msw-font-menu.el (mswindows-font-regexp):
	* printer.el:
	* printer.el (generic-page-setup):
	* printer.el (generic-print-region):
	* startup.el (early-error-handler):
	fix warnings.

2002-03-16  IKEYAMA Tomonori <tomonori@suiyokai.org>

        * unicode.el (load-unicode-tables): Make table for latin-jisx0201.
        * mule/mule-msw-init.el: Character sets to codepage mapping
        change. Add japanese-jisx0212, delete japanese-jisx0208-1978.

2002-03-15  Ben Wing  <ben@xemacs.org>

	* mule\mule-charset.el:
	* mule\mule-charset.el (char-width): Removed.
	* mule\mule-charset.el ('sref): Removed.
	* mule\mule-charset.el (char-bytes): Removed.
	* mule\mule-charset.el (string-to-sequence): Removed.
	* mule\mule-charset.el (string-to-list): Removed.
	* mule\mule-charset.el (string-to-vector): Removed.
	* mule\mule-charset.el (store-substring): Removed.
	* obsolete.el:
	* obsolete.el ('sref): New.
	* obsolete.el (char-bytes): New.
	* subr.el:
	* subr.el (char-width): New.
	* subr.el (string-to-sequence): New.
	* subr.el (string-to-list): New.
	* subr.el (string-to-vector): New.
	* subr.el (store-substring): New.
	* subr.el (truncate-string-to-width): New.  Put back
	previously-deleted truncate-string-to-width.  Move other
	non-Mule-specific stuff into subr.el or obsolete.el.

2002-03-15  Ben Wing  <ben@xemacs.org>

	* mule\chinese.el:
	* mule\chinese.el (post-read-decode-hz):
	* mule\chinese.el (pre-write-encode-hz):
	* mule\japan-util.el (japanese-katakana-region):
	* mule\japan-util.el (japanese-hiragana-region):
	* mule\japan-util.el (japanese-zenkaku-region):
	fix warnings.

2002-03-15  Ben Wing  <ben@xemacs.org>

	* behavior-defs.el (func-menu):
	* behavior-defs.el (filladapt):
	fix errors with require.

	* bytecomp-runtime.el:
	* bytecomp-runtime.el (with-boundp):
	* bytecomp-runtime.el (if-boundp):
	* bytecomp-runtime.el (when-boundp):
	* bytecomp-runtime.el (and-boundp): New.
	* bytecomp-runtime.el (declare-boundp):
	* bytecomp-runtime.el (globally-declare-boundp):
	* bytecomp-runtime.el (with-fboundp):
	* bytecomp-runtime.el (if-fboundp):
	* bytecomp-runtime.el (when-fboundp):
	* bytecomp-runtime.el (and-fboundp): New.
	* bytecomp-runtime.el (declare-fboundp):
	* bytecomp-runtime.el (globally-declare-fboundp):
	* bytecomp-runtime.el (with-byte-compiler-warnings-suppressed):
	add new funs {when,and}-{f}boundp, clean up docs.

	* cus-edit.el (custom-save-variables):
	pretty-print values.

	* dump-paths.el:
	* dump-paths.el (startup-setup-paths): New.
	* find-paths.el:
	* startup.el (command-switch-alist):
	* startup.el (command-line-do-help):
	* startup.el (normal-top-level):
	* startup.el (command-line-early):
	* startup.el (command-line):
	* startup.el (startup-find-roots-warning):
	* startup.el (startup-setup-paths): Removed.
	* startup.el (startup-load-autoloads):
	* setup-paths.el:
	fix problems/inconsistencies parsing options.  support new
	-no-packages option.  merge code duplication in dump-paths and
	startup.

	* lisp-mode.el:
	* lisp-mode.el (lisp-indent-function):
	* lisp-mode.el (while):
	indent macrolet and labels correctly.  update comments about
	lisp-indent-function.  flet already handled in cl.

	* apropos.el (apropos-safe-documentation):
	* auto-save.el (make-auto-save-file-name):
	* buff-menu.el (default-list-buffers-identification):
	* cl-extra.el (cl-map-intervals):
	* dragdrop.el (experimental-dragdrop-drop-url-default):
	* faces.el ((color '(red green blue yellow))):
	* files.el (recover-session):
	* files.el (file-remote-p):
	* fill.el (find-space-insertable-point):
	* font-lock.el (font-lock-thing-lock-cleanup):
	* font-lock.el (font-lock-after-fontify-buffer):
	* font.el (font-blink-initialize):
	* gtk-faces.el (*try-oblique-before-italic-fonts*): Removed.
	* gtk-faces.el (try-oblique-before-italic-fonts): New.
	* gtk-faces.el ('*try-oblique-before-italic-fonts*): New.
	* gtk-faces.el (gtk-make-font-italic):
	* gtk-faces.el (gtk-make-font-bold-italic):
	* gui.el (insert-gui-button):
	* help.el (xemacs-www-page):
	* help.el (xemacs-www-faq):
	* hyper-apropos.el (hyper-apropos-find-function):
	* hyper-apropos.el (hyper-apropos-find-variable):
	* info.el (Info-find-node):
	* isearch-mode.el (isearch-help-or-delete-char):
	* keymap.el (kbd):
	* lisp-mnt.el (lm-report-bug):
	* mouse.el (mouse-eval-sexp):
	* package-admin.el (package-admin-check-manifest):
	* package-get.el (package-get-update-base-from-buffer):
	* package-get.el (package-get-staging-dir):
	* printer.el (generic-print-region):
	* process.el (shell-command):
	* process.el (shell-quote-argument):
	* resize-minibuffer.el (resize-minibuffer-setup):
	* simple.el (sendmail-user-agent-compose):
	* toolbar-items.el (toolbar-paste):
	* toolbar-items.el (toolbar-ispell-internal):
	* toolbar-items.el (toolbar-compile):
	* toolbar-items.el (toolbar-gnus):
	* wid-edit.el (widget-before-change):
	* wid-edit.el (widget-after-change):
	* wid-edit.el (widget-url-link-action):
	* win32-native.el (grep-null-device):
	* win32-native.el (grep-null-device)): New.
	* win32-native.el (grep-regexp-alist):
	* win32-native.el (grep-regexp-alist)): New.
	* win32-native.el (mswindows-system-shells):
	fix warnings.

	* very-early-lisp.el: update docs.

2002-03-14  Ville Skyttä  <ville.skytta@xemacs.org>

	* files.el (auto-mode-alist): GNUmakefile is a Makefile,
	"system default" Xdefaults and friends get xrdb-mode.

2002-03-12  Ben Wing  <ben@xemacs.org>

	* The Great Mule Merge of March 2002:
	see node by that name in the Internals Manual.

2002-03-05  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.5 "beets" is released.

2002-03-05  Stephen J. Turnbull  <stephen@xemacs.org>

	* toolbar.el (default-toolbar-position): but I tested it! typo fix.

2002-03-05  Mats Lidell  <matsl@contactor.se>

 	* help-nomule.el (tutorial-supported-languages): Added Swedish
 	tutorial. Sorted languages.

2001-12-03  Christoph Wedler  <Christoph.Wedler@sap.com>

	* minibuf.el (completing-read): Update docstring.

2002-02-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* toolbar.el (toolbar-visible-p):
	(toolbar-captioned-p):
	Prefix * to docstring, improve line break.
	(default-toolbar-position): Prefix * to docstring, improve line break.
	Reconfigure frame to preserve window dimensions if toolbar is moved.

2002-01-27  Stephen J. Turnbull  <stephen@xemacs.org>

	* code-files.el (convert-mbox-coding-system): Improve comment.
	(write-region): Improve docstring.  Reformat to 80 columns.  Add
	coding-system argument to `write-region-pre-hook' call.
	(write-region-pre-hook): Fix docstring to mention lockname argument.

2002-02-11  Mike Sperber <mike@xemacs.org>

	* info.el (Info-maybe-update-dir): Regenerate dir if we're
	regenerating outdated dir files and dir is non-existent.

2002-02-03  Adrian Aichner  <adrian@xemacs.org>

	* printer.el (generic-print-region): Don't pass unwanted buffer
	argument to lpr-region, as pointed out by Björn Torkelsson.

2002-02-02  William M. Perry  <wmperry@gnu.org>

	* widgets-gtk.el (gtk-widget-get-callback): New function to
	support either :callback-ex or :callback in the widget functions.
	(gtk-widget-instantiate-button-internal): Use it.

2002-01-24  John Paul Wallington  <jpw@shootybangbang.com>

	* faces.el (zmacs-region): fix typo in docstring.

2002-01-14  Björn Torkelsson  <torkel@pdc.kth.se>

	* menubar-items.el (default-menubar): Open URLs menubar entries
	  moved to mail-lib

2002-01-16  John Paul Wallington  <jpw@shootybangbang.com>

	* cus-start.el: customize the builtin variable
	'modifier-keys-sticky-time'.

2002-01-09  John Paul Wallington  <jpw@shootybangbang.com>

	* help.el (describe-mode): synched with FSF 19.34; handle nil
	minor mode indicators.

2001-12-04  Christoph Wedler  <Christoph.Wedler@sap.com>

	* window.el (window-list): Deletia.  A function with the same name,
	which is the one used, is defined in window-xemacs.el.
	(quit-window): New command from Emacs-21.1.

2002-01-10  John Paul Wallington  <jpw@shootybangbang.com>

	* modeline.el (abbrev-mode-line-string): add custom group keyword.
	(overwrite-mode-line-string): ditto.
	(auto-fill-mode-line-string): ditto.
	(defining-kbd-macro-mode-line-string): ditto.

2002-01-10  Stephen J. Turnbull  <stephen@xemacs.org>

	* coding.el: Fix typo in comment.

2002-01-10  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/european.el (Latin-9): Add ISO 8859/15 support.

2002-01-09  Simon Josefsson  <jas@extundo.com>

	* files.el (auto-mode-alist): Support Sieve (*.siv, *.sieve).

2002-01-08  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.4 "bamboo" is released.

2002-01-04  Adrian Aichner  <adrian@xemacs.org>

	* info.el (Info-auto-generate-directory): Default
	Info-auto-generate-directory to 'if-outdated.

2001-12-27  David A. Panariti  <davep@who.net>

	* hyper-apropos.el (hyper-apropos-find-variable):
	Added this function based on hyper-apropos-find-function.

	* hyper-apropos.el (hyper-apropos-help-map):
	Added binding of "v" to hyper-apropos-find-variable.

2001-12-27  John Paul Wallington  <jpw@shootybangbang.com>

	* obsolete.el (interactive-form): new compatibility alias for
	function-interactive.

2001-12-26  Adrian Aichner  <adrian@xemacs.org>

	* printer.el (generic-print-region): Pass on arguments start, end,
	and buffer to lpr-region.  The original problem was pointed out by
	Nevin Kapur.

2001-12-26  John Paul Wallington  <jpw@shootybangbang.com>

	* keydefs.el (global-map): add a defn for C-x 5 1, previously
	undefined, to run delete-other-frames.

2001-12-18  John Paul Wallington  <jpw@shootybangbang.com>

	* gnuserv.el:
	(gnuserv-mode-line-string): new customizable variable
	(gnuserv-minor-mode): make variable buffer-local
	* isearch-mode.el:
	(isearch-mode-line-string): new customizable variable

2001-12-16  Andy Piper  <andy@xemacs.org>

	* package-get.el (package-get-update-all): Make sure installed.db
	gets updated after updating packages.

2001-12-13  William M. Perry  <wmperry@gnu.org>

	* gtk-faces.el (gtk-init-device-faces): Better way of munging the
	default faces from a style.  Do not use 'device' as the locale
	when setting it, or it makes it very difficult for a user to
	override.  Now munges highlight, zmacs-region, and toolbar from
	the appropriate information in the default GtkStyle for the
	device.

	* gui.el (gui-button-face): Ditto.

	* faces.el (text-cursor):
	(highlight):
	(zmacs-region):
	(list-mode-item-selected):
	(primary-selection):
	(secondary-selection):
	(isearch):
	(isearch-secondary): Condense old window-system specific settings
	into one specifier using the 'win default' tags.

	* dialog-gtk.el (popup-builtin-question-dialog): Deal gracefully
	with buttons of length 1, 2, and 3.  Fixed yes-or-no-p lossage.

2001-12-11  Andy Piper  <andy@xemacs.org>

	* menubar.el (get-popup-menu-response): re-order so that it works
	on more sane/facist window systems.

2001-12-03  Andy Piper  <andy@xemacs.org>

	* faces.el (frob-face-property): don't infloop in face frobbing
	from Jan Vroonhof <jan@xemacs.org>.

2001-11-30  Andy Piper  <andy@xemacs.org>

	* printer.el (generic-print-region): fix for non-MS systems from
	Mike Fabian.

2001-11-30  Jan Vroonhof  <jan@xemacs.org>

	* font.el (font-window-system-mappings): Add mapping for Gtk
	(assume identical to X)

2001-11-30  Jan Vroonhof  <jan@xemacs.org>

	* faces.el (frob-face-property): Follow face fall-back hierarchy
	properly for face properties without an instance. Only do manual
	copy form 'default in last resort. This handles in particular
	the case where 'default itself has only a fall-back (which is
	the case by default on windows).

2001-11-24  Andy Piper  <andy@xemacs.org>

	* printer.el (generic-print-region): set default-frame-plist to
	nil while creating the printer frame so that sizes reflect the
	printed page.

2002-05-09  Stephen J. Turnbull  <stephen@xemacs.org>

	This patch is based on Jerry James's patch and analysis.

	* select.el (get-clipboard):
	(get-selection):
	Update docstrings.
	(get-clipboard-foreign):
	(get-selection-foreign):
	New function for use as `interprogram-paste-function's.

	* simple.el (interprogram-paste-function): Change default to
	`get-clipboard-foreign'; improve docstring.
	(interprogram-cut-function): Improve dosctring.

2002-03-18  Adrian Aichner  <adrian@xemacs.org>

	* cus-edit.el (customize-save-variable): Fix typo in prompt.

2002-03-26  John Paul Wallington  <jpw@xemacs.org>

	* obsolete.el (assq-delete-all): New compatibility alias for
	remassq.

2002-01-09  Simon Josefsson  <jas@extundo.com>

	* files.el (auto-mode-alist): Support Sieve (*.siv, *.sieve).

2002-01-04  Adrian Aichner  <adrian@xemacs.org>

	* info.el (Info-auto-generate-directory): Default
	Info-auto-generate-directory to 'if-outdated.

2002-03-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* startup.el (normal-top-level): Prevent migration code from
	trashing .emacs on an error in loading the init files.

2002-03-14  Ville Skyttä  <ville.skytta@xemacs.org>

	* files.el (auto-mode-alist): GNUmakefile is a Makefile,
	"system default" Xdefaults and friends get xrdb-mode.

2002-03-05  Mats Lidell  <matsl@contactor.se>

 	* help-nomule.el (tutorial-supported-languages): Added Swedish
 	tutorial. Sorted languages.

2002-02-11  Mike Sperber <mike@xemacs.org>

	* info.el (Info-maybe-update-dir): Regenerate dir if we're
	regenerating outdated dir files and dir is non-existent.

2002-01-27  Stephen J. Turnbull  <stephen@xemacs.org>

	* code-files.el (convert-mbox-coding-system): Improve comment.
	(write-region): Improve docstring.  Reformat to 80 columns.  Add
	coding-system argument to `write-region-pre-hook' call.
	(write-region-pre-hook): Fix docstring to mention lockname argument.

2002-01-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* minibuf.el (completing-read): Remove redundant wrong arg list.

	* help.el (with-displaying-help-buffer): Put usage advice in docstring.

2001-12-27  John Paul Wallington  <jpw@shootybangbang.com>

	* obsolete.el (interactive-form): new compatibility alias for
	function-interactive.

2001-11-29  Adrian Aichner  <adrian@xemacs.org>

	* menubar-items.el (Menubar-items-truncate-list): Removed.
	* menubar-items.el (Menubar-items-truncate-history): New.
	* menubar-items.el (default-menubar): Use
	Menubar-items-truncate-history.

2002-02-03  Adrian Aichner  <adrian@xemacs.org>

	* printer.el (generic-print-region): Pass correct arguments to
	lpr-region.  Thanks to Nevin Kapur <nevin@jhu.edu> and Björn
	Torkelsson <torkel@acc.umu.se>.

2002-01-09  John Paul Wallington  <jpw@shootybangbang.com>

	* help.el (describe-mode): synched with FSF 19.34; handle nil
	minor mode indicators.

2001-12-03  Christoph Wedler  <Christoph.Wedler@sap.com>

	* minibuf.el (completing-read): Update docstring.

2001-12-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* faces.el (face-complain-about-font): Don't complain on printers.

2001-11-21  Stephen J. Turnbull  <stephen@xemacs.org>

	* package-net.el: Inadvertant synch with Windows branch.  From
	Andy's log:
	(package-net-kit-version): new variable.
	(package-net-generate-bin-ini): use it. Remove unwanted functions.

2001-11-28  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-locate-index-file): Also search the
	core etc/ directory for the package index file if it can't be
	found in ~/.xemacs/.

2001-12-13  William Perry  <wmperry@gnu.org>

	* dialog-gtk.el (popup-builtin-question-dialog):
	Conform to API in gui.c.

2001-11-12  Andy Piper  <andy@xemacs.org>

	* cus-edit.el (custom-save-face-internal): make sure we save
	non-themed faces.
	(custom-save-variables): ditto variables.

2001-11-20  Stephen J. Turnbull  <stephen@xemacs.og>

	* faces.el (make-face-family):
	(make-face-size):
	New face-modifying functions per Jan Vroonhof.

	cus-face.el (custom-set-face-font-family):
	(custom-set-face-font-size):
	Use them.

	* font.el (font-window-system-mappings): More precise docstring.

	(font-create-name):
	(font-create-object):
	(tty-font-create-object):
	(tty-font-create-plist):
	(x-font-create-object):
	(x-font-create-name):
	(ns-font-create-name):
	(mswindows-font-create-object):
	(mswindows-font-create-name):
	Add doctrings.

2001-11-14  John Paul Wallington <jpw@shootybangbang.com>

	* gtk-faces.el (gtk-init-device-faces): removed spurious
	quote before let* expression.

2001-12-19  Jan Vroonhof  <jan@xemacs.org>

	* gtk-faces.el (gtk-init-device-faces): Fix missing close paren
	problem with my application of the JPW's following patch.

2001-11-29  John Paul Wallington <jpw@shootybangbang.com>

	* gtk-faces.el (gtk-init-device-faces): Replaced device locale
	argument in set-face-background/foreground forms with
	'(default gtk) tag set to make the faces customizable, as
	suggested by Jan Vroonhof.

2001-12-15  John Paul Wallington  <jpw@shootybangbang.com>

	* modeline.el:
	(abbrev-mode-line-string): new customizable variable
	(overwrite-mode-line-string): ditto
	(auto-fill-mode-line-string): ditto
	(defining-kbd-macro-mode-line-string): ditto
	* view-less.el:
	(view-mode-line-string): ditto

2001-12-12  John Paul Wallington  <jpw@shootybangbang.com>

	* font-lock.el (font-lock-mode-line-string): new customizable
	variable

2001-10-16  Michael Diers  <mdiers@elego.de>

	* about.el: Update e-mail address.

2001-12-05  Michael Sperber [Mr. Preprocessor]  <sperber@informatik.uni-tuebingen.de>

	* packages.el (packages-compute-package-locations): Add
	user-specific site-packages and infodock-packages hierarchies for
	symmetry.

	* find-paths.el (paths-emacs-root-p): Use version-specific name
	for root testing.

2001-07-26  Mike Sperber <mike@xemacs.org>

	* files.el (auto-mode-alist): .9 files are man pages, too.

2001-12-04  John Paul Wallington  <jpw@shootybangbang.com>

	* paragraphs.el (mark-paragraph): synched with FSF;
        added optional argument.

2001-12-03  Didier Verna  <didier@xemacs.org>

	* rect.el: autoload `replace-rectangle'.
	* keydefs.el (global-map): bind it to `C-x r p'.

2001-11-29 Charles G Waldman <cgw@xemacs.org>

	* startup.el (initial-scratch-message): be correct about case

2001-12-02  Adrian Aichner  <adrian@xemacs.org>

	* package-get.el (package-get-update-base-from-buffer): Use
	exec-suffix-list with locate-file.

2001-12-03  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-update-base-from-buffer): Add
	autoload for 'mc-verify'.

2001-12-02  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-base-filename): Rename default file
	to 'package-index.LATEST.gpg'
	(package-get-require-signed-base-updates): Update doc string.

2001-11-29  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-entries-are-signed): New.
	(package-get-continue-update-base): New.
	(package-get-update-base-from-buffer): Use them.  Fix PGP code.

2001-11-29  Adrian Aichner  <adrian@xemacs.org>

	* menubar-items.el (Menubar-items-truncate-list): Removed.
	* menubar-items.el (Menubar-items-truncate-history): New.
	* menubar-items.el (default-menubar): Use
	Menubar-items-truncate-history.

2001-11-28  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-locate-index-file): Also search the
	core etc/ directory for the package index file if it can't be
	found in ~/.xemacs/.

2001-10-29  Andy Piper  <andy@xemacs.org>

	* code-files.el (toggle-buffer-file-coding-system): mark buffer as
	modified when changing coding system.

	* toolbar-items.el (toolbar-dired): Use interactive "D" spec so
	that we invoke the GUI directory selector.

2001-10-25  Andy Piper  <andy@xemacs.org>

	* dialog.el (make-dialog-box): use new directory dialog support.
	* minibuf.el (read-file-name-1): ditto.
	(read-file-name): ditto.
	(read-directory-name): ditto.

2001-09-28  Ben Wing  <ben@xemacs.org>

	* font-lock.el:
	* font-lock.el (font-lock-after-change-function):
	fix problem with last patch, reported by Katsumi Yamaoka.

2001-09-17  Ben Wing  <ben@xemacs.org>

	* font-lock.el (font-lock-after-change-function):
	fix problem when you insert a comment on the line before a line of
	code: if we use the following char, then when you hit backspace,
	the following line of code turns the comment color.

2001-09-15   Edward M. Lee  <tailbert@yahoo.com>

	* files.el (auto-mode-alist): Add configure.ac support.

2001-09-07  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.3 "asparagus" is released.

2001-08-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* README:  Partial update.

2001-08-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* wid-edit.el (widget-specify-secret):
	(widget-get):
	(widget-default-get):
	(widget-match-inline):
	(widget-create):
	(widget-create-child-and-convert):
	(widget-create-child):
	(widget-convert-text):
	(widget-convert-button):
	(widget-field-activate):
	(widget-beginning-of-line):
	(widget-end-of-line):
	(widget-kill-line):
	(widget-field-buffer):
	(widget-field-start):
	(widget-field-end):
	(widget-field-find):
	(widget-before-change):
	(`group' Widget):
	('list Widget):
	('vector Widget):
	Document usage conditions, fix typos.

2001-06-19  Ben Wing  <ben@xemacs.org>

	* term\AT386.el:
	* term\AT386.el (AT386-keypad-map):
	* term\AT386.el (AT386-keypad-map)): New.
	Fix warnings.

	* term\linux.el:
	* term\lk201.el:
	* term\news.el:
	* term\news.el (news-fkey-prefix)): New.
	* term\vt100.el:
	* term\vt100.el (vt100-wide-mode):
	Sync with FSF 21.0.103.
	Fix warnings.

2001-06-19  Ben Wing  <ben@xemacs.org>

	* dialog-gtk.el (popup-builtin-open-dialog): Fix warning.
	* hyper-apropos.el: Fix problem with undefined face.
	* update-elc.el (update-elc-files-to-compile): Compile in proper order.

2001-08-08  Didier Verna  <didier@xemacs.org>

	* autoload.el (make-autoload): handle the case of
	`define-derived-mode'.

2001-08-08  Didier Verna  <didier@xemacs.org>

	* autoload.el (update-autoload-files): make defdir a file name,
	not directory name.

2001-08-06  Steve Youngs  <youngs@xemacs.org>

	* menubar-items.el (default-menubar): Use 'report-xemacs-bug'.

	* lisp-mnt.el (lm-report-bug): Use 'report-xemacs-bug-beta-address'.

2001-07-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.2 "artichoke" is released.

2001-07-20  Steve Youngs  <youngs@xemacs.org>

	* packages.el (locate-data-file): Revert Karl's patch.

2001-07-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* specifier.el: define-specifier-tag 'gtk.

2001-07-15  Adrian Aichner  <adrian@xemacs.org>

	* about.el (about-personal-info): Fix word duplication typos.
	* dialog.el (make-dialog-box): Ditto.
	* lisp-mode.el (lisp-indent-function): Ditto.
	* package-admin.el (package-admin-delete-binary-package): Ditto.
	* package-get.el (package-get-staging-dir): Ditto.

2001-07-14  Sean MacLennan  <seanm@storm.ca>

	* package-admin.el (package-install-hook): New.
	(package-delete-hook): New.
	(package-admin-add-single-file-package): Use package-delete-hook.

	* package-get.el (package-get): Use package-install-hook.

2001-06-26  Robert Pluim  <rpluim@bigfoot.com>

	* packages.el (locate-library): change to use read-library-name so
	we can get completion

2001-06-26  Robert Pluim  <rpluim@bigfoot.com>

	* package-ui.el (pui-install-selected-packages): reverse the lists
	of packages so that they get handled in the same order as they
	were selected.

2001-06-21  Ben Wing  <ben@xemacs.org>

	* term\AT386.el:
	* term\AT386.el (AT386-keypad-map):
	* term\AT386.el (AT386-keypad-map)): New.
	Fix warnings.

	* term\apollo.el:
	* term\apollo.el ("term/vt100"):
	* term\apollo.el (*dm-mouse-key-bindings-file*): Removed.
	* term\apollo.el (*apollo-key-bindings-hook*): Removed.
	* term\apollo.el (*preempt-display-manager-bindings*): Removed.
	* term\apollo.el (*paste-buffer-directory*): Removed.
	* term\apollo.el (*apollo-mouse-move-point-allow-minibuffer-exit*): Removed.
	* term\apollo.el (*apollo-function-keys*): Removed.
	* term\apollo.el (*apollo-mouse-buttons*): Removed.
	* term\apollo.el (bind-apollo-function-key): Removed.
	* term\apollo.el (unbind-apollo-function-key): Removed.
	* term\apollo.el (select-apollo-meta-key): Removed.
	* term\apollo.el (bind-apollo-mouse-button): Removed.
	* term\apollo.el (unbind-apollo-mouse-button): Removed.
	* term\apollo.el ('apollo-prefix)): Removed.
	* term\apollo.el ('apollo-prefix-1)): Removed.
	* term\apollo.el ('apollo-prefix-2)): Removed.
	* term\apollo.el ('apollo-prefix-3)): Removed.
	* term\apollo.el ('apollo-prefix-4)): Removed.
	* term\apollo.el ('apollo-prefix-5)): Removed.
	* term\apollo.el ('apollo-prefix-6)): Removed.
	* term\apollo.el ('apollo-prefix-7)): Removed.
	* term\apollo.el ('apollo-prefix-8)): Removed.
	* term\apollo.el ('apollo-prefix): Removed.
	* term\apollo.el (apollo-copy-region): Removed.
	* term\apollo.el (apollo-cut-region): Removed.
	* term\apollo.el (apollo-paste): Removed.
	* term\apollo.el (minibuffer-prompt-length): Removed.
	* term\apollo.el (extract-file-or-buffer-name-around-point): Removed.
	* term\apollo.el (apollo-find-file): Removed.
	* term\apollo.el (apollo-grow-emacs-window): Removed.
	* term\apollo.el (apollo-move-emacs-window): Removed.
	* term\apollo.el (apollo-again): Removed.
	* term\apollo.el (apollo-exit): Removed.
	* term\apollo.el (apollo-abort): Removed.
	* term\apollo.el (apollo-aegis-help): Removed.
	* term\apollo.el (apollo-clean-help-file): Removed.
	* term\apollo.el (kill-whole-line): Removed.
	* term\apollo.el (apollo-key-undefined): Removed.
	* term\apollo.el (apollo-mouse-move-point): Removed.
	* term\apollo.el (apollo-mouse-move-mark): Removed.
	* term\apollo.el (apollo-mouse-cut): Removed.
	* term\apollo.el (apollo-mouse-copy): Removed.
	* term\apollo.el (apollo-mouse-paste): Removed.
	* term\apollo.el (apollo-mouse-pop-buffer): Removed.
	* term\apollo.el (apollo-mouse-find-file): Removed.
	* term\apollo.el (apollo-mouse-find-file-other-window): Removed.
	* term\apollo.el (apollo-mouse-defaults): Removed.
	* term\apollo.el (apollo-mouse-cut-copy-paste): Removed.
	* term\apollo.el (apollo-mouse-cancel-cut-copy-paste): Removed.
	* term\apollo.el (install-apollo-dm-preemptive-key-bindings): Removed.
	Kill kill kill.  Sync with FSF and remove most crap.

	* term\linux.el:
	* term\linux.el (function-key-map): Removed.
	Sync with FSF.  Don't define most defns, because they are
	automatically defined by termcap.  But do add defns for keys that
	normally get defined as f13, f14, etc. and really ought to be
	shift-f3, shift-f4, etc. (NOTE: I did this based on Cygwin, which
	emulates the Linux console.  I would appreciate it if someone on
	Linux could verify.)

	* term\cygwin.el:
	New.  Load term/linux.

	* term\lk201.el:
	* term\news.el:
	* term\news.el (news-fkey-prefix)): New.
	* term\vt100.el:
	* term\vt100.el (vt100-wide-mode):
	Sync with FSF.  Fix warnings.

2001-06-21  Ben Wing  <ben@xemacs.org>

	* dialog-gtk.el (popup-builtin-open-dialog): Fix warning.

	For 21.4:
	* help.el (frob-help-extents): Fix problem with undefined face.
	* update-elc.el (update-elc-files-to-compile): Compile in proper order.

	Maybe for 21.4:
	* keydefs.el (global-map): Add a defn for M-?, previously
	undefined, to access help -- in case the terminal is not set up
	right, or f1 gets redefined.

2001-06-19  Ben Wing  <ben@xemacs.org>

	* term/{internal,pc-win,win32-win,sun,sun-mouse}.el:
	Die die die.

2001-06-17  Ben Wing  <ben@xemacs.org>

	For 21.4:

	* update-elc-2.el (do-update-elc-2):
	* update-elc-2.el (batch-update-elc-2):
	Correct misplaced parentheses, making lisp/mule not get
	recompiled.

2001-06-10  Ben Wing  <ben@xemacs.org>

	* alist.el:
	* apropos.el:
	* autoload.el:
	* bytecomp.el:
	* bytecomp.el (byte-compile-insert-header):
	* cl-compat.el:
	* cl-extra.el:
	* cl-macs.el:
	* cl-seq.el:
	* cl.el:
	* cmdloop.el (execute-extended-command):
	* cus-edit.el (alloc):
	* derived.el:
	* gpm.el:
	* itimer.el:
	* lisp-mode.el (lisp-mode):
	* shadow.el:
	* version.el:
	* wid-browse.el:
	Rename 'GNU Emacs' to XEmacs in the copyright.
	Fix other references to GNU Emacs that should be XEmacs or just
	Emacs.

	* files.el (insert-directory):
	Fix warning.

	* simple.el:
	* simple.el (Simple-forward-line-creating-newline): New.
	* simple.el (Simple-transpose-lines-mover): New.
	* simple.el (transpose-line-up):
	* simple.el (transpose-line-down):
	* simple.el (transpose-subr):
	transpose-line-up/down will now move the region up or down by
	a line if active.

2001-06-08  Mike Sperber <mike@xemacs.org>

	* files.el (save-some-buffers-1): Don't zap the help window right
	after `map-y-or-n-p' has popped it up.

2001-06-08  Ben Wing  <ben@xemacs.org>

	* process.el: comment about shell-command-switch.
	* process.el (shell-quote-argument): Need to quote a null
	argument, too.  From Dan Holmsand.

	* startup.el (normal-top-level): Delete some unused FSF junk.
	* startup.el (command-line-early):

	* startup.el (command-line): Call MS Windows init function.

	* win32-native.el:
	* win32-native.el (mswindows-system-shells): New.
	* win32-native.el (mswindows-system-shell-p): New.
	* win32-native.el (init-mswindows-at-startup): New.
	* win32-native.el (mswindows-quote-one-vc-runtime-arg):
	* win32-native.el (mswindows-quote-one-simple-arg):
	* win32-native.el (mswindows-quote-one-command-arg):
	* win32-native.el (mswindows-construct-process-command-line-alist):
	Correct comments at top.  Correctly handle passing arguments
	to Cygwin programs and to bash.  Fix quoting of zero-length
	arguments (from Dan Holmsand).  Set shell-command-switch based
	on shell-file-name, which in turn comes from env var SHELL.

2001-06-03  William M. Perry  <wmperry@gnu.org>

	* dialog-gtk.el (popup-builtin-open-dialog): Yikes - don't forget
	to return the filename!

	* font.el (font-window-system-mappings): Add gtk entry - just an
	alias to the X code)

2001-06-02  William M. Perry  <wmperry@gnu.org>

	* gtk-marshal.el: Fix for removing of the string_hash utility
	functions in hash.c

2001-05-13  Karl M. Hegbloom  <karlheg@hegbloom.net>

	* packages.el (locate-data-file): Use suffixes list to allow
	finding compressed copies of the data files.

2001-05-30  Ben Wing  <ben@xemacs.org>

	* etags.el (buffer-tag-table-list):
	Fix infloop when going up to the root.

2001-05-30  William M. Perry  <wmperry@gnu.org>

	* gtk-marshal.el: Make sure that we use 'const' instead of 'CONST'
	in the generated file.  Put in a comment at the top of the
	generated file that it _IS_ auto-generated, and should not be
	edited by hand.


	* gtk-widget-accessors.el (define-widget-accessors): Use
	wtaerror() instead of signal_simple_error.
	(import-widget-accessors): Put in a comment at the top of the
	generated file that it _IS_ auto-generated, and should not be
	edited by hand.

2001-05-10   Daiki Ueno  <ueno@unixuser.org>

	* font-lock.el (font-lock-compile-keywords): Rewrite as a side
	effect free function.
	(font-lock-fontify-keywords-region): Supply the argument to
	font-lock-compile-keywords.

2001-05-24  Ben Wing  <ben@xemacs.org>

	* subr.el:
	* subr.el (error):
	fix doc string to reflect reality

2001-05-23  Ben Wing  <ben@xemacs.org>

	* behavior-defs.el:
	* behavior-defs.el (scroll-in-place):
	* behavior-defs.el ('scroll-in-place): New.
	* behavior-defs.el (mouse-avoidance):
	* behavior-defs.el (jka-compr):
	* behavior-defs.el ('jka-compr): New.
	* behavior-defs.el ('efs): New.
	* behavior-defs.el (efs):
	* behavior-defs.el (resize-minibuffer):
	* behavior-defs.el (func-menu):
	* behavior-defs.el (mwheel):
	* behavior-defs.el (recent-files):
	* behavior-defs.el (filladapt):
	Add scroll-in-place, jka-compr, efs, fix up some things.

2001-03-19  Karl M. Hegbloom  <karlheg@microsharp.com>

	* cus-edit.el (custom-display): Support the GTK Window System also.

2001-05-21  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el (=): `=' is not a binary predicate!
	Fix incorrect optimization: (= 0 0 (random 2)) ==> 0 or 1.
	Use byte-optimize-predicate, not byte-optimize-binary-predicate,

2001-05-20  Martin Buchholz  <martin@xemacs.org>

	* bytecomp.el (byte-compile-arithcompare):
	Only optimize (= x) ==> t if byte-compile-delete-errors is nil.

2001-05-20  Adrian Aichner  <adrian@xemacs.org>

	* buff-menu.el (Buffer-menu-mode): Properly make
	`mouse-track-click-hook' local.
	* info.el (Info-mode): Ditto.

2001-05-19  Ben Wing  <ben@xemacs.org>

	* autoload.el (batch-force-update-one-directory):
	Oops, off by one argument.

	* mouse.el:
	* mouse.el (Mouse-track-gensym): New.
	* mouse.el (mouse-track-run-hook):
	* mouse.el (mouse-track):
	* mouse.el (mouse-track-default):
	* mouse.el (mouse-track-insert):
	* mouse.el (mouse-track-insert-selected-region): Removed.
	* mouse.el (mouse-track-insert-drag-up-hook): Removed.
	* mouse.el (mouse-track-insert-click-hook): Removed.
	Add an argument to mouse-track so that hooks can be overridden.
	(let-binding doesn't work when the hooks have been made local.)
	modify mouse-track-run-hook accordingly, and fix mouse-track-default
	and mouse-track-insert to use the new functionality.

	* printer.el (generic-print-region):
	Oops, off by one paren.

2001-05-13  Adrian Aichner  <adrian@xemacs.org>

	* buff-menu.el (Buffer-menu-mode): `mouse-track-click-hook' was
	made buffer-local incorrectly (make-local-variable instead of
	make-local-hook).  Furthermore this hook must not be local so that
	it can keep track of buffers and windows.

2001-05-13  Mike Alexander  <mta@arbortext.com>

	* dragdrop.el (experimental-dragdrop-drop-url-default): If event
	has no window, use one from the frame in the event

2001-05-12  Ben Wing  <ben@xemacs.org>

	* .cvsignore: auto-autoloads/custom-load need to be added now that they're not in cvs.

2001-05-12  Ben Wing  <ben@xemacs.org>

	* find-paths.el (paths-find-recursive-path):
	fix error with null EXCLUDE-REGEXP.

	* font-lock.el (font-lock-mode):
	fix problem reported by hrvoje with buffers starting with a space.

	* lib-complete.el:
	* lib-complete.el (find-library-source-path): New.
	* lib-complete.el (find-library):
	add a variable to control where `find-library' looks, analogous to `find-function-source-path'.

2001-05-10  Ben Wing  <ben@xemacs.org>

	* mule\mule-coding.el:
	* mule\mule-coding.el (coding-system-charset): New.
	Move this function into Lisp to avoid doc warnings.

2001-05-10  Ben Wing  <ben@xemacs.org>

	* autoload.el:
	* autoload.el (update-autoloads-from-directory):
	* autoload.el (fixup-autoload-buffer):
	* autoload.el (batch-update-autoloads): Removed.
	* autoload.el (update-autoload-files): New.
	* autoload.el (batch-force-update-one-directory): New.
	* packages.el (packages-useful-lisp):
	* startup.el:
	* startup.el (normal-top-level):
	* startup.el (startup-load-autoloads): New.
	* update-elc-2.el (batch-update-elc-2):
	* update-elc.el:
	* update-elc.el (need-to-rebuild-autoloads): New.
	* update-elc.el (need-to-rebuild-mule-autoloads): New.
	* update-elc.el (need-to-recompile-autoloads): New.
	* update-elc.el (need-to-recompile-mule-autoloads): New.
	* update-elc.el (update-elc-chop-extension): New.
	Rewrite much of the bootstrapping process to be more robust,
	and in particular to rebuild the auto-autoloads and custom-loads
	files no matter what state (including missing) they're currently
	in.

2001-05-09  Ben Wing  <ben@xemacs.org>

	* files.el (find-file-noselect):
	* files.el (recover-session-finish):
	fix byte-compilation warnings.

2001-05-09  Ben Wing  <ben@xemacs.org>

	* font.el (bold): New.
	* font.el (italic): New.
	* font.el (oblique): New.
	* font.el (dim): New.
	* font.el (underline): New.
	* font.el (overline): New.
	* font.el (linethrough): New.
	* font.el (strikethru): New.
	* font.el (reverse): New.
	* font.el (blink): New.
	* font.el (smallcaps): New.
	* font.el (bigcaps): New.
	* font.el (dropcaps): New.
	* gtk-widget-accessors.el (import-widget-accessors):
	* widgets-gtk.el (gtk-widget-instantiate-internal):
	* x-font-menu.el (x-font-menu-font-data): New.
	* x-font-menu.el (x-font-menu-load-font):
	fix byte-compilation warnings.

2001-05-09  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.5.1 "anise" is released.

2001-05-06  Ben Wing  <ben@xemacs.org>

	* dialog.el (make-dialog-box):
	* menubar-items.el (default-menubar):
	* printer.el (generic-print-buffer):
	* printer.el (generic-print-region):
	implement printing the selection when it's selected.

	unrelated:

	* minibuf.el (input-error):
	* subr.el (error):
	a couple of error cleanups.

	* update-elc.el ((preloaded-file-list site-load-packages need-to-dump dumped-exe)):
	* update-elc.el (update-elc-files-to-compile):
	if bytecomp or byte-optimize need recompiling, then load
	the .el version of them first, recompile them, and reload
	the .elc versions to recompile everything else (so we won't
	be waiting until the cows come home).

2001-05-05  Ben Wing  <ben@xemacs.org>

	* subr.el (error):
	Add missing errors to the doc string.

2001-05-05  Ben Wing  <ben@xemacs.org>

	* dialog.el (make-dialog-box): fix doc string.
	* menubar-items.el (default-menubar): Add Page Setup for Windows,
	take out Pretty Print.
	* printer.el:
	* printer.el (printer-current-device): New.
	* printer.el (Printer-get-device): New.
	* printer.el (Printer-clear-device): New.
	* printer.el (generic-page-setup): New.
	* printer.el (generic-print-buffer):
	* printer.el (generic-print-region):
	Implement Page Setup.  Handle errors properly.

	unrelated:

	* gtk-init.el: Fix the warning properly.


2001-05-04  Ben Wing  <ben@xemacs.org>

	* printer.el (generic-print-buffer):
	* printer.el (generic-print-region):
	Enable dialog boxes.  Apply workaround recommended by Kirill.

	* simple.el (kill-whole-line):
	* simple.el (kill-line-1):
	* simple.el (kill-entire-line):
	* simple.el (kill-line):
	* simple.el (backward-kill-line):
	Take out interactive dependence of kill-whole-line.

2001-04-22  Ben Wing  <ben@xemacs.org>

	----------------------- byte-comp warning fixes -----------------

	* bytecomp-runtime.el:
	* bytecomp-runtime.el (with-boundp): New.
	* bytecomp-runtime.el (if-boundp): New.
	* bytecomp-runtime.el (declare-boundp): New.
	* bytecomp-runtime.el (globally-declare-boundp): New.
	* bytecomp-runtime.el (byte-compile-with-fboundp): New.
	* bytecomp-runtime.el ('with-fboundp-1): New.
	* bytecomp-runtime.el (with-fboundp): New.
	* bytecomp-runtime.el (if-fboundp): New.
	* bytecomp-runtime.el (declare-fboundp): New.
	* bytecomp-runtime.el (globally-declare-fboundp): New.
	* bytecomp-runtime.el (byte-compile-with-byte-compiler-warnings-suppressed): New.
	* bytecomp-runtime.el ('with-byte-compiler-warnings-suppressed-1): New.
	* bytecomp-runtime.el (with-byte-compiler-warnings-suppressed): New.
	* bytecomp-runtime.el (with-obsolete-variable): New.
	* bytecomp-runtime.el (with-obsolete-function): New.
	New functions for cleanly eliminating byte-compiler warnings.
	Their definitions require no changes at all in bytecomp.el,
	meaning that any package that wants to use them and be compatible
	with older versions of XEmacs need only copy the code and rename
	the functions (i.e. prefix them with the package name).

	* apropos.el (apropos-symbol-face):
	* apropos.el (apropos-keybinding-face):
	* apropos.el (apropos-label-face):
	* apropos.el (apropos-property-face):
	* cl-extra.el (cl-map-overlays):
	* coding.el:
	* coding.el (set-keyboard-coding-system):
	* coding.el (set-terminal-coding-system):
	* console.el (resume-pid-console):
	* dialog-gtk.el:
	* dialog-gtk.el (popup-builtin-open-dialog):
	* dialog-gtk.el (popup-builtin-color-dialog):
	* dragdrop.el (experimental-dragdrop-drop-mime-default):
	* dragdrop.el (gtk-start-drag):
	* dragdrop.el (gtk-start-drag-region):
	* faces.el (init-face-from-resources):
	* faces.el (init-device-faces):
	* faces.el (init-frame-faces):
	* faces.el (init-global-faces):
	* faces.el (set-face-stipple):
	* files.el (set-visited-file-name):
	* files.el (basic-save-buffer):
	* files.el (save-some-buffers-1):
	* files.el (file-remote-p):
	* fill.el (fill-move-forward-to-break-point):
	* fill.el (find-space-insertable-point):
	* font-lock.el:
	* frame.el (suspend-or-iconify-emacs):
	* frame.el (suspend-emacs-or-iconify-frame):
	* gdk.el:
	* generic-widgets.el:
	* generic-widgets.el (build-ui::radio-group):
	* generic-widgets.el (build-ui::button):
	* glade.el:
	* gnome-widgets.el:
	* gnome.el:
	* gtk-extra.el:
	* gtk-faces.el (gtk-choose-font):
	* gtk-file-dialog.el:
	* gtk-file-dialog.el (gtk-file-dialog-fill-file-list):
	* gtk-file-dialog.el (gtk-file-dialog-fill-directory-list):
	* gtk-file-dialog.el (gtk-file-dialog-new):
	* gtk-font-menu.el:
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* gtk-init.el:
	* gtk-init.el (gtk-initialize-compose):
	* gtk-package.el:
	* gtk-password-dialog.el:
	* gtk-widget-accessors.el:
	* gtk-widgets.el:
	* gtk.el:
	* isearch-mode.el (isearch-help-or-delete-char):
	* ldap.el:
	* lib-complete.el (read-library-internal):
	* lib-complete.el (read-library):
	* lib-complete.el (read-library-name):
	* lisp-mnt.el (lm-report-bug):
	* minibuf.el (minibuffer-smart-mouse-tracker):
	* minibuf.el (minibuffer-smart-select-kludge-filename):
	* minibuf.el (read-file-name-internal-1):
	* minibuf.el (read-color-completion-table):
	* modeline.el (modeline-toggle-read-only):
	* mouse.el (mouse-consolidated-yank):
	* mouse.el (default-mouse-track-maybe-own-selection):
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	* multicast.el (open-multicast-group):
	* mwheel.el:
	* package-get.el (package-get-update-base-from-buffer):
	* scrollbar.el (init-scrollbar-from-resources):
	* symbols.el:
	* syntax.el (describe-syntax-table):
	* toolbar.el (init-toolbar-from-resources):
	* toolbar-items.el (toolbar):
	* toolbar-items.el (toolbar-paste):
	* tty-init.el (init-pre-tty-win):
	* tty-init.el (init-post-tty-win):
	* wid-browse.el (widget-browse-sexp):
	* widgets-gtk.el:
	* x-faces.el:
	* x-font-menu.el:
	* x-font-menu.el (x-font-menu-font-data):
	* x-init.el:
	* x-misc.el:
	* x-mouse.el:
	* x-scrollbar.el:
	* x-select.el:
	* x-win-sun.el:
	* x-win-xfree86.el:
	Eliminate byte-compiler warnings using the new functions in
	bytecomp-runtime.el.

	* coding.el (coding-system-get): New.
	* coding.el (coding-system-put): New.
	* coding.el (coding-system-category): New.
	* mule\mule-misc.el (coding-system-get): Removed.
	* mule\mule-misc.el (coding-system-put): Removed.
	* mule\mule-misc.el (coding-system-category): Removed.
	Move these functions, since they're not Mule-specific and
	are used in prefer-coding-system.

	* font.el:
	* font.el (cl):
	* font.el (set-font-family):
	* font.el (set-font-weight):
	* font.el (set-font-style):
	* font.el (set-font-size):
	* font.el (set-font-registry):
	* font.el (set-font-encoding):
	* font.el (font-family):
	* font.el (font-weight):
	* font.el (font-style):
	* font.el (font-size):
	* font.el (font-registry):
	* font.el (font-encoding):
	* font.el (set-font-style-by-keywords):
	* font.el (font-properties-from-style):
	* font.el (font-combine-fonts-internal):
	* font.el (font-x-font-regexp):
	* font.el (x-font-create-object):
	* font.el (x-font-create-name):
	* font.el (ns-font-create-name):
	* font.el (mswindows-font-create-name):
	* font.el (font-update-device-fonts):
	* font.el (font-update-one-face):
	* font.el (font-rgb-color-p):
	* font.el (font-rgb-color-red):
	* font.el (font-tty-compute-color-delta):
	* font.el (font-normalize-color):
	This file was incredibly ugly.  Clean it up.  Avoid using defsubst
	for any exported functions, to avoid possible compatibility
	problems if we later change the internal interface. (It happened
	before, with face accessors, between 19.8 and 19.9). Fix tons
	of warnings.

	* gpm.el:
	* gpm.el (gpm-is-supported-p): New.
	* gpm.el (gpm-delete-device-hook):
	Clean up (new function gpm-is-supported-p eliminates duplicate
	code in gpm-create/delete-device-hook) and eliminate warnings.

	---------- make byte-recompile-directory work in the ---------
	           core `lisp' dir, even in the absence of
		   a Mule XEmacs (i.e. make it skip the Mule
	           files rather than trying to compile them).
	           now you should be able to do `touch *.el'
	           in the `lisp' dir, then
	           M-x byte-recompile-directory, and get no
	           warnings.

	* bytecomp.el:
	* bytecomp.el (byte-recompile-ignore-uncompilable-mule-files): New.
	* bytecomp.el (byte-compile-inbuffer):
	* bytecomp.el (byte-compile-inbuffer)): New.
	* bytecomp.el (byte-compile-outbuffer)): New.
	* bytecomp.el (byte-compile-warn):
	* bytecomp.el (byte-recompile-directory):
	* bytecomp.el (byte-recompile-file):
	Avoid trying to compile Mule files in byte-recompile-directory
	when we're not in a Mule XEmacs, since we're highly likely to get
	syntax errors.

	* mule\arabic.el:
	* mule\canna-leim.el:
	* mule\english.el:
	* mule\greek.el:
	* mule\kinsoku.el:
	* mule\latin.el:
	* mule\misc-lang.el:
	* mule\mule-category.el:
	* mule\mule-ccl.el:
	* mule\mule-charset.el:
	* mule\mule-cmds.el:
	* mule\mule-coding.el:
	* mule\mule-help.el:
	* mule\mule-init.el:
	* mule\mule-misc.el:
	* mule\mule-tty-init.el:
	* mule\mule-x-init.el:
	* mule\thai-xtis-chars.el:
	* mule\viet-chars.el:
	Add a coding-system cookie to all Mule files so that
	byte-recompile-directory ignores them.

	* code-files.el (load):
	* code-files.el (find-coding-system-magic-cookie): Removed.
	* files.el:
	* files.el (find-coding-system-magic-cookie-in-file): New.
	Magic cookie function moved to files.el from code-files.el (for
	use by bytecomp even in a non-coding-system XEmacs), and changed
	names and semantics for use by bytecomp.  NOTE: IMO this is an
	internal function that we can change as we like (and there is
	absolutely no code anywhere else using the function).

	---------------- GUI improvements: menus, help -------------------

	* help.el:
	* help.el (help-map): Removed.
	* help.el (help-for-help):
	* help.el (Help-princ-face):
	* help.el (Help-prin1-face):
	* help.el (describe-function-1):
	* help.el (describe-variable):
	Rearrange order of keymap declarations to be alphabetical.
	Improve help on help to include all bindings, and group by
	category.  Add bindings for new Info commands.  Remove
	warnings.  Use command-hyper-apropos in place of command-apropos.

	* hyper-apropos.el:
	* hyper-apropos.el (hyper-apropos-programming-apropos):
	* hyper-apropos.el (command-hyper-apropos): New.
	Add a function to do the equivalent of command-apropos.

	* help-macro.el (make-help-screen):
	Evals its help-text argument so you can put expressions there.
	Used now by help-for-help.

	* info.el:
	* info.el (Info-search):
	* info.el (Info-search-next): New.
	* info.el (Info-index): Removed.
	* info.el (Info-find-index-alternatives): New.
	* info.el (Info-read-search-text-regexp): New.
	* info.el (Info-search-text-in-lispref): New.
	* info.el (Info-search-text-in-xemacs): New.
	* info.el (Info-search-index-in-lispref): New.
	* info.el (Info-search-index-in-xemacs-and-lispref): New.
	* info.el (Info-mode-map):
	Add binding to continue text searches.  Expand index searches to
	work over multiple info documents.  Add commands to search
	text/index in User and Lispref.

	* lisp-mode.el (construct-lisp-mode-menu):
	 Add new entry,	"Uncomment Region" (parallels "Comment Out Region").

	* menubar-items.el (default-menubar):
	* menubar-items.el (default-popup-menu):
	Redo Help menu; add bindings for new Info commands to search the
	index or text of the User and Lispref manuals.  Add command for
	mark-paragraph, activate-region.  Make Edit->R accelerator be
	rectangle, not register (more commonly used), and put rectangle
	first.  Fix the Edit Init File entry to never load the .elc file.
	Simplify the default-popup-menu.  Add Cmds->Tabs menu.

	* menubar.el (popup-buffer-menu): Doc fix.
	* menubar.el ((boundp 'menu-accelerator-map)):
	Use kp-left not kp_left, etc.

	---------------- Miscellaneous bug fixes/cleanup -------------------

	* bytecomp-runtime.el (byte-compiler-options):
	Correct doc string.

	* easymenu.el (easy-menu-do-define): fix extra quote.

	* fill.el (fill-paragraph-or-region):
	Rewrite to be more correct -- use call-interactively so that
	we always get exactly the same behavior as if the functions
	were called directly.

	* font-lock.el (font-lock-fontify-pending-extents):
	* gutter-items.el (clear-progress-feedback):
	* gutter-items.el (abort-progress-feedback):
	* gutter-items.el (raw-append-progress-feedback):
	* simple.el (clear-message):
	* simple.el (raw-append-message):
	No need to fiddle with zmacs-region-stays, now that bogus
	clearing of it (2001-04-28 src/ChangeLog) is removed.

	* dialog.el (make-dialog-box):
	Put dialog titles back in -- this time correctly.  Fix various
	other problems with leaks and such.

	* keymap.el (key-sequence-list-description):
	Clean up fun to always correctly canonicalize.

	* simple.el:
	* simple.el (delete-forward-p):
	* simple.el (comment-padding): New.
	* simple.el (comment-region):
	* simple.el (do-auto-fill):
	* simple.el (indent-new-comment-line):
	Clean up Kinsoku comments, synch comment-region with FSF 20.7.

	* simple.el (region-exists-p):
	* simple.el (region-active-p):
	Add comment about which one is correct to use in menu specs.

	* sound.el (load-sound-file):
	Minor code clean up.

	* startup.el:
	* startup.el (command-line-early):
	* startup.el (initial-scratch-message):
	Comment changes.  Add info about sample.init.el to splash screen.
	Improve initial-scratch-message and clarify purpose of Scratch
	buffer.  Fix byte-compile warning.

	------------------------ Added features -------------------------

	* etags.el:
	* etags.el (tags-check-parent-directories-for-tag-files): New.
	* etags.el (buffer-tag-table-list):
	Add new variable to control whether etags checks all parent
	directories for tag files. (On by default.)

	* hash-table.el: New file, useful utility functions.
	* dumped-lisp.el (preloaded-file-list): Dump hash-table.el.

2001-05-03  Adrian Aichner  <adrian@xemacs.org>

	* build-report.el: Remove CVS keywords since this file has been in
	core lisp for a while now.
	* build-report.el (build-report-make-output-files): Fix typo.

2001-04-30  Ben Wing  <ben@xemacs.org>

	* printer.el:
	* printer.el (printer-page-header):
	* printer.el (Print-context): New.
	* printer.el (printer-page-footer):
	* printer.el (generate-header-element): New.
	* printer.el (generate-header-line): New.
	* printer.el (print-context-property):
	* printer.el (generic-print-buffer):
	* printer.el (generic-print-region):
	Implement headers and footers.  Implement calling Print dialog box
	(#### but it doesn't quite work yet).

2001-04-28  Ben Wing  <ben@xemacs.org>

	* about.el (xemacs-hackers):
	* about.el (about-url-alist):
	* about.el (about-personal-info):
	* about.el (about-hacker-contribution):
	More contributions.

	* simple.el (handle-post-motion-command):
	Fix spurious setting of zmacs-region-stays to t after a non-shift
	motion command.

	* etags.el (find-tag-internal):
	Sync up with FSF 20.7, to fix bugs handling some etags line formats.

	* gtk-init.el (init-post-gtk-win):
	* msw-init.el (init-post-mswindows-win):
	* x-init.el:
	* x-init.el (x-activate-region-as-selection): Removed.
	* x-init.el (init-post-x-win):
	* keydefs.el (global-map):
	* simple.el:
	* startup.el (command-line):
	* toolbar-items.el:
	* toolbar-items.el (init-x-toolbar-list): Removed.
	* toolbar-items.el (init-toolbar-list): New.
	* toolbar-items.el (init-x-toolbar): Removed.
	* toolbar-items.el (init-toolbar): New.
	* toolbar-items.el (x-init-toolbar-from-resources): Removed.
	* toolbar.el:
	Move non-window-system specific code that was duplicated in
	all window systems into the generic code.

	* gutter.el:
	* gutter.el (init-gutter): Removed. (unused)

	* mouse.el:
	* mouse.el (default-mouse-track-maybe-own-selection):
	* mouse.el (mouse-track-activate-rectangular-selection): New.
	* select.el:
	* select.el (disown-selection):
	* select.el (activate-region-as-selection):
	* select.el (primary-selection-extent):
	* select.el (valid-simple-selection-p):
	Clean up the rectangle code w.r.t. selections.  You'll now get
	the right text copied into the primary selection (but not the
	clipboard yet, unfortunately -- that really requires defining
	our own rectangle type).

2001-04-25  IKEYAMA Tomonori <tomonori@suiyokai.org>

	* faces.el (make-face-bold):
	* faces.el (make-face-italic):
	* faces.el (make-face-bold-italic):
	* faces.el (make-face-unbold):
	* faces.el (make-face-unitalic):
	* faces.el (make-face-smaller):
	* faces.el (make-face-larger):
	Call frob-face-property each for mswindows and msprinter.

2001-04-24  Hrvoje Niksic  <hniksic@arsdigita.com>

	* about.el (about-finish-buffer): Make sure the last change works
	even if EVENT is nil.

2001-04-24  Hrvoje Niksic  <hniksic@arsdigita.com>

	* about.el (about-mailto-link): Use compose-mail for sending mail.
	(about-finish-buffer): Kill/bury the buffer where the user
	clicked, not the one that happens to be the current buffer at the
	time.

2001-04-24  Hrvoje Niksic  <hniksic@arsdigita.com>

	* about.el (about-personal-info): Update my bio.
	(about-hacker-contribution): Ditto.

2001-04-23  Didier Verna  <didier@xemacs.org>

	* cus-edit.el (custom-variable-pre-save): New.
	* cus-edit.el (custom-variable-post-save): New.
	* cus-edit.el (custom-variable-save): use them.
	* cus-edit.el (custom-face-pre-save): New.
	* cus-edit.el (custom-face-post-save): New.
	* cus-edit.el (custom-face-save): use them.
	* cus-edit.el (custom-group-pre-save): New.
	* cus-edit.el (custom-group-post-save): New.
	* cus-edit.el (custom-group-save): use them.
	* cus-edit.el (Custom-save): use the pre/post functions above,
	call `custom-save-all' only once.
	* cus-edit.el (custom-variable-pre-reset-standard): New.
	* cus-edit.el (custom-variable-post-reset-standard): New.
	* cus-edit.el (custom-variable-reset-standard): use them.
	* cus-edit.el (custom-face-pre-reset-standard): New.
	* cus-edit.el (custom-face-post-reset-standard): New.
	* cus-edit.el (custom-face-reset-standard): use them.
	* cus-edit.el (custom-group-pre-reset-standard): New.
	* cus-edit.el (custom-group-post-reset-standard): New.
	* cus-edit.el (Custom-reset-standard): use them.
	* cus-edit.el (custom-face-reset-saved): use the pre/post
	functions above, call `custom-save-all' only once.

2001-04-15  Ben Wing  <ben@xemacs.org>

	* about.el:
	* about.el (about-headline-face): New.
	* about.el (about-link-face): New.
	* about.el (about-current-release-maintainers): New.
	* about.el (about-other-current-hackers): New.
	* about.el (about-once-and-future-hackers): New.
	* about.el (about-lookup-url): New.
	* about.el (about-get-buffer):
	* about.el (about-mailto-link): New.
	* about.el (about-finish-buffer):
	* about.el (about-xemacs):
	* about.el (about-features): Removed.
	* about.el (about-advantages): New.
	* about.el (about-maintainer-info): Removed.
	* about.el (about-personal-info): New.
	* about.el (about-hacker-contribution): New.
	* about.el (about-maintainer):
	* about.el (about-show-linked-info):
	* about.el (about-hackers):
	Major revamping.  Rewriting of most of the text, improve the
	link handling, separate info on contributors into personal
	and contribution info, add new contributors, update personal
	info, etc. etc.

	* menubar-items.el (default-menubar):
	Help menubar entry for News now says more accurately
	"What's New in XEmacs".

	* mouse.el:
	* mouse.el (mouse-track-cleanup-hook):
	* mouse.el (mouse-track):
	Don't set-buffer to a dead buffer when calling mouse-track
	cleanup hooks.

2001-04-18  Didier Verna  <didier@xemacs.org>

	* cus-edit.el (Custom-reset-standard): reset to standard settings
	not only when the buffer's :custom-state is 'modified, but also
	when it is 'set or 'saved.

2001-04-18  Martin Buchholz  <martin@xemacs.org>

	* XEmacs 21.5.0 "alfalfa" is released.

2001-04-17  Didier Verna  <didier@xemacs.org>

	* startup.el (load-user-init-file): define `custom-file' before
	loading the user's init file.

2001-04-02  Jan Vroonhof  <jan.vroonhof@ntlworld.com>

	* dialog.el (make-dialog-box): Disable dialog box titles until
	we get them working.

2001-03-30  Ben Wing  <ben@xemacs.org>

	* help.el:
	* help.el (Help-princ-face):
	* help.el (Help-prin1-face):
	* help.el (frob-help-extents):
	* help.el (describe-function-1):
	* help.el (describe-variable):
	Avoid using font-lock faces, which may not be defined.
	Instead, use hyper-apropos faces, and make sure they're
	defined as necessary by using `require'. (It's not so safe
	to do this for font-lock.) In any case, we will eventually
	be merging this functionality into hyper-apropos.

	* loaddefs.el (completion-ignored-extensions):
	Fix documentation.

	* menubar-items.el (menu-truncate-list): Removed.
	* menubar-items.el (Menubar-items-truncate-list): New.
	* menubar-items.el (default-menubar):
	Fix errors if grep or compile command is too long.  Rename helper
	function to be less visible.

2001-03-23  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el (byte-optimize-minus):
	Fix mis-byte-compilation of (- 0 x) --> (- (- x))

2001-03-26  Hrvoje Niksic  <hniksic@arsdigita.com>

	* dumped-lisp.el (preloaded-file-list): Load mule/latin.el when
	Mule is available.

	* mule/latin.el: New file.

2001-03-11  Ben Wing  <ben@xemacs.org>

	* auto-save.el:
	* auto-save.el (auto-save-directory):
	* auto-save.el (make-auto-save-file-name):
	* auto-save.el (auto-save-file-name-p): New.

	Merge in improvements from other definition of
	make-auto-save-file-name in files.el.

	* auto-save.el (auto-save-original-name):
	* auto-save.el (auto-save-name-in-fixed-directory):
	* auto-save.el (auto-save-unslashify-name): Removed.
	* auto-save.el (auto-save-slashify-name): Removed.
	* auto-save.el (auto-save-reserved-chars): New.
	* auto-save.el (auto-save-escape-name): New.
	* auto-save.el (auto-save-unhex): New.
	* auto-save.el (auto-save-unescape-name): New.

	Change algorithm for encoding filenames in auto-save names to be
	entirely safe with all filesystems and all possible characters in
	a filename, and 100% reversible. (Essentially, uses
	quoted-printable as the encoding.)

	* auto-save.el (recover-all-files):

	Use insert-directory rather than calling ls directly -- fixes
	things under Windows.

	* files.el:
	* files.el (convert-standard-filename): Substitute FSF's
	definition for this (we had nothing here before).

	* files.el (backup-buffer): Warning fix.

	* files.el (make-backup-file-name):
	* files.el (find-backup-file-name):
	Fix error in calling sequence to auto-save-file-name-p.

	* files.el (recover-file):
	Use insert-directory rather than calling ls directly -- fixes
	things under Windows.

	* files.el (make-auto-save-file-name): Removed.
	* files.el (auto-save-file-name-p): Removed.
	auto-save is always dumped so no sense in having a definition
	that will always be overwritten with another.

	* files.el (insert-directory):
	* win32-native.el:
	* win32-native.el (debug-mswindows-process-command-lines):
	* win32-native.el (original-make-auto-save-file-name): Removed.
	* win32-native.el (make-auto-save-file-name): Removed.


2001-03-21  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.46 "Urania" is released.

2001-03-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* menubar-items.el (default-menubar): Update sample.emacs to
	sample.init.el and adjust accelerators.

2001-02-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* build-report.el (build-report): Improve docstring.

2001-03-15  Stephen J. Turnbull  <stephen@xemacs.org>

	* ChangeLog: Log GTK merge.

	* gutter-items.el:
	* mwheel.el:
	* sound.el:
	* startup.el:
	Revert gratuitous whitespace changes.

2001-03-07  Ben Wing  <ben@xemacs.org>

	* help.el:
	* help.el (key-or-menu-binding):
	* help.el (Help-find-file): New.
	* help.el (describe-beta):
	* help.el (describe-copying):
	* help.el (describe-project):
	* help.el (view-emacs-news):
	* help.el (view-sample-init-el): New.
	* help.el (Help-princ-face): New.
	* help.el (Help-prin1-face): New.
	* help.el (help-symbol-function-context-menu):
	* help.el (help-symbol-variable-context-menu):
	* help.el (help-symbol-function-and-variable-context-menu):
	* help.el (frob-help-extents):
	* help.el (describe-function-1):
	* help.el (describe-variable):

	Add coloring in Help buffers, correspondent with hyperlinks.
	View files in view-mode rather than Fundamental.
	Remove separators from context menus -- now handled in generic code.
	Add `Find Tag' to context menu.

	* menubar.el (popup-mode-menu):

	Rewrite code that outputs the popup menu to (a) put more specific
	entries first, (b) be more robust, (c) output the proper context
	menu separators automatically (the context menu functionality is
	new and currently used only by Help).

2001-03-10  William M. Perry  <wmperry@aventail.com>

	* dialog-gtk.el (gtk-make-dialog-box-internal): Forgot to rewrite
	this function when converting from the 21.1 GTK branch.  Now
	supports file, password, question, and color built-in dialogs.

2001-03-06  Ben Wing  <ben@xemacs.org>

	* keydefs.el:
	* keydefs.el (global-map):
	Add commented-out change of M-k (for 21.5).

	* menubar-items.el (default-menubar):
	Fix items to control kill-line behavior; add items for
	shifted motion.

	* simple.el:
	* simple.el (kill-whole-line):
	* simple.el (historical-kill-line): Removed.
	* simple.el (kill-line): Removed.
	* simple.el (kill-entire-line): New.
	* simple.el (kill-line-1): New.
	* simple.el (backward-kill-line):
	Undo kill-whole-line == always changes.  Add new function
	kill-entire-line to unconditionally delete the current line.
	Add comments describing the lamentable state of affairs of
	the kill-line functions and variables.

2001-03-02  Ben Wing  <ben@xemacs.org>

	* simple.el:
	* simple.el (beginning-of-buffer):
	* simple.el (end-of-buffer):
	* simple.el (mark-ring-unrecorded-commands):
	* simple.el (signal-error-on-buffer-boundary):
	* simple.el (shifted-motion-keys-select-region):
	* simple.el (unshifted-motion-keys-deselect-region):
	* simple.el (motion-keys-for-shifted-motion): New.
	* simple.el (handle-pre-motion-command):
	* simple.el (handle-post-motion-command):
	* simple.el (forward-char-command):
	* simple.el (backward-char-command):
	* simple.el (scroll-up-command):
	* simple.el (scroll-down-command):
	* simple.el (next-line):
	* simple.el (previous-line):
	* simple.el (backward-block-of-lines):
	* simple.el (forward-block-of-lines):
	* simple.el (backward-word):
	* simple.el (mark-word):

	Augment documentation of the most common motion commands to make
	note of the shifted-motion support.  Improve the support to (a)
	properly document how it works and why it's done in the fashion it
	is, and (b) allow the keystrokes that trigger it to be customized.

	Correct error in the customize specification of
	mark-ring-unrecorded-commands.

2001-03-02  Ben Wing  <ben@xemacs.org>

	* font-lock.el:
	* font-lock.el (font-lock-pending-extent-table): Removed.
	* font-lock.el (font-lock-pending-buffer-table): New.
	* font-lock.el (font-lock-pre-idle-hook):
	* font-lock.el (font-lock-after-change-function):
	* font-lock.el (font-lock-fontify-pending-extents):
	* font-lock.el (font-lock-lisp-like):

	Fix handling of pending extents to avoid excessive slowness (N^2
	behavior) when making lots of buffer changes between redisplays,
	such as when saving the Options.

2001-03-09  William M. Perry  <wmperry@aventail.com>

	* device.el:
	* dragdrop.el:
	* dumped-lisp.el:
	* faces.el:
	* frame.el:
	* gnuserv.el:
	* loadup.el:
	* menubar-items.el:
	* minibuf.el:
	The Great GTK Merge.

	* ChangeLog.GTK:
	* dialog-gtk.el:
	* gdk.el:
	* generic-widgets.el:
	* glade.el:
	* gnome-widgets.el:
	* gnome.el:
	* gtk-compose.el:
	* gtk-extra.el:
	* gtk-faces.el:
	* gtk-ffi.el:
	* gtk-file-dialog.el:
	* gtk-font-menu.el:
	* gtk-glyphs.el:
	* gtk-init.el:
	* gtk-iso8859-1.el:
	* gtk-marshal.el:
	* gtk-mouse.el:
	* gtk-package.el:
	* gtk-password-dialog.el:
	* gtk-select.el:
	* gtk-widget-accessors.el:
	* gtk-widgets.el:
	* gtk.el:
	widgets-gtk.el:
	The Great GTK Merge: new files.

2001-03-05  Stephen J. Turnbull  <stephen@xemacs.org>

	* generic-widgets.el: Don't require gtk (a built-in feature) at
	top level.  Don't execute the last sexp unless (featurep 'gtk).

2001-02-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/mule-init.el (auto-language-alist): Split zh into GB and BIG5.

2001-02-23  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.45 "Thelxepeia" is released.

2001-01-25  Jason R. Mastaler  <jason@xemacs.org>

        * about.el (xemacs-hackers): update my entry.
        * about.el (about-maintainer-info): ditto.
        * about.el (about-hackers): ditto.

2001-02-20  Jan Vroonhof  <jan@xemacs.org>

	* about.el (about-maintainer-info): More vanity info about
	yours truly.

2001-02-20  Adrian Aichner  <adrian@xemacs.org>

	* build-report.el (build-report-destination): xemacs-build-reports
	has moved to SourceForge, where mailing list name length is
	restricted, hence the name change to
	xemacs-buildreports@xemacs.org.
	* build-report.el (build-report-keep-regexp): Update default.
	* build-report.el (build-report-delete-regexp): Ditto.
	* build-report.el (build-report-make-output-files): Ditto.

2001-02-19  Craig Lanning  <lanning@scra.org>

	* lisp-mode.el: Add indentation specifications for following
	Common Lisp forms: handler-case, handler-bind, with-slots,
	with-open-file, with-open-stream, print-unreadable-object.

2001-02-18  Matt Tucker  <tuck@whistlingfish.net>

	* font-lock.el (font-lock-set-defaults-1):
	Move initialization of `font-lock-cache-position' so that it's set
	even if font-lock-keywords is already defined.

2001-02-17  Matt Tucker  <tuck@whistlingfish.net>

	* autoload.el (generate-file-autoloads-1):
	Use `emacs-lisp-mode-syntax-table' instead of
	`lisp-mode-syntax-table'.
	* lisp-mode.el (lisp-mode-syntax-table):
	Get rid of old checks for `parse-partial-sexp' version.
	Make `|' (pipe) string delimiter instead of punctuation.

2001-02-16  Martin Buchholz  <martin@xemacs.org>

	* window.el (save-selected-window):
	Use gensym for better macro hygiene.

2001-02-06  Mike Sperber <mike@xemacs.org>

	* dump-paths.el:
	* startup.el (startup-setup-paths): Set and use
	`mule-lisp-directory'.
	(startup-setup-paths-warning): Ditto.

	* setup-paths.el (paths-find-mule-lisp-directory): Added.
	(paths-construct-load-path): Consider `mule-lisp-directory'.

2001-02-07  Matt Tucker  <tuck@whistlingfish.net>

	* font-lock.el: Syntax table improvements used.  A few random
	changes are not specified below.
	(font-lock-fontify-string-delimiters):
	(font-lock-syntactic-keywords):
	(font-lock-cache-state nil):
	(font-lock-cache-position):
	New variables.
	(font-lock-set-syntax):
	(font-lock-apply-syntactic-highlight):
	(font-lock-fontify-syntactic-anchored-keywords):
	(font-lock-fontify-syntactic-keywords-region):
	(font-lock-eval-keywords):
	New functions.
	(font-lock-remove-face):
	(font-lock-fontify-syntactically-region):
	Use syntax properties.

2001-02-08  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.44 "Thalia" is released.

2001-01-16  Mike Sperber <mike@xemacs.org>

	* startup.el (normal-top-level): Work even if no installation root
	is found.

2001-01-30  Andy Piper  <andy@xemacs.org>

	* gutter-items.el (progress-abort-glyph): remove instantiator.
	(set-progress-abort-instantiator): new function.
	(abort-progress-feedback): use it.

	* gutter.el (set-gutter-dirty-p): new function.

2001-01-30  Didier Verna  <didier@xemacs.org>

	* mwheel.el (mwheel-scroll): unwind-protect the selected window.

2001-01-24  Didier Verna  <didier@xemacs.org>

	* sound.el (sound-extension-list): give a better default value.
	* sound.el (load-sound-file): improve the doc string, also find
	files given by absolute names, pass a real extension list to
	`locate-file'.

2001-01-26  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.43 "Terspichore" is released.

2001-01-20  Klaus Frank <klausf@i3.informatik.rwth-aachen.de>

	* gnuserv.el (gnuserv-process-filter): Robuster handling of error
	messages from gnuserv.

2001-01-20  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.42 "Poseidon" is released.

2001-01-12  Andy Piper  <andy@xemacs.org>

	* package-get.el (package-get-custom): call
	package-net-update-installed-db.

	* package-ui.el (pui-install-selected-packages): call
	package-net-update-installed-db.

	* package-net.el (package-net-update-installed-db): use
	packages-package-list so that we reflect reality.

	* packages.el (packages-package-list): Make docstring reflect
	reality.

	* package-net.el (package-net-convert-index-to-ini): exclude mule entries.

	* postinstall.cc (do_postinstall): don't pick up shells if cygwin
	isn't installed.

2001-01-17  Andy Piper  <andy@xemacs.org>

	* wid-edit.el (widget-activation-glyph-mapper): activate or
	deactivate native widgets.
	(widget-glyph-insert-glyph): record instantiator.
	(widget-push-button-value-create): use it.

	* gui.el (gui-button-action): new function. Make button's domain
	buffer current when calling.
	(make-gui-button): update to use gui-button-action.

2001-01-16  Didier Verna  <didier@xemacs.org>

	* menubar-items.el (default-menubar): add an entry for modeline
	horizontal scrolling in Options -> Display.

2001-01-17  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-require-signed-base): Set to nil
	by default.

2001-01-17  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.41 "Polyhymnia" is released.

2001-01-16  Mike Sperber <mike@xemacs.org>

	* setup-paths.el (paths-core-load-path-depth): Stopgap bump to
	catch lisp/mule/.

2001-01-14  Mike Sperber <mike@xemacs.org>

	* startup.el (maybe-create-compatibility-dot-emacs):
	(maybe-unmigrate-user-init-file):
	(unmigrate-user-init-file): Created.
	(maybe-migrate-user-init-file): Offer creation of compatibility
	.emacs.
	Some doc fixes wrt init file location.

2001-01-15  Golubev I. N.  <gin@mo.msk.ru>

	* faces.el (face-frob-from-locale-first): new variable.
	(frob-face-font-2): Honor tags arg while trying to use
	standard-face-mapping.  When face-frob-from-locale-first is set,
	first try to set face inheriting from frobbed-face.

2001-01-15  Didier Verna  <didier@xemacs.org>

	* about.el (xemacs-hackers): update my entry.
	* about.el (about-url-alist): ditto.
	* about.el (about-maintainer-info): ditto.
	* about.el (about-hackers): ditto.

2001-01-15  Martin Buchholz  <martin@xemacs.org>

	The byte compiler has been badly broken for a year,
	by the patch of 1999-12-06.
	* byte-optimize.el (byte-optimize-form-code-walker):
	Bug was: the byte compiler was making this erroneous optimization:
	(progn (or (foo)) (bar)) ==> (bar)

2000-11-20  Mike Sperber <mike@xemacs.org>

	* setup-paths.el (paths-core-load-path-depth): Split
	`paths-load-path-depth' in two for site and core lisp.  Don't
	recurse into core.
	* setup-paths.el (paths-construct-load-path): Use.

2001-01-10  Andy Piper  <andy@xemacs.org>

	* package-net.el (package-net-cygwin32-binary-size): new variable
	(package-net-win32-binary-size): ditto.  add much needed
	commentary.

	* gutter-items.el (buffers-tab-items): correct off-by-one error
	for buffers-tab-max-size.

2001-01-08  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.40 is released.

2001-01-06  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/hebrew.el: Fix comments and typos.
	mule/japanese.el: Fix comments, typos, and 8-bit character encoding.

2001-01-06  Stephen J. Turnbull  <stephen@xemacs.org>

	* ChangeLog.1: move ancient log from fill.el.

	* dump-paths.el:
	paragraphs.el:
	mule/mule-category.el:
	Miscellaneous typo fixes and slight doc clarifications.

	* mule/mule-ccl.el:  Correct file name in header.

2000-12-31  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.39 is released.

2000-12-27  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el (byte-optimize-cond):
	(byte-optimize-cond-1): New.
	Rewrite `cond' in terms of `if' and `or', which are easier to optimize.
	Optimizes (cond (x nil)) ==> nil.
	Provide better diagnostic on malformed expr like (cond foo).

2000-12-20  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/mule-coding.el:
	mule/mule-cmds.el (reset-language-environment,
	set-language-environment-coding-systems):
	Safer default coding-priority-list, corresponding to src/file-coding.h.

2000-12-03  Jorma Laaksonen <jorma.laaksonen@hut.fi>

	* package-admin.el: Allow package removal from
	early-package-load-path.

2000-12-15  Andreas Jaeger  <aj@suse.de>

	* about.el (about-maintainer-info): Update my entry.

2000-12-11  Matt Tucker  <tuck@whistlingfish.net>

	* packages.el (locate-library): Add support for bzip2
	compressed .el files.

2000-12-12  Andy Piper  <andy@xemacs.org>

	* package-net.el: new file.

2000-12-01  Enrico Scholz  <enrico.scholz@informatik.tu-chemnitz.de>

	* font-lock.el: Add missing C++ keywords.

2000-12-08  Adrian Aichner  <adrian@xemacs.org>

	* simple.el (indent-for-comment): Preserve indentation of comments
	starting in column 0, as documented in (Info-goto-node
	"(xemacs)Comments").  Update docstring accordingly.

2000-12-05  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.38 is released.

2000-12-04  Didier Verna  <didier@xemacs.org>

	* mouse.el (default-mouse-track-set-point-in-window): remove
	spurious '+' operation detected by Martin.


2000-12-01  Martin Buchholz  <martin@xemacs.org>

	* cl-extra.el (coerce):
	Implement char to integer coercion.
	Remove extraneous (numberp) test.

	* byte-optimize.el (byte-compile-splice-in-already-compiled-code):
	Perform lapcode inlining if the value of `byte-optimize' is 'byte.
	(byte-optimize-predicate):
	Warn if evaluating constant expression signals an error.
	(byte-optimize-form): Small simplification.

	* cl-macs.el (cl-do-proclaim): small efficiency improvement.

2000-11-30  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el:
	(byte-optimize-minus):
	(byte-optimize-plus):
	(byte-optimize-mult):
	(byte-optimize-quo):
	Use (car (last x)) instead of (last x) to get last elt!
	Use `byte-optimize-predicate' to optimize `%'.
	Move optimizations for special numeric args to bytecomp.el.
	* bytecomp.el (byte-compile-associative): Remove.
	(byte-compile-max): New.
	(byte-compile-min): New.
	Properly handle erroneous calls: (max) (min).
	(byte-compile-plus): New.
	(byte-compile-minus):
	It's easiest to handle 0, +1 and -1 args here.
	(byte-compile-mult): New.
	It's easiest to handle 1, -1 and 2 args here.
	(byte-compile-quo):
	It's easiest to handle 0, +1 and -1 args here.
	Issue byte-compiler warning when dividing by zero.

	Byte-compiler arithmetic improvements.
	Better optimize these expressions in the obvious way:
	(+ x y 1)   -->  varref x varref y add add1
	(+ x y -1)  -->  varref x varref y add sub1
	(- x y 0)   -->  (- x y)
	(- 0 x y)   -->  (- (- x) y)
	(% 42 19)   --> compile-time constant
	(/ 42 19)   --> compile-time constant
	(* (foo) 2) --> foo call dup plus

	Optimize away arithmetic operations (+ x) (* x) (/ x 1)
	unless (declaim (optimize (safety 3)))
	or (setq byte-compile-delete-errors nil).

2000-11-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* paragraphs.el (paragraph-separate, forward-sentence):  Clarify
	docstrings.

2000-11-08  Stephen J. Turnbull  <stephen@xemacs.org>

	* startup.el (command-line-do-help):  Add documentation of
	portable dumper switches.

2000-11-22  Andy Piper  <andy@xemacs.org>

	* x-mouse.el (x-init-pointer-shape): use cursor-font explicitly.

	* glyphs.el (init-glyphs): don't use autodetect for strings.

2000-11-28  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el (byte-optimize-char-before):
	(byte-optimize-backward-char):
	(byte-optimize-backward-word):
	Fix incorrect optimizations for these sorts of expressions:
	(let ((x nil)) (backward-char x))

2000-11-21  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el:
	* byte-optimize.el (byte-optimize-backward-char): New.
	* byte-optimize.el (byte-optimize-backward-word): New.
	Make backward-word and backward-char as efficient as forward versions.

	* bytecomp.el (byte-compile-no-args-with-one-extra):
	* bytecomp.el (byte-compile-one-arg-with-one-extra):
	* bytecomp.el (byte-compile-two-args-with-one-extra):
	* bytecomp.el (byte-compile-zero-or-one-arg-with-one-extra):
	* bytecomp.el (byte-compile-one-or-two-args-with-one-extra):
	* bytecomp.el (byte-compile-two-or-three-args-with-one-extra):
	Check if extra arg is constant nil, and if so, use byte-coded call.

	* simple.el (backward-word):
	* simple.el (mark-word):
	* simple.el (kill-word):
	* simple.el (backward-kill-word):
	Make COUNT argument optional, for consistency with forward-char et al.

	* abbrev.el (abbrev-string-to-be-defined):
	* abbrev.el (inverse-abbrev-string-to-be-defined):
	* abbrev.el (inverse-add-abbrev):
	* abbrev.el (expand-region-abbrevs):
	* buff-menu.el (Buffer-menu-execute):
	* indent.el (move-to-left-margin):
	* indent.el (indent-relative):
	* indent.el (move-to-tab-stop):
	* info.el (Info-reannotate-node):
	* lisp-mode.el (lisp-indent-line):
	* lisp.el (end-of-defun):
	* lisp.el (move-past-close-and-reindent):
	* misc.el (copy-from-above-command):
	* mouse.el (default-mouse-track-scroll-and-set-point):
	* page.el (forward-page):
	* paragraphs.el (forward-paragraph):
	* paragraphs.el (end-of-paragraph-text):
	* picture.el (picture-forward-column):
	* picture.el (picture-self-insert):
	* rect.el (extract-rectangle-line):
	* simple.el (newline):
	* simple.el (fixup-whitespace):
	* simple.el (backward-delete-char-untabify):
	* simple.el (transpose-chars):
	* simple.el (transpose-preceding-chars):
	* simple.el (do-auto-fill):
	* simple.el (indent-new-comment-line):
	* simple.el (blink-matching-open):
	* view-less.el (cleanup-backspaces):
	* wid-edit.el (widget-transpose-chars):
	* term/bg-mouse.el (bg-insert-moused-sexp):
	Use more readable (backward-FOO n) instead of (forward-FOO -n).

	* info.el (Info-fontify-node):
	* simple.el (backward-delete-function):
	Use canonical delete-backward-char instead of backward-delete-char.

2000-11-20  Andy Piper  <andy@xemacs.org>

	* gutter-items.el (update-tab-in-gutter): don't barf if there are
	no buffers.

2000-11-20  Andy Piper  <andy@xemacs.org>

	* gutter-items.el (update-tab-in-gutter): don't give popup frames
	buffer tabs.

2000-11-18  Martin Buchholz  <martin@xemacs.org>

	* cl-macs.el: Correctly optimize plusp minusp oddp evenp.
	(proclaim inline...) was shadowing compiler-macros.

2000-11-17  Martin Buchholz  <martin@xemacs.org>

	* bytecomp.el (byte-compile-eval): New.
	(byte-compile-initial-macro-environment): Use byte-compile-eval.
	Keeps this promise made in Lispref:
	"If a file being compiled contains a `defmacro' form, the macro is
	defined temporarily for the rest of the compilation of that file."

2000-11-09  Martin Buchholz  <martin@xemacs.org>

	* cl.el (floatp-safe):
	(plusp):
	(minusp):
	(oddp):
	(evenp):
	(cl-abs):
	Use a better parameter name than `x'.

	* cl-macs.el (check-type): Make continuable.  Change documentation
	to require PLACE, but accept any form for compatibility.

	* abbrev.el (define-abbrev): Use check-type.
	* font-menu.el (font-menu-change-face): Use check-type.
	* menubar.el (relabel-menu-item): Use check-type.
	* itimer.el: Fix typo.

2000-11-10  Yoshiki Hayashi  <yoshiki@xemacs.org>

	* info.el (Info-extract-menu-node-name): Comma is a delimiter.

2000-11-14  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.37 is released.

2000-11-13  Katsumi Yamaoka  <yamaoka@jpl.org>

	* code-cmds.el: Provide the feature.

2000-07-21  Jan Vroonhof  <jan@xemacs.org>

	* dumped-lisp.el (preloaded-file-list): Load code-cmds.el

	* code-cmds.el: New file
	* mule/mule-cmds.el:
	* mule/mule-misc.el
	(coding-keymap): New keymap. Define coding system keyboard
	commands on file-coding builds too.
	(coding-system-change-eol-conversion):
	(universal-coding-system-argument):
	(set-default-coding-systems):
	(prefer-coding-system): Moved from mule-cmds.el
	(set-buffer-process-coding-system): Moved from mule-misc.el

2000-09-15  Stephen Carney <carney@scubadoo.com>

	* etags.el (buffer-tag-table-files): Use append instead of nconc.

2000-11-09  Steve Youngs  <youngs@xemacs.org>

	* package-get.el (package-get-download-sites): Add a pre-release
	site for experimental packages.

	* auto-autoloads.el: Regenerated.

2000-08-01  Andy Piper  <andy@xemacs.org>

	* gutter-items.el (buffers-tab-omit-function): reference
	buffers-tab-select-visible-buffers.
	(buffers-tab-filter-functions): new variable, by default uses
	buffers-tab-selection-function and buffers-tab-omit-function.
	(select-buffers-tab-buffers-by-mode): invert arguments.
	(buffers-tab-select-visible-buffers): new function. Invert calling
	of buffers-menu-omit-invisible-buffers.
	(buffers-tab-items): rewrite to use
	buffers-tab-filter-functions. Rewrite docstring.
	(gutter-buffers-tab-extent): delete.
	(add-tab-to-gutter): always build a new extent when adding the
	tabs.
	(update-tab-in-gutter): make gutter dirty when orientation
	changes.

2000-11-07  Martin Buchholz  <martin@xemacs.org>

	* bytecomp.el (byte-compile-defvar-or-defconst):
	Only do loadhist recording if defvar form includes a value.

2000-11-02  Martin Buchholz  <martin@xemacs.org>

	* bytecomp.el (byte-compile-initial-macro-environment):
	`eval-when-compile' should not compile its body.

2000-11-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/cyrillic.el: Add Windows 1251 code page encoding (by
	Sergey Groznyh <gsm@fct.ru> in <863diqaygu.fsf@fct.ru>).  Fix
	some Japanese English.	Remove some ancient FSF comments, and
	improve docstrings.  Use symbols not vectors for tables.

2000-11-03  Martin Buchholz  <martin@xemacs.org>

	* keymap.el:
	(local-key-binding):
	(global-key-binding):
	Add an optional `accept-defaults' parameter, just like `lookup-key'.

	* lisp.el:
	(backward-sexp): Slightly simpler code.
	(mark-sexp): Make arg optional, like FSF Emacs.
	(forward-list): Slightly simpler code.
	(backward-list): Slightly simpler code.
	(down-list):  Make arg optional, like FSF Emacs.
	(up-list):  Make arg optional, like FSF Emacs.
	(backward-up-list):  Make arg optional, like FSF Emacs.
	(kill-sexp):  Make arg optional, like FSF Emacs.
	(backward-kill-sexp):  Make arg optional, like FSF Emacs.

	* font-menu.el (font-menu-change-face):
	Take continuable errors into account.

	* abbrev.el:
	* abbrev.el (clear-abbrev-table):
	* abbrev.el (define-abbrev-table):
	* abbrev.el (define-abbrev):
	* abbrev.el (insert-abbrev-table-description):
	* apropos.el (apropos-documentation-check-doc-file):
	* apropos.el (apropos-documentation-check-elc-file):
	* buff-menu.el (list-buffers):
	* buff-menu.el (list-buffers-noselect):
	* bytecomp.el (byte-recompile-directory):
	* bytecomp.el (batch-byte-compile):
	* cl-macs.el (typep):
	* code-files.el (find-coding-system-magic-cookie):
	* code-files.el (insert-file-contents):
	* cus-edit.el (customize-set-variable):
	* cus-edit.el (customize-save-variable):
	* cus-face.el (custom-set-face-font-size):
	* cus-face.el (custom-set-face-update-spec):
	* cus-face.el (custom-reset-faces):
	* custom.el (custom-check-theme):
	* custom.el (copy-upto-last):
	* fill.el (canonically-space-region):
	* fill.el (fill-paragraph):
	* fill.el (fill-region):
	* fill.el (find-space-insertable-point):
	* fill.el (justify-current-line):
	* faces.el (face-spec-update-all-matching):
	* faces.el (set-face-stipple):
	* files-nomule.el (insert-file-contents):
	* files.el (insert-file-contents-literally):
	* files.el (hack-local-variables-last-page):
	* files.el (basic-save-buffer):
	* files.el (insert-directory):
	* font-menu.el (font-menu-change-face):
	* font.el (font-spatial-to-canonical):
	* format.el (format-encode-region):
	* format.el (format-insert-file):
	* format.el (format-replace-strings):
	* gutter.el (set-gutter-element):
	* help.el (key-or-menu-binding):
	* help.el (describe-bindings):
	* help.el (with-syntax-table):
	* indent.el (indent-rigidly):
	* indent.el (delete-to-left-margin):
	* info.el:
	* info.el (Info-extract-dir-entry-from):
	* info.el (Info-build-dir-anew):
	* info.el (Info-rebuild-dir):
	* info.el (Info-batch-rebuild-dir):
	* info.el (Info-read-subfile):
	* info.el (Info-build-node-completions):
	* info.el (Info-extract-menu-node-name):
	* isearch-mode.el (isearch-range-invisible):
	* isearch-mode.el (isearch-restore-invisible-extents):
	* itimer.el (itimerp):
	* itimer.el (itimer-live-p):
	* keymap.el:
	* keymap.el (substitute-key-definition):
	* keymap.el (read-command-or-command-sexp):
	* keymap.el (local-key-binding):
	* keymap.el (global-key-binding):
	* keymap.el (global-set-key):
	* keymap.el (local-set-key):
	* ldap.el:
	* ldap.el (ldap-add-entries):
	* ldap.el (ldap-delete-entries):
	* lisp.el (backward-sexp):
	* lisp.el (mark-sexp):
	* lisp.el (forward-list):
	* lisp.el (backward-list):
	* lisp.el (down-list):
	* lisp.el (backward-up-list):
	* lisp.el (up-list):
	* lisp.el (kill-sexp):
	* lisp.el (backward-kill-sexp):
	* menubar.el (add-menu-button):
	* menubar.el (add-submenu):
	* menubar.el (delete-menu-item):
	* menubar.el (relabel-menu-item):
	* mouse.el (narrow-window-to-region):
	* obsolete.el (define-obsolete-variable-alias):
	* obsolete.el (store-substring):
	* package-admin.el:
	* package-admin.el (package-admin-install-function):
	* package-admin.el (package-admin-install-function-mswindows):
	* package-admin.el (package-admin-default-install-function):
	* package-get.el (package-get-update-base-entries):
	* packages.el (packages-load-package-dumped-lisps):
	* packages.el (packages-collect-package-dumped-lisps):
	* printer.el (generic-print-buffer):
	* printer.el (generic-print-region):
	* replace.el (occur-mode-mouse-goto):
	* replace.el (perform-replace):
	* select.el (get-selection-no-error):
	* simple.el:
	* simple.el (newline):
	* simple.el (open-line):
	* simple.el (edit-and-eval-command):
	* simple.el (goto-line):
	* simple.el (undo):
	* simple.el (kill-region):
	* simple.el (copy-region-as-kill):
	* simple.el (kill-ring-save):
	* simple.el (set-mark):
	* simple.el (next-line):
	* simple.el (previous-line):
	* simple.el (line-move):
	* simple.el (set-goal-column):
	* simple.el (comment-region):
	* subr.el:
	* subr.el (putf):
	* syntax.el (modify-syntax-entry):
	* syntax.el (map-syntax-table):
	* view-less.el (view-file):
	* view-less.el (view-buffer):
	* view-less.el (view-file-other-window):
	* window-xemacs.el (backward-other-window):
	* window.el:
	* window.el (one-window-p):
	* window.el (walk-windows):
	* window.el (window-list):
	* x-mouse.el (x-mouse-kill):
	* x-select.el (x-get-cutbuffer):
	* x-select.el (x-store-cutbuffer):
	* term/bg-mouse.el (bg-mouse-line-to-center):
	* term/sun-mouse.el (window-line-end):
	* term/sun-mouse.el (sun-select-region):
	* term/sun.el (kill-region-and-unmark):
	* mule/mule-category.el:
	* mule/mule-category.el (modify-category-entry):
	* mule/mule-category.el (char-category-list):
	* mule/mule-coding.el (coding-system-force-on-output):
	* mule/mule-misc.el (coding-system-put):
	Docstring arglist/Texinfo fixes.  See man/ChangeLog for details.

2000-11-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* cus-face.el: Typo fixes and tiny clarifications.
	* custom.el: ditto

2000-10-27  Yoshiki Hayashi  <yoshiki@xemacs.org>

	* startup.el (auto-save-list-file-prefix): Moved to fileio.c.
	* startup.el (normal-top-level): Setup auto-save-list-file-name
	if auto-save-list-file-prefix is non-nil.

2000-10-25  Yoshiki Hayashi  <yoshiki@xemacs.org>

	* files.el (auto-mode-alist): Allow mixed case suffix for idlwave-mode.

2000-01-05  Yoshiki Hayashi  <t90553@mail.ecc.u-tokyo.ac.jp>

	* hyper-apropos.el (hyper-apropos-this-symbol): Don't always
	get symbol at point-min.

2000-10-24  Didier Verna  <didier@xemacs.org>

	* info.el (Info-emacs-info-file-name): defconst it.
	* info.el (Info-footnote-tag): defcustom it.
	* info.el (Info-no-description-string): ditto.
	* info.el (Info-find-node): adapt to new semantics of
	'Info-suffixed-file (don't do the case variants stuff).
	* info.el (Info-insert-dir): rewrite the dir file variants code.
	* info.el (Info-directory-files): New. Return the list of info
	files in a directory.
	* info.el (Info-dir-outdated-p): use it.
	* info.el (Info-parse-dir-entries): ditto.
	* info.el (Info-build-dir-anew): don't restrict to files ending
	with a ".info.*" extension.
	* info.el (Info-set-mode-line): ditto.
	* info.el (Info-read-subfile): adapt to new semantics of
	'Info-suffixed-file (append 'exact argument).
	* info.el (Info-all-case-regexp): New. Return a regexp matching a
	string independently of the case.
	* info.el (Info-suffixed-file): use it (match all possible case
	for the file name).
	* info.el (Info-insert-file-contents): code cleanup.
	* info.el (Info-rebuild-dir): cosmetics only. Fit code in 80
	columns.
	* info.el (Info-batch-rebuild-dir): ditto.
	* info.el (Info-read-node-name-1): ditto.
	* info.el (Info-search): ditto.
	* info.el (Info-fontify-node): ditto.


2000-10-24  Didier Verna  <didier@xemacs.org>

	* process.el (shell-command): when called from a program, avoid
	'push-mark's "mark-set" message.

2000-10-15  MIYASHITA Hisashi  <himi@m17n.org>

	* mule/thai-xtis.el (tis-620): Specify coding-system's ccl-program
	by a symbol, not by a vector.
	* mule/vietnamese.el (vscii): Likewise.
	(viscii): Likewise.
	* mule/cyrillic.el (koi8-r): Likewise.

	* mule/chinese.el (chinese-big5-1): Specify charset's ccl-program
	by a symbol, not by a vector.
	(chinese-big5-2): Likewise.
	* mule/ethiopic.el (ethiopic): Likewise.
	* mule/vietnamese.el (vietnamese-viscii-lower): Likewise.
	(vietnamese-viscii-upper): Likewise.

2000-10-12  Yoshiki Hayashi  <yoshiki@xemacs.org>

	* files.el (auto-mode-alist): Remove obsolete entry for html3-mode.

2000-10-13  Yoshiki Hayashi  <yoshiki@xemacs.org>

	* byte-optimize.el (byte-optimize-car): New function.
	(byte-optimize-cdr): Ditto.

2000-10-12  Yoshiki Hayashi  <yoshiki@xemacs.org>

	* byte-optimize.el: Partial synch with FSF 20.7.
	Optimize constant concatenation.
	Add keymapp as a side effect free function.  It is a built-in.
	(byte-after-unbind-pos): Remove byte-equal.

2000-10-13  Gunnar Evermann  <ge204@eng.cam.ac.uk>

	* update-elc-2.el: Quote regexps correctly.

2000-10-05  MIYASHITA Hisashi  <himi@m17n.org>

	* mule/mule-ccl.el: Sync up with Emacs 21.0.90.
	(ccl-compile): Apply integerp, not integer-or-char-p to
	check the type of the buffer magnification
	(ccl-compile-write-string): Encode a string with binary
	coding system.
	(ccl-compile-write-repeat): Likewise.

2000-09-25  Robert Pluim  <rpluim@bigfoot.com>

	* buff-menu.el:
	* bytecomp.el:
	* coding.el:
	* faces.el:
	* files.el:
	* fill.el:
	* float-sup.el:
	* font-lock.el:
	* help.el:
	* iso8859-1.el:
	* loaddefs.el:
	* menubar-items.el:
	* menubar.el:
	* modeline.el:
	* msw-font-menu.el:
	* paragraphs.el:
	* paths.el:
	* replace.el:
	* simple.el:
	* sound.el:
	* startup.el:
	* version.el:
	* x-faces.el:
	* x-font-menu.el:
	Remove purecopy.

2000-10-03  Daniel Pittman  <daniel@rimspace.net>

	* simple.el (do-auto-fill): Use the function pointer to by
	`comment-line-break-function', not `indent-new-comment-line'. This
	fixes an issue with cc-mode comment continuation.

2000-10-11  Martin Buchholz  <martin@xemacs.org>

	* simple.el (turn-on-auto-fill):  Add (interactive).
	* mwheel.el (mwheel-install): Add (interactive).
	* font-lock.el (turn-on-font-lock): Add (interactive).
	(turn-off-font-lock): Add (interactive).

2000-10-03  Karl M. Hegbloom  <karlheg@bittersweet.inetarena.com>

	* packages.el (packages-special-base-regexp): Add `man'.

2000-10-08  Adrian Aichner  <adrian@xemacs.org>

	* wid-edit.el (widget-specify-active): map over extents in current
	buffer like `widget-specify-inactive' does.  Mapping over the
	inactive extent object does not work since the current extent is
	ignored by `map-extents'.

2000-10-04  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.36 is released.

2000-09-22  Martin Buchholz  <martin@xemacs.org>

	* byte-optimize.el (byte-optimize-lapcode): Add an optimizer pass.
	Optimize the compiled-function-constants vector by byte-code
	reference counts.

2000-09-25  Robert Pluim  <rpluim@bigfoot.com>

	* build-report.el (build-report-delete-regexp): quote value in
	defcustom

2000-09-24  Adrian Aichner  <aichner@ecf.teradyne.com>

	* build-report.el (build-report): Don't bind srcdir which we don't
	use in `multiple-value-bind' to avoid the only byte-compiler
	warning.

2000-09-23  Adrian Aichner  <aichner@ecf.teradyne.com>

	* build-report.el: Requires cl and custom now.
	build-report-version is determined by XEmacs version -- remove
	build-report-version*.
	* build-report.el (build-report-version): Removed.
